dnl aclocal.m4 generated automatically by aclocal 1.4a

dnl Copyright (C) 1994, 1995-8, 1999 Free Software Foundation, Inc.
dnl This file is free software; the Free Software Foundation
dnl gives unlimited permission to copy and/or distribute it,
dnl with or without modifications, as long as this notice is preserved.

dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY, to the extent permitted by law; without
dnl even the implied warranty of MERCHANTABILITY or FITNESS FOR A
dnl PARTICULAR PURPOSE.


dnl
dnl prft ob mmap(MAP_WRITE|MAP_SHARED) broken ist.
dnl
AC_DEFUN(tom_MMAP_BROKEN,
[
	AC_REQUIRE([AC_FUNC_MMAP])
	if test $ac_cv_func_mmap_fixed_mapped = yes ; then
		AC_MSG_CHECKING([whether mmap(MAP_WRITE|MAP_SHARED) is broken])
		AC_CACHE_VAL(tom_cv_mmap_broken,
		AC_TRY_RUN([
			#include    <sys/types.h>
			#include    <sys/stat.h>
			#include    <sys/mman.h>    /* mmap() */
			#include    <unistd.h>
			#include    <fcntl.h>
			int main(void) {
				void *cad;
				struct stat st;
				int fd;
				fd = open("conftest.tmp22", O_RDWR | O_CREAT | O_TRUNC,  
					(S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH) );
				if (fd<0) {
					write(2,"can't open testfile\n",20);
					exit(1);
				}
				if (write(fd,"123456",6)!=6) {
					write(2,"cannot write\n",12);
					exit(1);
				}
				if (-1==fstat(fd,&st)) {
					write(2,"cannot fstat\n",12);
					exit(1);
				}
				cad = mmap(0, st.st_size, PROT_READ, MAP_FILE | MAP_SHARED, fd, 0);
				unlink("conftest.tmp22");
				if (cad == (caddr_t) -1) {
					write(2,"addr==-1\n",9);
					exit(1);
				}
				if (memcmp(cad,"123456",6)) {
					write(2,"memcmp failed\n",14);
					exit(1);
				}
				exit(0);
			}
		],tom_cv_mmap_broken=no,tom_cv_mmap_broken=yes
		,[AC_MSG_WARN([considering mmap(MAP_SHARED) as broken])
		tom_cv_mmap_broken=yes] ))dnl end of try_run and cache_val
		AC_MSG_RESULT($tom_cv_mmap_broken)
		if test $tom_cv_mmap_broken = yes; then
			AC_DEFINE(HALF_MMAP)
			AC_SUBST(HALF_MMAP)
		fi

	fi
]) dnl Ende von tom_MMAP_BROKEN

dnl
dnl tom_STRUCT_ST_ATTR: does struct stat.st_attr exist?
dnl
AC_DEFUN(tom_STRUCT_ST_ATTR,
[
	AC_MSG_CHECKING([checking for st_attr])

	AC_CACHE_VAL(tom_cv_stat_st_attr,[
	AC_EGREP_HEADER(st_attr,sys/stat.h,
	tom_cv_stat_st_attr=yes,tom_cv_stat_st_attr=no)])

	AC_MSG_RESULT($tom_cv_stat_st_attr)
	if test $tom_cv_stat_st_attr = yes; then
		AC_DEFINE(HAVE_ST_ATTR)
	fi
	AC_SUBST(HAVE_ST_ATTR)
]) dnl Ende von tom_STRUCT_ST_ATTR

dnl tom_TYPE_SIGHANDLER_T(DEFAULT)
dnl defines HAVE_SIGHANDLER_T if sighandler_t is found
AC_DEFUN(tom_TYPE_SIGHANDLER_T,
[
AC_MSG_CHECKING(for sighandler_t)
AC_CACHE_VAL(ac_cv_type_$1,
[AC_EGREP_CPP($1, [#include <signal.h>], 
ac_cv_type_sighandler_t=yes, ac_cv_type_sighandler_t=no)])dnl
AC_MSG_RESULT($ac_cv_type_sighandler_t)
if test $ac_cv_type_sighandler_t = yes; then
  AC_DEFINE(HAVE_SIGHANDLER_T)
fi
]) dnl Ende von tom_TYPE_SIGHANDLER_T

dnl
dnl prft ob tgetent(0,name) funktioniert.
dnl
AC_DEFUN(tom_TGETENT_NULL,
[
	AC_MSG_CHECKING([whether tgetent(0,...) works])
	AC_CACHE_VAL(tom_cv_tgetent_null,
	AC_TRY_RUN([
		int main(void) {
			(void) tgetent(0,"vt100");
			exit(0);
			}
		],tom_cv_tgetent_null=yes,tom_cv_tgetent_null=no
		,[AC_MSG_WARN([considering tgetent(0,name) as broken])
	tom_cv_tgetent_null=no] ))dnl end of try_run and cache_val
	AC_MSG_RESULT($tom_cv_tgetent_null)
	if test $tom_cv_tgetent_null = yes; then
		AC_DEFINE(TGETENT_NULL)
		AC_SUBST(TGETENT_NULL)
	fi
]) dnl Ende von tom_MMAP_BROKEN

dnl AC_CHECK_TYPE_INCLUDE(TYPE, DEFAULT, INCLUDE)
AC_DEFUN(AC_CHECK_TYPE_INCLUDE,
[AC_REQUIRE([AC_HEADER_STDC])dnl
AC_MSG_CHECKING(for $1)
AC_CACHE_VAL(ac_cv_type_$1,
[AC_EGREP_CPP($1, [#include <sys/types.h>
$3
#if STDC_HEADERS
#include <stdlib.h>
#endif], ac_cv_type_$1=yes, ac_cv_type_$1=no)])dnl
AC_MSG_RESULT($ac_cv_type_$1)
if test $ac_cv_type_$1 = no; then
  AC_DEFINE($1, $2)
  fi
])

dnl
dnl prft ob DOS-hnlich organisierte Laufwerke vorliegen.
dnl das ist nur ein Dummytest (obwohl prinzipiell funktionsfhig) - auf 
dnl den Kisten wird configure wohl nicht laufen.
dnl
AC_DEFUN(tom_DOSDRIVES,
[
	AC_MSG_CHECKING([lack of unified filesystem])
	AC_CACHE_VAL(tom_cv_dosdrives,[
		if test "$cross_compiling" = "yes" ; then
			case `echo $host_os | tr A-Z a-z` in
			*os2*) tom_cv_dosdrives=yes ;;
			*msdos*|*msdog*|*dummdos*) tom_cv_dosdrives=yes ;;
			*magic*) tom_cv_dosdrives=yes ;;
			*unix*|*sunos*|*solaris*|*linux*|*bsd*|*mint*) tom_cv_dosdrives=no ;;
			*) AC_MSG_WARN([do not know about your system, filesys assumed]) 
				tom_cv_dosdrives=no ;;
			esac
		else
			case `pwd` in
			/*) tom_cv_dosdrives=no ;;
			?:*) tom_cv_dosdrives=yes ;;
			esac
		fi
	])
	AC_MSG_RESULT($tom_cv_dosdrives)
	if test "$tom_cv_dosdrives" = yes; then
		AC_DEFINE(HAVE_DOSDRIVES)
		AC_SUBST(HAVE_DOSDRIVES)
	fi
]) dnl Ende von tom_DOSDRIVES

dnl
dnl prft auf funktionierende Terminallibraries. Geklaut von less-278.
dnl
AC_DEFUN(tom_TERMLIBS,
[
	TERMLIBS=
	tom_found_ncurses=
	tom_found_curses=
	tom_found_termlib=

	AC_CHECK_LIB(pc, puttext, [TERMLIBS="-lpc"])
	OLDLIBS="$LIBS"

	AC_CHECKING([for working terminal libraries])
	AC_CHECK_LIB(curses, initscr, [tom_found_curses=1],,$TERMLIBS)
	AC_CHECK_LIB(ncurses, initscr, [tom_found_ncurses=1],,$TERMLIBS)
	AC_CHECK_LIB(termlib, tgetent, [tom_found_termlib=1], [have_termlib=no])

	if test "x$tom_found_ncurses" = x ; then
		if test "x$tom_found_curses" = x ; then
			if test "x$tom_found_termlib" = x ; then
				AC_MSG_WARN([Can't find any terminal library.])
			else
				TERMLIBS="-ltermlib";
			fi
		else
			TERMLIBS="-lcurses";
		fi
		:
	else
		TERMLIBS="-lncurses";
	fi

	AC_CACHE_VAL(tom_cv_termlibs,[
		LIBS="$LIBS $TERMLIBS"
		AC_TRY_LINK(, [tgetent(0); tgetflag(0); tgetnum(0); tgetstr(0);],
			[termok=yes], [termok=no])
		if test x$termok = xno ; then
			tom_found_termcap=
			AC_CHECK_LIB(termcap, tgetent, [tom_found_termcap=1])
			if test "x$tom_found_termcap" = x ; then
				:
			else
				TERMLIBS="$TERMLIBS -ltermcap";
				LIBS="$LIBS -ltermcap";
				AC_TRY_LINK(, [tgetent(0); tgetflag(0); tgetnum(0); tgetstr(0);],
					[termok=yes], [termok=no])
			fi
		fi
		if test x$termok = xyes; then
			AC_MSG_RESULT(using $TERMLIBS)
			tom_cv_termlibs="$TERMLIBS"
		else
			AC_MSG_WARN([Can't find termcap-functions.])
		fi
	])

	AC_MSG_CHECKING([which terminal library to use])
	if test "x$tom_cv_termlibs" = "x" ; then
		:
	else
		AC_DEFINE(HAVE_TERMCAP)
	fi

	LIBS="$OLDLIBS $tom_cv_termlibs"
	AC_MSG_RESULT([$tom_cv_termlibs])

]) dnl Ende von tom_TERMLIBS

dnl
dnl prft auf Binr-ffnungsmodi bei fopen
AC_DEFUN(tom_FOPEN_B,
[

	AC_REQUIRE([AC_CANONICAL_HOST])
	AC_REQUIRE([AC_PROG_CC])

	SAVE_CFLAGS="$CFLAGS"
	SAVE_LDFLAGS="$LDFLAGS"
	CFLAGS="-O"
	LDFLAGS=

	AC_MSG_CHECKING([whether fopen needs b-flag])
	AC_CACHE_VAL(tom_cv_fopen_b,[
	AC_TRY_RUN([
		#include <stdio.h>
		#include <string.h>
		int main(void) {
			FILE *f;
			char buf[256];
			char bufb[256];
			f=fopen("conftest.1f","w");
			if (!f)
			{
				fprintf(stdout,"unable to open file with w\n");
				exit(1);
			}
			fprintf(f,"hallo\n");
			fclose(f);

			f=fopen("conftest.1f","r");
			if (!f)
			{
				fprintf(stdout,"unable to open file with r\n");
				exit(1);
			}
			fgets(buf,sizeof(buf),f);
			fclose(f);

			f=fopen("conftest.1f","rb");
			if (!f)
			{
				fprintf(stdout,"unable to open file with rb\n");
				exit(1);
			}
			fgets(bufb,sizeof(bufb),f);
			fclose(f);

			if (strcmp(buf,bufb))
			{
				fprintf(stdout,"unequal\n");
				exit(1);
			}
			fprintf(stdout,"equal\n");
			exit(0);
		}
		],tom_cv_fopen_b=no,
		[tom_cv_fopen_b=yes ; echo compile/link/run failed],
		[ case "$host_os" in
			*os2*)
				echo "os2"
				tom_cv_fopen_b=yes
				;;
			*dos*)
				echo "dos"
				tom_cv_fopen_b=yes
				;;
			*tos*)
				echo "tos"
				tom_cv_fopen_b=yes
				;;
			*)
				AC_MSG_WARN([considering fopen(...,"b") not necessary])
				tom_cv_fopen_b=no
				;;
			esac
		] 
	)])dnl end of try_run and cache_val

	AC_MSG_RESULT($tom_cv_fopen_b)
	if test $tom_cv_fopen_b = yes; then
		AC_DEFINE(NEED_FOPEN_B)
		AC_SUBST(NEED_FOPEN_B)
	fi
	CFLAGS="$SAVE_CFLAGS"
	LDFLAGS="$SAVE_LDFLAGS"
]) dnl Ende von tom_FOPEN_B

dnl
dnl pat CFLAGS an unterschiedliche Compiler an
AC_DEFUN(tom_CFLAGS,
[

	AC_REQUIRE([AC_CANONICAL_HOST])
	AC_REQUIRE([AC_PROG_CC])
	AC_MSG_CHECKING([CFLAGS])

	AC_CACHE_VAL(tom_cv_cflags,[
		if test "$GCC" = "yes" ; then
			M="-Wall -Wstrict-prototypes -Wmissing-prototypes"
			M="${M} -Wnested-externs -Wpointer-arith -Wcast-qual"
			M="${M} -Wcast-align -Winline -Wwrite-strings"
			M="${M} -Wshadow -Wmissing-braces -Wcomments"
			M="${M} -pipe -fforce-mem -fforce-addr"
			for i in $M ; do
				case "$CFLAGS" in
				*$i*)
					;;
				*)
					CFLAGS="$i $CFLAGS"
					;;
				esac
			done
		else
			# try to guess it
			case "$host_os" in
			*hpux*)
				CFLAGS="$CFLAGS -Ae -O -D_XPG2 -D_XPG4"
				;;
			*)
				;;
			esac
		fi
		tom_cv_cflags="$CFLAGS"
	])
	AC_MSG_RESULT([$tom_cv_cflags])
	CFLAGS="$tom_cv_cflags"
]) dnl Ende von tom_CFLAGS


dnl
dnl prft ob funktionierende strftime
dnl
AC_DEFUN(tom_STRFTIME_BROKEN,
[
	AC_MSG_CHECKING([whether strftime works])
	AC_CACHE_VAL(tom_cv_strftime_broken,
	AC_TRY_RUN([
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
int main(void)
{
	struct tm *tm;
	time_t t=time(0);
	int i;
	char buf[20];
	tm=localtime(&t);
	for (i=8;i<15;i++)
	{
		char c;
		if (!strftime(buf,i,"%d.%m.%Y",tm) && i>=11)
			exit(1);
	}
	exit(0);
}
		],tom_cv_strftime_broken=no,tom_cv_strftime_broken=yes
		,[AC_MSG_WARN([considering strftime as ok])
	tom_cv_strftime_broken=no] ))dnl end of try_run and cache_val
	AC_MSG_RESULT($tom_cv_strftime_broken)
	if test $tom_cv_strftime_broken = no; then
		LIBOBJS="$LIBOBJS strftime.o";
		AC_SUBST(LIBOBJS)
	fi
]) dnl Ende von tom_STRFTIME_BROKEN

dnl
dnl
dnl tom_LIBRARY(name, dirname, function)
dnl             conf, conflib, cl_getconf
AC_DEFUN(tom_LIBRARY,
[
	AC_CHECK_LIB([$1], [$3])
	case "$LIBS" in
	*-l$1*)
		;;
	*)
		AC_MSG_CHECKING([for $2])
		cl=`echo $srcdir/$2*`
		if test -d "$cl" -a -f "$cl/configure" ; then
			help=-L`pwd`/$2
			LDFLAGS="$LDFLAGS $help -l$1"
			CFLAGS="$CFLAGS -I\$(srcdir)/$2"
			tom_lib_subdirs="$tom_lib_subdirs `echo $cl | sed 's/^.*\///'`"
			AC_MSG_RESULT([taken from \$srcdir/$2])
		else
			AC_MSG_WARN("keine $2 Library vorhanden")
		fi
		;;
		AC_SUBST(tom_lib_subdirs)
	esac
])dnl

dnl
dnl
dnl tom_TOOL(name,dirname)
dnl             lineedit, lineedit
AC_DEFUN(tom_TOOL,
[
	AC_MSG_CHECKING([for $1])
	cl=`echo $srcdir/$2*`
	if test -d "$cl" -a -f "$cl/configure" ; then
		tom_tool_subdirs="$tom_tool_subdirs `echo $cl | sed 's/^.*\///'`"
		AC_MSG_RESULT([taken from \$srcdir/$2])
	else
		AC_MSG_RESULT([not found])
	fi
	AC_SUBST(tom_tool_subdirs)
])dnl

AC_DEFUN(tom_STATFS_BAVAIL,[
	AC_MSG_CHECKING([for struct statfs,f_bavail])
	AC_CACHE_VAL(libquark_cv_statfs_bavail,[
    	AC_TRY_COMPILE([
			#ifdef HAVE_SYS_STATFS_H
			#include <sys/statfs.h>
			#elif defined(HAVE_SYS_VFS_H)
			#include <sys/vfs.h>
			#elif defined(HAVE_SYS_MOUNT_H)
			#include <sys/param.h>
			#include <sys/mount.h>
			#endif
			],
        	[struct statfs s; return s.f_bavail;],
        	[libquark_cv_statfs_bavail=yes],
        	[libquark_cv_statfs_bavail=no])
    ])
	if test $libquark_cv_statfs_bavail = yes ; then
    	AC_MSG_RESULT(yes)
    	AC_DEFINE(HAVE_STATFS_BAVAIL)
	else
    	AC_MSG_RESULT(no)
	fi
])dnl
AC_PREREQ(2.5)

AC_DEFUN(md_TYPE_PTRDIFF_T,
  [AC_CACHE_CHECK([for ptrdiff_t], ac_cv_type_ptrdiff_t,
     [AC_TRY_COMPILE([#include <stddef.h>], [ptrdiff_t p],
		     ac_cv_type_ptrdiff_t=yes, ac_cv_type_ptrdiff_t=no)])
   if test $ac_cv_type_ptrdiff_t = yes; then
     AC_DEFINE(HAVE_PTRDIFF_T)
   fi
])

dnl ------------------------
dnl Emacs LISP file handling
dnl ------------------------
AC_DEFUN(ud_PATH_LISPDIR,
 [AC_PATH_PROG(EMACS, emacs, no)
  if test $EMACS != "no"; then
    AC_MSG_CHECKING([where .elc files should go])
    dnl Set default value
    LISPDIR="\$(datadir)/emacs/site-lisp"
    if test "x$prefix" = "xNONE"; then
      if test -d $ac_default_prefix/share/emacs/site-lisp; then
	LISPDIR="\$(prefix)/share/emacs/site-lisp"
      else
	if test -d $ac_default_prefix/lib/emacs/site-lisp; then
	  LISPDIR="\$(prefix)/lib/emacs/site-lisp"
	fi
      fi
    else
      if test -d $prefix/share/emacs/site-lisp; then
	LISPDIR="\$(prefix)/share/emacs/site-lisp"
      else
	if test -d $prefix/lib/emacs/site-lisp; then
	  LISPDIR="\$(prefix)/lib/emacs/site-lisp"
	fi
      fi
    fi
    AC_MSG_RESULT($LISPDIR)
    ELCFILES="\$(ELCFILES)"
  fi
  AC_SUBST(LISPDIR)
  AC_SUBST(ELCFILES)])

dnl aclocal.m4 generated automatically by aclocal 1.1l

# Like AC_CONFIG_HEADER, but automatically create stamp file.

AC_DEFUN(AM_CONFIG_HEADER,
[AC_PREREQ([2.12])
AC_CONFIG_HEADER([$1])
dnl When config.status generates a header, we must update the stamp-h file.
dnl This file resides in the same directory as the config header
dnl that is generated.  We must strip everything past the first ":",
dnl and everything past the last "/".
AC_OUTPUT_COMMANDS(changequote(<<,>>)dnl
test -z "<<$>>CONFIG_HEADER" || echo timestamp > patsubst(<<$1>>, <<^\([^:]*/\)?.*>>, <<\1>>)stamp-h<<>>dnl
changequote([,]))])


# serial 1

AC_DEFUN(AM_PROG_INSTALL,
[AC_REQUIRE([AC_PROG_INSTALL])
test -z "$INSTALL_SCRIPT" && INSTALL_SCRIPT='${INSTALL_PROGRAM}'
AC_SUBST(INSTALL_SCRIPT)dnl
])


# Do all the work for Automake.  This macro actually does too much --
# some checks are only needed if your package does certain things.
# But this isn't really a big deal.

# serial 1

dnl Usage:
dnl AM_INIT_AUTOMAKE(package,version, [no-define])

AC_DEFUN(AM_INIT_AUTOMAKE,
[AC_REQUIRE([AC_PROG_INSTALL])
dnl We require 2.13 because we rely on SHELL being computed by configure.
AC_PREREQ([2.13])
PACKAGE=[$1]
AC_SUBST(PACKAGE)
VERSION=[$2]
AC_SUBST(VERSION)
dnl test to see if srcdir already configured
if test "`cd $srcdir && pwd`" != "`pwd`" && test -f $srcdir/config.status; then
  AC_MSG_ERROR([source directory already configured; run "make distclean" there first])
fi
ifelse([$3],,
AC_DEFINE_UNQUOTED(PACKAGE, "$PACKAGE", [Name of package])
AC_DEFINE_UNQUOTED(VERSION, "$VERSION", [Version number of package]))
AC_REQUIRE([AM_SANITY_CHECK])
AC_REQUIRE([AC_ARG_PROGRAM])
dnl FIXME This is truly gross.
missing_dir=`cd $ac_aux_dir && pwd`
AM_MISSING_PROG(ACLOCAL, aclocal, $missing_dir)
AM_MISSING_PROG(AUTOCONF, autoconf, $missing_dir)
AM_MISSING_PROG(AUTOMAKE, automake, $missing_dir)
AM_MISSING_PROG(AUTOHEADER, autoheader, $missing_dir)
AM_MISSING_PROG(MAKEINFO, makeinfo, $missing_dir)
AC_REQUIRE([AC_PROG_MAKE_SET])])

#
# Check to make sure that the build environment is sane.
#

AC_DEFUN(AM_SANITY_CHECK,
[AC_MSG_CHECKING([whether build environment is sane])
# Just in case
sleep 1
echo timestamp > conftestfile
# Do `set' in a subshell so we don't clobber the current shell's
# arguments.  Must try -L first in case configure is actually a
# symlink; some systems play weird games with the mod time of symlinks
# (eg FreeBSD returns the mod time of the symlink's containing
# directory).
if (
   set X `ls -Lt $srcdir/configure conftestfile 2> /dev/null`
   if test "[$]*" = "X"; then
      # -L didn't work.
      set X `ls -t $srcdir/configure conftestfile`
   fi
   if test "[$]*" != "X $srcdir/configure conftestfile" \
      && test "[$]*" != "X conftestfile $srcdir/configure"; then

      # If neither matched, then we have a broken ls.  This can happen
      # if, for instance, CONFIG_SHELL is bash and it inherits a
      # broken ls alias from the environment.  This has actually
      # happened.  Such a system could not be considered "sane".
      AC_MSG_ERROR([ls -t appears to fail.  Make sure there is not a broken
alias in your environment])
   fi

   test "[$]2" = conftestfile
   )
then
   # Ok.
   :
else
   AC_MSG_ERROR([newly created file is older than distributed files!
Check your system clock])
fi
rm -f conftest*
AC_MSG_RESULT(yes)])

dnl AM_MISSING_PROG(NAME, PROGRAM, DIRECTORY)
dnl The program must properly implement --version.
AC_DEFUN(AM_MISSING_PROG,
[AC_MSG_CHECKING(for working $2)
# Run test in a subshell; some versions of sh will print an error if
# an executable is not found, even if stderr is redirected.
# Redirect stdin to placate older versions of autoconf.  Sigh.
if ($2 --version) < /dev/null > /dev/null 2>&1; then
   $1=$2
   AC_MSG_RESULT(found)
else
   $1="$3/missing $2"
   AC_MSG_RESULT(missing)
fi
AC_SUBST($1)])

# Define a conditional.

AC_DEFUN(AM_CONDITIONAL,
[AC_SUBST($1_TRUE)
AC_SUBST($1_FALSE)
if $2; then
  $1_TRUE=
  $1_FALSE='#'
else
  $1_TRUE='#'
  $1_FALSE=
fi])

