/* bb_find_ren.c: Find a name in the list of renamed groups
    Copyright (C) 1998 Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@ohse.de, Uwe Ohse @ DU3 (mausnet)
*/
#include <portab.h>


#include "config.h"
#include "libquark.h"

#include "brett_db.h"

/*
BB_FUNCTION(Funktion,bb_rename_t,bb_find_rename_entry,[[(const char *@var{name})]],[[
    Wandelt den angegebenen Brettnamen mittels bb_canonical in die
    interne Form und sucht ihn in der Liste aller umbenannten Gruppen.
	Diese Funktion ist potentiell langsam.

    Liefert NULL bei Nichtfinden, sonst einen Zeiger auf die Rename-Infos.
]])
*/
bb_rename_t *bb_find_rename_entry(const char *name)
{
	bb_rename_t *akt;
	char bufname[512];

	bb_canonical(name,bufname);
	for (akt=bb_rename_anker;akt;akt=akt->next) {
		if (!strcmp(bufname,akt->old_name))
			return akt;
	}
	return NULL;

} /* bb_find_rename_entry */
