/* bb_pfad.c: returns the path of the brett data.
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/
#include <portab.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <ctype.h>

#include "config.h"
#include "libquark.h"

#include "brett_db.h"
#include "brett_int.h"

/*
BB_FUNCTION(Funktion,const char *,brettpfad,[[(BRETTNR @var{bnr})]],[[
    Die Funktion liefert zurck, in welchem Verzeichnis die Daten des
    Bretts mit der Nummer @var{bnr} liegen. Bei einer illegalen 
    Brettnummer wird ein Leerstring zurckgeliefert.

    Die Funktion verwendet einen statischen Speicherbereich zur
    Ablage des Strings!
]])
*/

const char *
brettpfad(BRETTNR nr)
{
	static char *pfad=NULL;
	BRETT *b;
	const char *dir;
	if (!pfad)
		pfad=XMALLOC(PATH_MAX);

	CHECK_BRETTNR(nr,return "");

	b=br_ind[nr].brett;
	if (!b)
		return "";
	if (b->art==TEXT_BRETT && nr)
		dir=bb_text_db_dir;
	else
		dir=bb_binaer_db_dir;


	/* Pers. Programmteil befindet sich immer auf aktuellem Laufwerk */
	if (!nr)
		sprintf(pfad,"%s/000/",dir);
	else
#ifdef HAVE_DOSDRIVES
		sprintf(pfad,"%c:%s/%03ld/",b->partition+'A',dir,(long)b->nr);
#else
		sprintf(pfad,"%s/%03ld/",dir,(long)b->nr);
#endif

	return pfad;

} /* brettpfad */
