/* auslast.c: Auslastungsanzeige */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/

#include "tomsysdep.h"

#include <portab.h>
#include <stdio.h>
#include <stdlib.h>

#include "tomsysdep.h"
#include "befehle.h"
#include "modem.h"
#include "terminal.h"
#include "prototyp.h"

extern WORD anz_lineW;
extern WORD vtmodeW;


/*
	08.04.93 Frank, neu

	dieselbe, optimierte Ausgabe fr ASCII und vt100
	lineare Interpolation der Werte zwischen den ganzen Stunden
*/
BOOLEAN bef_auslastung(const char *dummy TOM_ATTRIB_UNUSED)
{
	char zeile[80];
	int prozent[25];
	int i,max;
	int hour;
	int zeilen;
	int auslast[24];

	set_status_line(tprintf("Die heutige Auslastung der Box bis %s betrgt %d %%",
						hh_mm_ss(),(int) auslastung()));
	/* Auslastung lesen */
	get_auslastung(auslast);

	zeilen = SCROLLZEILEN;
	zeilen -= 4;
	max = zeilen;
	for (i = 0; i < 24; i++)
	{
		prozent[i] = (int)((100L*auslast[i])/3600);
		if (prozent[i] > max)
			max = prozent[i];
	}
	prozent[24] = prozent[0];

	mboutput("    00-01-02-03-04-05-06-07-08-09-10-11-"
	         "12-13-14-15-16-17-18-19-20-21-22-23-\r\n");

	for (i = 0; i < zeilen; i++)
	{
		char *p;

		p = zeile;
		*p = 0;
		mbprintf("%02d%% ",max-i*max/zeilen);
		for (hour = 0; hour < 24; hour++)
		{
			int limit;

			limit = max-i*max/zeilen;

			if (prozent[hour] < limit)
				*p++ = ' ';
			else
				*p++ = '*';

			if ((prozent[hour]*2+prozent[hour+1])/3 < limit)
				*p++ = ' ';
			else
				*p++ = '*';

			if ((prozent[hour]+prozent[hour+1]*2)/3 < limit)
				*p++ = ' ';
			else
				*p++ = '*';
		}
		*p = 0;

		while (p > zeile && *--p == ' ')
			*p = 0;

		mboutput(zeile);
		if (mboutput("\r\n") < 0)
			break;
	}

	mboutput("    00-01-02-03-04-05-06-07-08-09-10-11-"
	         "12-13-14-15-16-17-18-19-20-21-22-23-\r\n");

	return TRUE;
}
