/* befehle1.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
 * TOM Mailboxsystem
 * Copyright (C) 1993 1994 1995 Frank Baumgart, Uwe Ohse
 *
 * #include <all_rights_reserved>
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "config.h"

#include <portab.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "prototyp.h"
#include "befehle.h"
#include "brett.h"
#include "user.h"
#include "modem.h"
#include "terminal.h"
#include "msg.h"
#include "cmd.h"

extern USER user;
extern BRETT akt_brett;

extern int col_ix[];
extern BOOLEAN mehr_disabled;

extern char **boxbefehlS;

extern WORD
anz_lineW,
befehl_anzW,
count_crW,
vtmodeW;



/* >> Alphabetisch sortiert << */


/*
	fr Fragezeichen

	fhrende Grobuchstaben fett ausgeben
*/
static char *convert_ansi_S(char *str)
{
	static char befehl[50];
	char *p;

	/* Wenn Befehlsname nicht mit Grobuchstaben beginnt, normal ausgeben */
	if (!isupper(*str))
		return str;

	for (p=str;*p && isupper(*p);p++)
		;
	/* p nun auf erstem Kleinbuchstaben oder \0 */

	strcpy(befehl,vt_S(ATTR_FETT));
	strncat(befehl,str,p-str);
	strcat(befehl,vt_S(ATTR_OFF));
	strcat(befehl,p);

	return befehl;

} /* convert_ansi_S */


BOOLEAN bef_fragezeichen(const char *para)
{
	char eintrag[50];
	char *tmp;
	int count;
	int bpz = user.bs_spalten / 15;		/* pro Zeile passende Befehle */

	if (!*para)
	{
		box_cmd_t *akt;
		if (level()==0)
			set_status_line("Boxbefehle fr Gste");
		else
			set_status_line(tprintf("Boxbefehle fr Userlevel: %d",level()));
		count = 0;
		for (akt=befehl_get_anker(); akt; akt=akt->next)
		{
			if (!akt->fragezeichen)
				continue;
			if (akt->level[level()] 
			|| (akt->auch_chef && user.nummer==akt_brett.grp_chef))
			{
				tmp = convert_ansi_S(tprintf("%-12.12s",akt->name_ext));
				sprintf(eintrag,"%s %c%s",
				       (count % bpz == 0) ? "\r\n   " : " ",
				       (akt->nur_zahler) ? '$' : ' ',
				       tmp);
				mboutput(eintrag);
				count++;
			}
		}
		mboutput("\r\n");
		mboutput("\r\n");
		return TRUE;
	}
	else
		return bef_hilfe(para);

} /* bef_fragezeichen */



BOOLEAN bef_clearscreen(const char *dummy TOM_ATTRIB_UNUSED)
{
	const char *pos=vt_pos_S(2,1);
	const char *rest=vt_S(DEL_SCR_REST);
	const char *all=vt_S(DEL_SCR);

	if (pos && (rest||all))
	{
		/* Die "notfall"-Variante mit "all" lscht leider auch die 
		 * oberste Zeile */
		mbprintf("%s%s",pos,rest ? rest : all);
		count_crW = 0;
		redraw_status();
	}
	else
	{
		UWORD i;
		BOOLEAN old;
		old=mehr_disabled;
		mehr_disabled=TRUE;
		if (user.bs_zeilen)
			for(i=0;i<user.bs_zeilen;i++)
				mboutput("\r\n");
		count_crW = 0;
		mehr_disabled=old;
		pos=vt_pos_S(1,1);
		if (pos)
			mboutput(pos);
	}
	return TRUE;

} /* bef_clearscreen */
