/* datum.c : still no description */
/*
    Copyright (C) 1994-1996, 1999 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@ohse.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/

/*
 * bef_datum.c: Vergleichsdatum setzen.
 */

#include "config.h"

#include <portab.h>
#include <stdlib.h>
#include <string.h>

#include "prototyp.h"
#include "user.h"
#include "brett.h"
#include "modem.h"
#include "befehle.h"

extern USER user;

static time_t orig_datum;
static USERNR orig_unr;

/*
	25.02.93 Frank, C Strings
*/
BOOLEAN bef_datum(const char *para)
{
	struct tm *datime;
	char datumS[30];
	char dummyS[10];
	BOOLEAN change = FALSE;

	datime = localtime(&user.letzter_login);
	if (orig_unr != user.nummer || orig_datum==(time_t) 0)
	{
		orig_datum=user.letzter_login;
		orig_unr=user.nummer;
	}

	if (!*para || !strcmp(para,"*"))
	{
		set_status_line("Vergleichs-Datum ndern");
		time_t_to_mtzeit(&user.letzter_login,datumS);
		/* JJJJMMDD */
		/* strncpy(datumS,zeige_datum_S(user.letzter_login),8+5); */
		mbquestion(2,2,TRUE," >> Tag    (TT): ",datumS+6,dummyS); 
		datime->tm_mday = atoi(dummyS);
		mbquestion(2,2,TRUE," >> Monat  (MM): ",datumS+4,dummyS);
		datime->tm_mon = atoi(dummyS)-1; /* 0..11 */
		mbquestion(4,2,TRUE," >> Jahr   (JJJJ): ",datumS,dummyS);
		datime->tm_year = atoi(dummyS);
		if (datime->tm_year < 100) {
			struct tm *tm;
			time_t t=time(0);
			tm=localtime(&t);
			if (tm->tm_year>=100) 
				datime->tm_year+=100;
		}
		if (*para)
		{
			mboutput("\r\n");
			mbquestion(2,2,TRUE," >> Stunde (SS): ",datumS+8,dummyS);
			datime->tm_hour = atoi(dummyS);
			mbquestion(2,2,TRUE," >> Minute (MM): ",datumS+10,dummyS);
			datime->tm_min = atoi(dummyS);
		}
		else
		{
			datime->tm_min = 0;
			datime->tm_hour = 0;
		}
		datime->tm_sec = 0;
		user.letzter_login = mktime(datime);
		mbprintf("\r\n ** neue Vergleichs-Daten: %s\r\n\n",zeige_datum_S(user.letzter_login));
		change = TRUE;
	}
	else if (!strcmp(para,"0") || !strcmp(para,"-0"))
	{
		user.letzter_login = orig_datum;
		mbprintf("\r\n ** neue Vergleichs-Daten: %s (2.letzter LOGOFF)\r\n\n",zeige_datum_S(user.letzter_login));
		change = TRUE;
	}
	else if (!strcmp(para,"-1"))
	{
		user.letzter_login = user.letzter_login2;
		mbprintf("\r\n ** neue Vergleichs-Daten: %s (2.letzter LOGOFF)\r\n\n",zeige_datum_S(user.letzter_login));
		change = TRUE;
	}
	else if (!strcmp(para,"-2"))
	{
		user.letzter_login = user.letzter_login3;
		mbprintf("\r\n ** neue Vergleichs-Daten: %s (3.letzter LOGOFF)\r\n\n",zeige_datum_S(user.letzter_login));
		change = TRUE;
	}
	else if (!strcmp(para,"#"))
	{
		mbprintf("\r\n ** aktuelle Vergleichs-Daten: %s\r\n\n",zeige_datum_S(user.letzter_login));
	}
	else
	{
		parameter_falsch("DATUM",para);
		return FALSE;
	}

	/* bei Datumsnderungen erneut Bretter mit neuem Inhalt ermitteln */
	if (change)
		b_set_flags(&user);
	return TRUE;
}
