/* befehle/event.c: Eventliste ansehen oder Event auslsen */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/

#include "tomsysdep.h"

#include <portab.h>
#include <string.h>

#include "prototyp.h"
#include "befehle.h"
#include "user.h"
#include "modem.h"
#include "event.h"
#include "business.h"

extern USER user;

extern char *global_event_hack;
extern int logout_modus;
extern WORD temp_levelW;

static void print_zugang(GRENZE *g, int typ);

static void
print_zugang(GRENZE *g, int typ)
{
	if (g->erlaubt)
	{
		if (g->zahler)
			mboutput(" $");
		else
			mboutput("  ");
		switch(g[typ].level)
		{
		case 0: mboutput("Gast   "); break;
		case 1: mboutput("Neuuser"); break;
		case 2: mboutput("User   "); break;
		case 7:
		case 8:
		case 9: 
			mboutput("Sysop  "); 
			break;
		default: mbprintf("User(%d)",g[typ].level); break;
		}
	}
	else
		mboutput("  nein   ");
}

BOOLEAN bef_event(const char *para)
{
	if (!*para)
	{
		event_t *akt;
		long anzahl;
		BUSINESS *bus;

		set_status_line("Eventliste und Onlinezeiten ansehen");

		mboutput(" Soft  Wurf  Hard   Nchster in  Zuletzt vor  ist\r\n\n");
		for (akt=event_anker(); akt!= NULL; akt=akt->next)
		{
			time_t t,dif;

			if (!akt->auto_ok)
				continue;

			t=time(NULL);
			dif=(akt->next_soft-t)/60;

			mbprintf(" %02d:%02d",
				(int) (akt->soft_begin / 100), 
				(int) (akt->soft_begin%100) );
			if (akt->wurf_begin != (ULONG) -1)
				mbprintf(" %02d:%02d",
					(int) (akt->wurf_begin / 100), 
					(int) (akt->wurf_begin%100) );
			else
				mboutput("      ");
			mbprintf(" %02d:%02d",
				(int) (akt->hard_begin / 100), 
				(int) (akt->hard_begin%100) );
			if (dif>6*60)
				mbprintf(" %3d h      ", (int) (dif/60));
			else
				mbprintf(" %3d min    ", (int) dif);
			if (akt->last_started)
			{
				dif=(t-akt->last_started)/60;
				if (dif<6*60)
					mbprintf("   %3d min    ",(int) dif);
				else if (dif<48*60)
					mbprintf("   %3d h      ",(int) (dif/60));
				else
					mbprintf("   %3d d      ",(int) (dif/1440));
			}
			else
				mbprintf("              ");
			
			mbprintf("  %s\r\n",akt->id);
		}
		bus=get_business_array(&anzahl);
		if (bus)
		{
			long i;
			BOOLEAN self=FALSE;
			if (level()!=2 && level()!=0)
				self=TRUE;

			mbprintf(
				"\r\n"
				"Onlinezeiten:\r\n"
				"Ab    Gste  User%s    Prog. Titel\r\n",
				self ? " selb." : "");
			for (i=0;i<anzahl;i++,bus++)
			{
				mbprintf("%02d:%02d",
					bus->start / 60, bus->start%60);
				mbprintf(" %5d %5d", 
					bus->onlinezeit[0],
					bus->onlinezeit[2]);
				if (self)
					mbprintf(" %5d", bus->onlinezeit[level()]);
				print_zugang(bus->grenze,B_DOWNLOAD);
				mbprintf(" %s\r\n",bus->titel);
/*
MAUS:
Uhrzeit        Gste   User Zahler  Hinweise
00:00 - 02:59     30     60     60  G Die Stunden zum saugen.
Quark:
Ab    Gste  User[  self.]    Tausch    Prog. Titel
00:00    20    30            User(2)  User(4) Any
*/
			}
		}
	}
	else 
	{
		char *leave;

		leave=event_execute(para);

		if (leave)
		{
			mboutput("\r\n");
			mboutput(" Die Box wird nun verlassen, um den Event auszufhren\r\n");
			logout_modus=1;
			redraw_status();
			temp_levelW=-1;
			global_event_hack=leave;
		}
	}
	return TRUE;
}
