/* inhalt.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
 * TOM Mailboxsystem
 * Copyright (C) 1993 1994 1995 Frank Baumgart, Uwe Ohse
 *
 * #include <all_rights_reserved>
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * befehle/inhalt.c: Inhaltsbersichten von Binr- und Textbrettern.
 */

#include "config.h"

#include <portab.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include <unistd.h>

#include "tomsysdep.h"
#ifdef OFFLINE2
#include "offline/inc/version.h"
#include "offline/inc/message.h"
#else
#include "offline/version.h"
#include "offline/message.h"
#endif
#include "prototyp.h"
#include "befehle.h"
#include "brett.h"
#include "user.h"
#include "modem.h"
#include "terminal.h"
#include "msg.h"
#include "bin_msg.h"
#include "bin_out.h"

extern USER user;
extern BRETT akt_brett;
extern BRETTNR brettnrW;
extern BRETTINFO *br_ind;

extern WORD count_crW;
extern int logout_modus;

static BOOLEAN inhalt_text(const char *para);
static BOOLEAN inhalt_binaer(const char *para);



BOOLEAN bef_inhalt(const char *para)
{
	if (brettart(brettnrW) == BINAER_BRETT)
		return inhalt_binaer(para);
	else
		return inhalt_text(para);

} /* bef_inhalt */



/*
	Nachrichten-bersicht

	15.12.92 Frank

	Bug (?):
	keine berprfung der Zugriffsberechtigung
*/
static BOOLEAN inhalt_text(const char *para)
{
	char all_para[] = "1-99999";
	char neu_para[16];
	BOOLEAN header = FALSE;

	char maske[80] = { 0 };
	char s[300];				/* aktuelle Indexzeile */
	int ok;
	long nr;						/* aktuelle Messagenummer */
	BOOLEAN keine = FALSE;	/* Flag, ob berhaupt Nachrichten */
	BOOLEAN neue = TRUE;		/* Flag, ob neue Nachrichten */
	BOOLEAN pm;					/* Flag, ob PM oder Gruppe */
	const char *name;			/* Gruppen- bzw. Username */

#ifdef OFFLINE_VERSION
	ULONG max = 99999;		/* ### Anzahl Msgs. in der Gruppe */
	ULONG flags;				/* akt. Msg.-Flags */
	int gh;						/* handle */
	size_t maxlen;

	pm = (brettnrW == 0);
	name = (pm) ? user.name : akt_brett.name;
	if ((gh = group_open(name,pm)) < 0)
		keine = TRUE;
	else
	if (!*para)
	{
		if (!brettnrW || br_ind[brettnrW].brett->flags & B_NEU)
		{
			if (!index_goto_new(gh,user.letzter_login))
				neue = FALSE;
#if 0
			else
			if (msg_get_nr(gh) < max)
			{
				sprintf(neu_para,"%ld-999999",(long) msg_get_nr(gh));
				para = neu_para;
			}
#endif
		}
		else
			neue = FALSE;

		if (!neue)
			group_close(gh,getpid());
	}

	if (keine || (!*para && !neue))
	{
		mboutput(" Keine ");
		if (!*para && !neue)
			mboutput("neuen ");
		mboutput("Eintrge ");
		if (pm)
			mboutput("im Postfach");
		else
			mboutput("in diesem Brett");
		mboutput(" vorhanden\r\n");
		mboutput("\r\n");

		return FALSE;
	}

	set_status_line("Nachrichten-bersicht");

	if (!strcmp(para,"*"))
		para = all_para;
	else
	if (!strcmp(para,"*-"))
	{
		long max = 0;
		while (index_goto(gh,max+1))
			max++;
		sprintf(neu_para,"%ld-1",(long) max+1);
		para = neu_para;
	}
	if (isalpha(*para))
	{
		size_t len;
		len = strcspn(para," ");
		strncpy(maske,para,len);
		maske[len] = 0;
		strlwr(maske);
		para += len;
		while (isspace(*para))
			para++;
		if (!*para)
			para = all_para;
	}

	maxlen=user.bs_spalten ? user.bs_spalten : 80;
	if (maxlen>=sizeof(s))
		maxlen=sizeof(s)-1;
	for (ok = lrange(para,&nr); ok && nr > 0; ok = lrange(NULL,&nr))
	{
		if (nr <= 0)
			continue;
		if ((ULONG) nr > max)
			break;

		if (userbreak())
			break;
		if (logout_modus)
			break;

		if (!msg_index_string_nr(gh,nr-1,maxlen,s))
			break;

		/* todo: Maske berprfen */

		if (!header)
		{
			set_scroll_area(2);
			mboutput(vt_pos_S(4,1));
			mbprintf(" NR.  KV  DATUM    ABSENDER               ZEILEN BETREFF\r\n");
			mbprintf(" %s\r\n",trennzeile);
			header = TRUE;
		}

		if (mbprintf("%s\r\n",s) < 0)
			break;

		neue = TRUE;
	}

#else

	ULONG max;					/* Anzahl Msgs. in der Gruppe */
	ULONG flags;				/* akt. Msg.-Flags */
	int gh;						/* handle */
	size_t maxlen;

	pm = (brettnrW == 0);
	name = (pm) ? user.name : akt_brett.name;
	if (!group_info_msgs(name,pm,&max,NULL) || !max
	|| ((gh = group_open(getpid(),name,pm,FALSE)) < 0))
		keine = TRUE;
	else
	if (!*para)
	{
		if (!brettnrW || br_ind[brettnrW].brett->flags & B_NEU)
		{
			if (!index_goto_new(gh,user.letzter_login))
				neue = FALSE;
			else
			if (msg_get_nr(gh) < max)
			{
				sprintf(neu_para,"%ld-999999",(long) msg_get_nr(gh)+1);
				para = neu_para;
			}
		}
		else
			neue = FALSE;

		if (!neue)
			group_close(gh,getpid());
	}

	if (keine || (!*para && !neue))
	{
		mboutput(" Keine ");
		if (!*para && !neue)
			mboutput("neuen ");
		mboutput("Eintrge ");
		if (pm)
			mboutput("im Postfach");
		else
			mboutput("in diesem Brett");
		mboutput(" vorhanden\r\n");
		mboutput("\r\n");

		return FALSE;
	}

	set_status_line("Nachrichten-bersicht");

	if (!strcmp(para,"*"))
		para = all_para;
	else
	if (!strcmp(para,"*-"))
	{
		sprintf(neu_para,"%ld-1",(long) max);
		para = neu_para;
	}
	if (isalpha(*para))
	{
		size_t len;
		len = strcspn(para," ");
		strncpy(maske,para,len);
		maske[len] = 0;
		strlwr(maske);
		para += len;
		while (isspace(*para))
			para++;
		if (!*para)
			para = all_para;
	}

	maxlen=user.bs_spalten ? user.bs_spalten : 80;
	if (maxlen>=sizeof(s))
		maxlen=sizeof(s)-1;
	for (ok = lrange(para,&nr); ok && nr > 0; ok = lrange(NULL,&nr))
	{
		if (nr <= 0)
			continue;
		if ((ULONG) nr > max)
			break;

		if (userbreak())
			break;
		if (logout_modus)
			break;

		if (!index_goto(gh,(MESSAGE) (nr-1)) || !index_read(gh))
			break;

		/* gelschte Messages berspringen */
		flags = msg_get_flag(gh);
		if (flags & TOTAL)
			continue;

		/* Indexstring holen */
		if (!msg_index_string(gh,maske,maxlen,s))
			continue;

		if (!header)
		{
			set_scroll_area(2);
			mboutput(vt_pos_S(4,1));
			mbprintf(" NR.  KV  DATUM    ABSENDER               ZEILEN BETREFF\r\n");
			mbprintf(" %s\r\n",trennzeile);
			header = TRUE;
		}

		if (mbprintf("%s\r\n",s) < 0)
			break;

		neue = TRUE;
	}
#endif

	group_close(gh,getpid());
	set_scroll_area(1);

	return TRUE;

} /* inhalt_text */



/*
	01.02.93 Frank
	10.02.93 Frank, Konverter-frei
	16.08.94 Frank, es wird nun FALSE zurckgeliefert, wenn keine Parameter
	                angegeben waren und keine neuen Daten vorliegen
	23.01.95 Frank, "INHALT" mit numer. Parametern korrigiert und "*-" ergaenzt
*/
static BOOLEAN inhalt_binaer(const char *para)
{
	BOOLEAN paraB = FALSE;
	BOOLEAN pm;
	BOOLEAN parW;
	char p_tmp[80];
	time_t ref_zeit = user.letzter_login;
	BIN_MSG bin_info;
	FILE *bin_f;
	char maske[80] = "";

	if (level()==0)
		ref_zeit=0;

	strcpy(p_tmp,para);
	if (brettnrW && !(br_ind[brettnrW].brett->flags & B_READ))
	{
		mbfehler("Inhaltsbersicht hier nicht erlaubt");
		return FALSE;
	}

	pm = (brettnrW == 0);

	if (!stricmp(para,"PP") && pm)
	{
		set_status_line("verschickte pers. Programme:");
		bin_heading();
		set_scroll_area(2);

		if ((bin_f = binaer_dat_oeffnen(0,FALSE)) == NULL)
			return FALSE;

		while (fread(&bin_info,sizeof(BIN_MSG),1,bin_f))
		{
			if (bin_info.nr && bin_info.usernr == user.nummer)
			{
				if (bin_msg_inhalt(&bin_info) < 0)
					break;
			}
			if (userbreak())
				break;
		}
		binaer_dat_schliessen(bin_f);

		set_scroll_area(1);
		paraB = TRUE;
	}
	else /* !PP */
	{
		BOOLEAN show_all=FALSE;
		long all,neu;
		BOOLEAN ok;
		long nr;

		if (!binaer_dat_anzahl(brettnrW,ref_zeit,&all,&neu,NULL,NULL) || !all)
		{
			mboutput(" Keine Eintrge in diesem Brett vorhanden\r\n");
			mboutput("\r\n");
			return FALSE;
		}

		/* Buchstabe als Suchtext angegeben? */
		if (isalpha(*para))
		{
			size_t len = 0;
			while (isalpha(para[len]))
				len++;
			strncpy(maske,para,len);
			maske[len] = 0;
			strlwr(maske);
			while (isspace(para[len]))
				len++;
			strcpy(p_tmp,para+len);
		}

		/* immer wieder geben User "INHALT **" statt "INHALT *" ein */
		if (!strcmp(p_tmp,"*") || !strcmp(p_tmp,"**"))
		{
			show_all = TRUE;
			sprintf(p_tmp,"1-%ld",all);
			parW = TRUE;
		}
		else if (!strcmp(p_tmp,"*-"))
		{
			show_all = TRUE;
			sprintf(p_tmp,"%ld-1",all);
			parW = TRUE;
		}
		else if (*p_tmp)
		{
			parW = TRUE;
		}
		else /* !*p_tmp */
		{
			char tmp[80];

			strcpy(p_tmp,"1-999999");

			show_all = FALSE;
			if (!neu)
			{
				mboutput(" Keine neuen Eintrge ");
				if (pm)
				{
					mboutput("im eigenen Programmfach\r\n");
					return FALSE;
				}
				else
				{
					mboutput("in diesem Brett\r\n");
					return FALSE;
				}
			}

			if (pm)
				strcpy(tmp," Neue Dateien im eigenen Programmfach");
			else
				sprintf(tmp," Neue Dateien im Brett <%s>",akt_brett.name);
			set_status_line(tprintf("%s seit dem %s",tmp,zeige_datum_S(ref_zeit)));
			parW = FALSE;
		}

		if (!neu && !*p_tmp)
			return TRUE;

		set_status_line("Brettinhalt:");
		bin_heading();
		set_scroll_area(2);

		bin_f = binaer_dat_oeffnen(brettnrW,FALSE);

		for (ok = lrange(p_tmp,&nr); ok && nr > 0; ok = lrange(NULL,&nr))
		{
			if (nr <= 0)
				continue;
			if (nr > all)
				break;

			if (fseek(bin_f,(nr-1)*sizeof(BIN_MSG),SEEK_SET)
			|| !fread(&bin_info,sizeof(BIN_MSG),1,bin_f))
				continue;

			if (*maske)
			{
				BIN_MSG tmp_info = bin_info;

				strlwr(tmp_info.name);
				strlwr(tmp_info.absender);
				strlwr(tmp_info.betreff);
				if (!strstr(tmp_info.name,maske)
				&&  !strstr(tmp_info.absender,maske)
				&&  !strstr(tmp_info.betreff,maske))
					continue;
			}

			if (bin_read_access(&bin_info)
			&& (show_all || parW || (!parW && bin_info.datime > ref_zeit)))
			{
				if (bin_msg_inhalt(&bin_info) < 0)
					break;
			}

			if (userbreak())
				break;
			if (logout_modus)
				break;
		}
		paraB = TRUE;

		binaer_dat_schliessen(bin_f);
		set_scroll_area(1);
	}
	mboutput("\r\n");

	if (!paraB)
	{
		if (*maske)
		{
			mbprintf(" Kein Eintrag mit '%s' gefunden\r\n",maske);
			return TRUE;
		}
		else
		{
			parameter_falsch("INHALT",p_tmp);
			return FALSE;
		}
	}
	else
		return TRUE;

} /* inhalt_binaer */
