/* proginfo.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
 * TOM Mailboxsystem
 * Copyright (C) 1993 1994 1995 Frank Baumgart, Uwe Ohse
 *
 * #include <all_rights_reserved>
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "tomsysdep.h"

#include <portab.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "fnmatch.h"

#include "prototyp.h"
#include "modem.h"
#include "brett.h"
#include "bin_msg.h"
#include "befehle.h"

extern BRETTINFO *br_ind;
extern long max_brettnr;



/*
	Programmteilinfo
	bersicht ber alle Programmteile ausgeben

	Syntax:
	PTINFO [maske [datum]]

	maske darf wildcards enthalten und dient zur Auswahl der Programmbereiche,
	z.B.: PTINFO ST-* 1.1.94

	21.02.93 Frank
	06.07.94 Frank, wildcards
*/
BOOLEAN bef_proginfo(const char *para)
{
	char maske[80] = { 0 };
	long all,bytes;
	long sum_all = 0;
	long sum_bytes = 0;
#ifdef HAVE_DOSDRIVES
	long frei;
#endif
	int i;
	time_t ref_time = 0;

	set_status_line("Programmteil-Informationen:");

	/* zum optionalen Parameter */
	while (isspace(*para))
		para++;
	if (*para)
	{
		size_t len;
		len = strcspn(para," ");
		strncpy(maske,para,len);
		maske[len] = 0;
		strlwr(maske);
		para += len;
		while (isspace(*para))
			para++;

		/* Datum auswerten */
		if (*para)
		{
			int tag,monat,jahr;
			if (zerlege_datum(para,&tag,&monat,&jahr))
			{
				struct tm zeit;

				memset(&zeit,0,sizeof(zeit));
				zeit.tm_mday = tag;
				zeit.tm_mon  = monat-1;
				zeit.tm_year = jahr;
				ref_time = mktime(&zeit);
			}
		}
	}

/*	mboutput(" Brett                Anzahl   Gre [kB]    Partition   frei [kB]\r\n");*/
#ifdef HAVE_DOSDRIVES
	mboutput(" Brett                Dateien     kBytes   Partition        frei [kB]\r\n");
#else
	mboutput(" Brett                Dateien     kBytes\r\n");
#endif
	mboutput(" ====================================================================\r\n");

	for (i = 0; i < max_brettnr; i++)
	{
		if (!br_ind[i].brett)
			continue;
		if (i == 0
		|| (i != 0 && brettart(i)==BINAER_BRETT))
		{
			if (*maske)
			{
				char tmp[80];

				/* wg. case-insensitiver Suche, Brettname -> Kleinschrift */
				strcpy(tmp,br_ind[i].brett->name);
				strlwr(tmp);

				if (fnmatch(maske,br_ind[i].brett->name,0))
					continue;
			}

			binaer_dat_anzahl(i,ref_time,&all,NULL,&bytes,NULL);

			sum_all += all;
			sum_bytes += bytes;

			/* Ausgabe nur bei Leseberechtigung */
			if (br_ind[i].brett->flags & B_READ)
			{
#ifdef HAVE_DOSDRIVES			
				frei = bytes_free(brettdrive(i));
				mbprintf(" %-20.20s %7ld %10ld       %c:         %9ld\r\n",
							(i) ? br_ind[i].brett->name : "pers. Programme",
							all,bytes/1024,brettdrive(i)+'A',frei/1024);
#else
				mbprintf(" %-20.20s %7ld %10ld\r\n",
							(i) ? br_ind[i].brett->name : "pers. Programme",
							all,bytes/1024);
#endif
			}
		}

		if (userbreak())
			break;
	}

	mboutput(" ====================================================================\r\n");
	mbprintf(" %-20s %7ld %10ld\r\n","Summe:",sum_all,sum_bytes/1024);

	mboutput("\r\n");

	return TRUE;

} /* bef_proginfo */
