/* systemstatus.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
 * TOM Mailboxsystem
 * Copyright (C) 1993 1994 1995 Frank Baumgart, Uwe Ohse
 *
 * #include <all_rights_reserved>
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "config.h"

#include <portab.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "prototyp.h"
#include "befehle.h"
#include "modem.h"
#include "terminal.h"
#include "tomsysdep.h"
#include "box_conf.h"
#include "config.h"
#include "aktdata.h"

#ifdef HAVE_DOSDRIVES
extern char known_drivesS[];
#endif


/*
	Ausgabe des Systemstatus

	06.12.1992 Frank, fast neu
*/
BOOLEAN bef_sys_status(const char *dummy TOM_ATTRIB_UNUSED)
{
	struct status_dat st;
	open_read_status_dat(TRUE,&st);
	set_status_line(tprintf("Systemstatus %s:",box_conf.systemname));

	mbprintf(" %s Version     :%s %s (#%s) %s %s\r\n",
				vt_S(ATTR_FETT),vt_S(ATTR_OFF),
				VERSION,vstr_compileversion,vstr_date,vstr_time);
	mbprintf(" %s Name        :%s %-26s\r\n",
				vt_S(ATTR_FETT),vt_S(ATTR_OFF),
				box_conf.systemname);
	mbprintf(" %s Gesamtanrufe:%s %-26ld%s Tagesanrufe :%s %d\r\n",
				vt_S(ATTR_FETT),vt_S(ATTR_OFF),
				st.anz_calls,
				vt_S(ATTR_FETT),vt_S(ATTR_OFF),
				st.tagesanrufe);
	mbprintf(" %s Auslastung  :%s %3d %%%21s%s Post-Ertrag :%s %.1ld.%02ld DM\r\n",
				vt_S(ATTR_FETT),vt_S(ATTR_OFF),
				auslastung(),"",
				vt_S(ATTR_FETT),vt_S(ATTR_OFF),
				st.postertrag/100,
				st.postertrag%100);
#ifdef HAVE_DOSDRIVES
	mbprintf(" %s Online-Zeit :%s %8.8s - %8.8s%7s%s Laufwerke   :%s %s\r\n",
				vt_S(ATTR_FETT),vt_S(ATTR_OFF),
				box_conf.online_from,
				box_conf.online_to,
				"",
				vt_S(ATTR_FETT),vt_S(ATTR_OFF),
				known_drivesS);
#else
	mbprintf(" %s Online-Zeit :%s %8.8s - %8.8s\r\n",
				vt_S(ATTR_FETT),vt_S(ATTR_OFF),
				box_conf.online_from,
				box_conf.online_to);
#endif

	if (box_conf.sys_stat_system_cmd)
	{
		FILE *f;
		f=popen(box_conf.sys_stat_system_cmd,"r");
		if (f)
		{
			char buf[1024];
			while (fgets(buf,sizeof(buf),f))
			{
				char *p;
				p=strpbrk(buf,"\r\n");
				if (p)
					*p='\0';
				mbprintf("%s\r\n",buf);
			}
			pclose(f);
		}
	}

	mboutput("\r\n");

	return TRUE;
}
