/* teilnehmer.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
 * TOM Mailboxsystem
 * Copyright (C) 1993 1994 1995 Frank Baumgart, Uwe Ohse
 *
 * #include <all_rights_reserved>
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "config.h"

#include <portab.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>

#include "prototyp.h"
#include "modem.h"
#include "terminal.h"
#include "befehle.h"
#include "user.h"

extern USER user;

extern BYTE
batchB;

extern WORD
count_crW,
vtmodeW;



/*
	14.12.92 Frank, schwer berarbeitet aber noch buggy
	25.03.93 Frank, an Userdatenbank angepat
	02.05.93 Frank, wahlweise nur neue User bzw. ab Referenzzeitpunkt
	22.11.93 Uwe, Default, NEU, ALL, *, $, INAKTIV, PASSWORT, LEVEL, +
             (heavily rehacked).

	Einschrnkung: (? TEIL NEU macht das eigentlich berflssig, oder? -- uwe )
	Ausgabe rckwrts noch nicht mglich

	Ich tendiere zu einem eigenem Befehl fr Teilnehmer Rckwrts, sonst
	wird der Parameterparser grauenvoll. RTEIL <para> und Teil <para> 
	knnten dann intern ber ein- und dieselbe Routine gehen. -- uwe.
*/
BOOLEAN bef_teilnehmer(const char *para)
{
	BOOLEAN zahler = FALSE;		/* Zahler ausgeben */
	BOOLEAN seit = FALSE;		/* seit einem bestimmten Zeitpunkt */
	int level = -1;				/* User mit Level x (-1: alle) */
	BOOLEAN inaktive=FALSE;		/* seit 4 Wochen nicht mehr angerufen */
	BOOLEAN aktive=FALSE;		/* in den letzten 4 Wochen angerufen */
	time_t inaktive_secs=0;		/* Sekunden inaktiv */
	time_t aktive_secs=0;		/* in x Sekunden aktiv */
	BOOLEAN pw_dat=FALSE;		/* User mit Passwort ab einem bestimmten Alter */
	long passwort_secs = 0;
	long anrufzahl = -1;			/* User mit dieser oder einen hheren Anrufzahl */
	time_t ref_time;				/* Referenzzeitpunkt */
	USER u;
	BOOLEAN statistik=FALSE;	/* Am Ende eine Statistik anzeigen */
	BOOLEAN use_spec=FALSE;		/* typabhngige Zahl anstelle von Rechner? */
	BOOLEAN mit_adr=FALSE;      /* Mit Adressen ausgeben? */
	BOOLEAN mit_zahlerdatum=FALSE;
	WORD count = 0;
	/* fr den Fall einer unvollstndigen Erweiterung der Routine */
	const char *bezeich="Hier fehlt ein Default";
	const char *ueberschrift="Hier fehlt ein Default";

	char hilf[128];

	if (*para)
	{
		if (!stricmp(para,"-adr$"))
		{
			para+=5;
			mit_adr=TRUE;
			mit_zahlerdatum=TRUE;
		}
		else if (!stricmp(para,"-adr"))
		{
			para+=4;
			mit_adr=TRUE;
			mit_zahlerdatum=TRUE;
		}
		else if (!strnicmp(para,"-adr$ ",6))
		{
			para+=6;
			mit_adr=TRUE;
		}
		else if (!strnicmp(para,"-adr ",5))
		{
			para+=5;
			mit_adr=TRUE;
		}
		if (mit_adr && user.level < 8)
		{
			mboutput("\r\n");
			mboutput(" Spielplatz erst fr Kinder ab 8 freigegeben.\r\n");
			return FALSE;
		}
	}

	if (!*para)	/* Default */
	{
		/* TEIL-Default. Unterschiedlich fr User und Sysops. */
		if (user.level>=7)
			para="NEU";
		else
			para="*";
		/* Damit ist auch gesichert, da spter para immer etwas enthlt ! */
	}

	if (!strcmp(para,"$")) /* Nur Zahler */
	{
		set_status_line("Liste der zahlenden User:");
		zahler=TRUE;
		statistik=TRUE;
		bezeich="Zahlende";
	}
	else if (!strnicmp(para,"LV ",3)) /* Nur ein bestimmter Level */
	{
		level = (int) strtol(para+3,NULL,10);
		statistik = TRUE;
		if (level<ULV_MIN || level>ULV_MAX)
		{
			parameter_falsch("TEILNEHMER",para);
			return FALSE;
		}
		/* Wenn User < Level 7 versuchen, Informationen zu bekommen, 
			die nicht fr ihn gedacht sind */
		if (level>user.level && user.level<7)
		{
			mbfehler("Das funktioniert nur bis zu ihrem eigenen Level");
			return FALSE;
		}
		sprintf(hilf,"User mit Level %ld",(long)level);
		bezeich=hilf;
	}
	else if (*para=='-' || !stricmp(para,"REV")) /* Alle, aber Rckwrts */
	{
#if 0
		set_status_line("Userliste der Box: (rckwrts)");
#else
		mboutput(" Ausgabe rckwrts derzeit nicht mglich\r\n");
		return FALSE;
#endif
	}
	else if (!stricmp(para,"NEU")) /* Neue User */
	{
		set_status_line("Neue User in der Box:");
		seit=TRUE;
		statistik=TRUE;
		bezeich="Neue";
#ifdef HAS_USER_LETZTER_TEIL
		/* Neue user seit dem letzten Aufruf von TEILNEHMER */
		ref_time = user.letzter_teil;
#else
		/* neue User seit dem letzten Login */
		ref_time = user.letzter_login; 
#endif
		use_spec=TRUE;
		ueberschrift="Erster Anruf vor";
	}
	else if (!strcmp(para,"*"))
	{
		set_status_line("Userliste der Box:");
	}
	else if (isdigit(*para))
	{
		seit = TRUE;
		statistik=TRUE;
		bezeich="Neue";
		set_status_line("Neue User in der Box:");
		if (!zerlege_datum_2_time_t(para,&ref_time))
		{
			parameter_falsch("TEILNEHMER",para);
			return FALSE;
		}
		use_spec=TRUE;
		ueberschrift="erster Anruf vor";
	}
	else if (!strnicmp(para,"AKTIV",5))
	{
		long days;
		char *next;
		aktive=TRUE;
		statistik=TRUE;
		bezeich="Aktive";
		if (para[5]=='\0')
			days=28;
		else
		{
			days=strtol(para+5,&next,10);
			if (next==para+5)
			{
				parameter_falsch("TEILNEHMER",para);
				return FALSE;
			}
		}
		use_spec=TRUE;
		ueberschrift = "Letzter Anruf vor";
		aktive_secs = days * 86400L;
		set_status_line("Aktive User in der Box:");
	}
	else if (!strnicmp(para,"INAKTIV",7))
	{
		long days;
		char *next;
		inaktive=TRUE;
		statistik=TRUE;
		bezeich="Inaktive";
		if (para[7]=='\0')
			days=28;
		else
		{
			days=strtol(para+7,&next,10);
			if (next==para+7)
			{
				parameter_falsch("TEILNEHMER",para);
				return FALSE;
			}
		}
		use_spec=TRUE;
		ueberschrift = "Letzter Anruf vor";
		inaktive_secs = days * 86400L;
		set_status_line("Inaktive User in der Box:");
	}
	else if (!strnicmp(para,"PASSWORT",8))
	{
		long days;
		char *next;
		pw_dat=TRUE;
		statistik=TRUE;
		bezeich="User mit altem Passwort"; /* Hm. Bessere Lsung gesucht */
		if (user.level < 8)
		{
			mboutput("\r\n");
			mboutput(" Spielplatz erst fr Kinder ab 8 freigegeben.\r\n");
			return FALSE;
		}
		if (para[8]=='\0')
			days=90;
		else
		{
			days=strtol(para+8,&next,10);
			if (next==para+8)
			{
				parameter_falsch("TEILNEHMER",para);
				return FALSE;
			}
		}
		use_spec=TRUE;
		ueberschrift="Passwortalter";
		passwort_secs = days * 86400L;
		set_status_line("User mit alten Passwrtern in der Box:");
	}
	else if (!strncmp(para,"+ ",2))
	{
		anrufzahl = (long) strtol(para+2,NULL,10);
		statistik = TRUE;
		if (anrufzahl<0)
		{
			parameter_falsch("TEILNEHMER",para);
			return FALSE;
		}
		else if (anrufzahl==0)
		{
			set_status_line("User, die noch nie angerufen haben:");
			bezeich="Tote";
		}
		else
		{
			char zwi[256];
			sprintf(zwi,"User mit %ld oder mehr Anrufen:",anrufzahl);
			sprintf(hilf,"User mit mehr als %ld Anrufen",anrufzahl);
			bezeich=hilf;
			set_status_line(zwi);
			use_spec=TRUE;
			ueberschrift="Anrufzahl";
		}
	}
	else
	{
		parameter_falsch("TEILNEHMER",para);
		return FALSE;
	}

	mboutput(vt_pos_S(4,1));
	mbprintf(" %s Teilnehmer                      Letzter Anruf    %s%s\r\n",
		vt_S(ATTR_FETT),use_spec ? ueberschrift: "Computer",vt_S(ATTR_OFF));
	mbprintf(" %s\r\n",trennzeile);
	set_scroll_area(2);
	count_crW = 0;


	u.nummer = 0;

	while (ub_walk_user(&u))
	{
		/* Wenn es der User ist, der die Liste aufruft, dann 
		   Attribut setzen (welches auch immer?).
		 */
		BOOLEAN zeige=FALSE;
		long spec=0;
		if (user.nummer == u.nummer)
		{
			u=user; /* damit auch die aktuellen Daten ausgegeben werden */
			if (vtmodeW == T_VT100)
			{
				if (mboutput(vt_S(ATTR_INVERS))==-1)
					break;
			}
		}
		if (seit)
		{
			if (u.erster_login>=ref_time)
			{
				zeige=TRUE;
				/* Anzahl Tage ermitteln */
				spec=(time(NULL)-u.erster_login) / 86400L;
			}
		}
		else if (zahler)
		{
			if (u.bezahlt)
				zeige=TRUE;
		}
		else if (level>=0)
		{
			if (u.level==level)
				zeige=TRUE;
		}
#if 0
		else if (!strcmp(u.name,para) || !*para)
		{
			if (!bezahltB)
			{
				mbprintf(" %c%-31.31s %s   %s\r\n",
						(u.bezahlt) ? '$' : ' ',
						u.name,datum_zeit_string(&u.letzter_login),u.computer);
			}
		}
#endif
		else if (anrufzahl>0)
		{
			if ((long) u.anrufe > anrufzahl)
			{
				zeige++;
				spec=u.anrufe;
			}
		}
		else if (anrufzahl==0)
		{
			if (u.anrufe==0)
				zeige++;
		}
		else if (inaktive)
		{
			if (u.letzter_login<time(NULL)-inaktive_secs)
			{
				zeige++;
				spec=(time(NULL)-u.letzter_login)/86400L;
			}
		}
		else if (aktive)
		{
			if (u.letzter_login>=time(NULL)-aktive_secs)
			{
				zeige++;
				spec=(time(NULL)-u.letzter_login)/86400L;
			}
		}
		else if (pw_dat)
		{
			if (u.passwortdatum<time(NULL)-passwort_secs)
			{
				spec=(time(NULL)-u.passwortdatum)/86400L;
				zeige++;
			}
		}
		else
		{
			/* Keine Flags -> Alles */
			zeige++;
		}
		if (zeige)
		{
			int ret;
			if (use_spec)
				ret=mbprintf(" %c%-31.31s %s   %ld\r\n",
					(u.bezahlt) ? '$' : ' ',
					u.name,datum_zeit_string(&u.letzter_login),spec);
			else
				ret=mbprintf(" %c%-31.31s %s   %s\r\n",
					(u.bezahlt) ? '$' : ' ',
					u.name,datum_zeit_string(&u.letzter_login),u.computer);
			count++;
			if (ret<0)
				break;

			if ((zahler || mit_zahlerdatum) && u.bezahlt) 
			{
				mbprintf("    $ bis: %24.24s\r\n",ctime(&u.bezahlt_bis));
			}

			/* Liste mit Adressen ausgeben? */
			if (mit_adr)
			{
				mboutput("    ");
				if (u.plz[0])
					mbprintf("Plz.: %s, ",u.plz);
				if (u.ort[0])
					mbprintf("Ort : %s",u.ort);
				mboutput("\r\n");
				if (u.strasse[0])
					mbprintf("    Str.: %s\r\n",u.strasse);

				if (u.telefon[0])
					mbprintf("    Tel.: %s\r\n",u.telefon);
			}

		}

		if (user.nummer == u.nummer && vtmodeW == T_VT100)
			mboutput(vt_S(ATTR_OFF));

		if (userbreak())
			break;
	}

	if (statistik)
	{
		mboutput("\r\n");
		mbprintf(" Es gibt %d %s von insgesamt %ld Usern,\r\n",
					count,bezeich,ub_userzahl);
		mbprintf(" Das entspricht %d Prozent.\r\n",
				(int)(((100*count/ub_userzahl)*100)/100));
	}

	set_scroll_area(1);
	mboutput("\r\n");

	return TRUE;

} /* bef_teilnehmer */
