/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
*/

#include "tomsysdep.h"

#include <portab.h>
#include <string.h>
#include <stdlib.h>

#include "prototyp.h"
#include "befehle.h"
#include "modem.h"
#include "user.h"
#include "brett.h"
#include "bin_msg.h"

extern USER user;
extern BRETT akt_brett;
extern BRETTNR brettnrW;
extern BRETTINFO *br_ind;

static BOOLEAN umkopieren_binaer(const char *para);



BOOLEAN bef_umkopieren(const char *para)
{
	if (user.typ!=UTYP_USER && brettnrW==0)
	{
		mbfehler("Umkopieren von Nachrichten ist nur Benutzern erlaubt");
		return FALSE;
	}

	if (brettart(brettnrW) == BINAER_BRETT)
		return umkopieren_binaer(para);
	else
	{
		char *p=concat("-W ", para, NULL);
		BOOLEAN ret;
		XNULLCHECK(p);
		ret=bef_kopieren(p);
		free(p);
		return ret;
	}

} /* bef_umkopieren */



/*
	Verschieben von Binrdateien

	06.02.93 Frank
*/
static BOOLEAN umkopieren_binaer(const char *para)
{
	BOOLEAN paraB = FALSE;
	long nr;
	int ok;
	USERNR unr = 0;
	BRETTNR bnr = 0;
	char empfaenger[80];
	char para_altS[80];
	long all;
	FILE *bin_f;
	BIN_MSG bin_info;

	set_status_line("Dateien umkopieren");

	strncpy(para_altS,para,80);

	mbquestion(60,2,TRUE," >> Empfnger: ","",empfaenger);
	strtrim(empfaenger);
	ub_find_username(&unr,empfaenger);
	if (!unr)
		bnr = (ULONG) find_brett(empfaenger);

	if (!unr && !bnr)
	{
		mbfehler("User oder Brett unbekannt");
		return FALSE;
	}
	if (bnr && brettnrW==bnr)
	{
		/* PP -> PP ? ### */
		mbfehler("Umkopieren in gleiches Brett nicht mglich");
		return FALSE;
	}
	if (bnr && !(br_ind[bnr].brett->flags & B_WRITE))
	{
		mbfehler("Ziel-Brett ist schreibgeschtzt");
		return FALSE;
	}
	if (bnr && brettart(bnr) != BINAER_BRETT)
	{
		mbfehler("Binrdateien knnen nicht in Text-Bretter umkopiert werden");
		return FALSE;
	}

	if (!binaer_dat_anzahl(brettnrW,0,&all,NULL,NULL,NULL))
		return FALSE;

	mboutput("\r\n");

	if ((bin_f = binaer_dat_oeffnen(brettnrW,FALSE)) == NULL)
		return FALSE;

	for (ok = lrange(para,&nr); ok && nr > 0; ok = lrange(NULL,&nr))
	{
		if (nr <= 0)
			continue;
		if (nr > all)
			break;

		if (userbreak())
			break;

/*		binaer_dat_lesen(nr);*/
		fseek(bin_f,(nr-1)*sizeof(BIN_MSG),SEEK_SET);
		fread(&bin_info,sizeof(BIN_MSG),1,bin_f);

/*		if (msg_change_access())*/
		if ((user.nummer != akt_brett.grp_chef) && (level() < 9))
		{
			mbfehler("Datei kann nicht umkopiert werden");
			continue;
		}

		if (!fileexist(tprintf("%s%ld.bin",brettpfad(brettnrW),bin_info.nr)))
		{
			mbfehler("Datei auf Speichermedium nicht vorhanden");
			continue;
		}

		if (binaer_dat_kopieren(brettnrW,bnr,bin_info.lokal)
		&&  binaer_dat_loeschen(brettnrW,bin_info.lokal))
			mbprintf(" -> Datei Nr. %ld umkopiert\r\n",nr);

		bb_update_brett(bnr);

		paraB = TRUE;
	}
	binaer_dat_schliessen(bin_f);

	if (bnr)
	{
		bb_update_brett(bnr);
	}
	mboutput("\r\n");

	if (!paraB)
	{
		parameter_falsch("UMKOPIEREN",para_altS);
		return FALSE;
	}
	else
		return TRUE;

} /* umkopieren_binaer */


