# mausfkt.tcl: Hilfsfunktionen fr die Mausoberflche
#
#   Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#   Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
#      Snail Mail (don't expect me to answer):
#            Uwe Ohse
#            Drosselstrae 2
#            47055 Duisburg
#            Germany
#   Contact2: MausNet Newsgroups Quark & Q-Sysops.
#

#
# Eine Menzeile ausgeben.
#
proc menuentry { off string } {
	global MENUEHIGHLIGHT MENUECOLOR
	if [regexp {\(.\)} $string klammer] {
		set zeichen [string range $klammer 1 1]
		set highlight ""
		set aus ""
		if {$MENUEHIGHLIGHT > ""} {
			set highlight "$highlight[tom_vt $MENUEHIGHLIGHT]"
			set aus [tom_vt "off"]
		}
		if {$MENUECOLOR > ""} {
			set highlight "$highlight[tom_vt $MENUECOLOR]"
			set aus [tom_vt "off"]
		}
		regsub -nocase {(\(.\))} $string "($highlight$zeichen$aus)" new
	} else {
		set new $string

	}

	return [tom_puts "[format {%*.*s} $off $off " "] $new"]
}

#
# Menhilfe (lang) anzeigen. 
#
proc do_help { off l } {
	set i 0

	tom_puts ""
	foreach var $l {
		if {[tom_charavail] == 1} return
		menuentry $off "$var"
	}
	tom_puts ""
}

proc menuselect { auswahlstr } {
	global logout_modus
	# tom_puts "$auswahlstr"
	tom_puts -nonewline "Eingabe: " 
	set auswahlstr [string toupper "$auswahlstr"]
	while (1) {
		if {$logout_modus > 0 } { return "" }
		set var [string toupper [tom_getchar]]
		set ind [string first "$var" "$auswahlstr"]
		if { $ind != -1 } {
			tom_puts ""
			return [string index $auswahlstr $ind]
		}
	}
}

proc wait_after { } {
	global terminaltyp
	if {$terminaltyp} {
		tom_puts -nonewline "Weiter mit beliebiger Taste\r"
		tom_getchar
		tom_puts -nonewline "                           \r"
	}
}

#
# Ein Men bearbeiten
#
proc work_menu { titel helpfkt} {
	global menuestil
	global terminaltyp
	global logout_modus

	if {$terminaltyp} {
		tom_befehl "CLscreen"
		tom_puts "" 
		tom_puts "" 
	} else {
		tom_puts "" 
	}

	if {$menuestil} {
		tom_puts "$titel :"
	} else {
		tom_puts -nonewline "$titel : "
	}

	set auswahlstr [string toupper [$helpfkt 4 $menuestil]]

	while (1) {
		if { $logout_modus > 0 } { return "" }
		if {$menuestil} {
			tom_puts -nonewline "Ihre Eingabe:"
		}
		set var [string toupper [tom_getchar]]
		if {![string compare $var "?"]} {
			$helpfkt 0 1
			tom_puts "$titel :"
		} else {
			tom_puts ""
			set ind [string first "$var" "$auswahlstr"]
			if { $ind != -1 } {
				tom_puts ""
				return [string index $auswahlstr $ind]
			} else {
				tom_puts "$titel :"
			}
			$helpfkt 4 $menuestil
		}
	}

	if {$terminaltyp} {
		tom_befehl "CLscreen"
	}
}

proc define_extern_progteil { beschreibung kommando } {
	global pt_xprogteilzahl pt_xprogteil
    regexp {\(.\)} $beschreibung klammer
	set pt_xprogteil($pt_xprogteilzahl,text) "$beschreibung"
	set pt_xprogteil($pt_xprogteilzahl,kommando) "$kommando"
	set pt_xprogteil($pt_xprogteilzahl,key) \
		[string range $klammer 1 1]
    incr pt_xprogteilzahl
}

proc define_progteil { beschreibung verzeichnis } {
	global pt_progteilzahl
	global pt_progteil
    regexp {\(.\)} $beschreibung klammer
	set pt_progteil($pt_progteilzahl,text) "$beschreibung"
	set pt_progteil($pt_progteilzahl,dir) "$verzeichnis"
	set pt_progteil($pt_progteilzahl,key) \
		[string range $klammer 1 1]
    incr pt_progteilzahl
#    tom_puts "$pt_progteilzahl programmteile"
}

proc define_pt_mailadr {dir add} {
	global pt_mailadrzahl pt_mailadr
	set pt_mailadr($pt_mailadrzahl,dir) "$dir"
	set pt_mailadr($pt_mailadrzahl,adr) "$add"
    incr pt_mailadrzahl
}
proc define_pt_acc {dir r w acl} {
	global pt_acczahl pt_acc
	set pt_acc($pt_acczahl,dir) "$dir"
	set pt_acc($pt_acczahl,r) "$r"
	set pt_acc($pt_acczahl,w) "$w"
	set pt_acc($pt_acczahl,acl) "$acl"
    incr pt_acczahl
}

proc pt_get_mailadr {dir} {
	global pt_mailadrzahl pt_mailadr
	if {$pt_mailadrzahl} {
		for {set i 0} {$i <$pt_mailadrzahl} {incr i} {
			if {1==[string match $pt_mailadr($i,dir) $dir]} {
				return $pt_mailadr($i,adr)
			}
		}
	}
	return "sysop"
}

proc define_tauschsoft { beschreibung helpfile files} {
	global pt_tauschsoftzahl pt_tauschsoft
    regexp {\(.\)} $beschreibung klammer
	set pt_tauschsoft($pt_tauschsoftzahl,text) "$beschreibung"
	set pt_tauschsoft($pt_tauschsoftzahl,helpfile) "$helpfile"
	set pt_tauschsoft($pt_tauschsoftzahl,files) "$files"
	set pt_tauschsoft($pt_tauschsoftzahl,key) \
		[string range $klammer 1 1]
    incr pt_tauschsoftzahl
}

proc define_infofile { menue kuerzel beschreibung } {
    global lokalinfozahl lokalinfofile
    global mausnetinfozahl mausnetinfofile
    global proginfozahl proginfofile
    regexp {\(.\)} $beschreibung klammer
    if { $menue == "lokal" } {
        set lokalinfofile($lokalinfozahl,text) "$beschreibung"
        set lokalinfofile($lokalinfozahl,kuerzel) "$kuerzel"
        set lokalinfofile($lokalinfozahl,key) \
            [string range $klammer 1 1]
        incr lokalinfozahl
    } elseif { $menue == "prog" } {
        set proginfofile($proginfozahl,text) "$beschreibung"
        set proginfofile($proginfozahl,kuerzel) "$kuerzel"
        set proginfofile($proginfozahl,key) \
            [string range $klammer 1 1]
        incr proginfozahl
    } elseif { $menue == "mausnet" } {
        set mausnetinfofile($mausnetinfozahl,text) "$beschreibung"
        set mausnetinfofile($mausnetinfozahl,kuerzel) "$kuerzel"
        set mausnetinfofile($mausnetinfozahl,key) \
            [string range $klammer 1 1]
        incr mausnetinfozahl
    } else {
        tom_puts "unbekanntes Infofilemenu $menue"
        return
    }
}

proc append_entry { auswahl liste text} {
    upvar $auswahl a
    upvar $liste l
    regexp {\(.\)} $text key
    set key [string range $key 1 1]
    set a "$a$key"
    lappend l "${text}"
}

proc kurz_menue_hilfe {str} {
    for {set i 0} {$i < [string length $str]} {incr i} {
        if {$i>0} {
            tom_puts -nonewline ","
        }
        tom_puts -nonewline [string range $str $i $i]
    }
    tom_puts ",?"
}

proc getgroupname { } {
	if { ![tom_getvar "%gn"] } {
		set gname "Postfach"
		# Wenn im Programmfach, dann wechseln
		if { [string compare [tom_getvar "postfach_art"] "PM"] } {
			tom_befehl "Postfach"
		}
	} else {
		set gname [tom_getvar "%gN"]
	}
	return $gname
}


proc readfile { fname } {
	set text ""
	set i 0
	if {0==[catch {set id [open $fname "r"]} errt]} {
		set text [read $id]
		close $id
	}
	return $text
}
