# main.tcl: Hauptmen der Mausoberflche
#
#   Copyright (C) 1995, 1996 Uwe Ohse
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#   Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
#      Snail Mail (don't expect me to answer):
#            Uwe Ohse
#            Drosselstrae 2
#            47055 Duisburg
#            Germany
#   Contact2: MausNet Newsgroups Quark & Q-Sysops.
#
#
proc mainmenuhelp { off lang } {
	global programmteilcmd
	global SCHNELLOGOUT TRENNSTRICHE
	set erlaubt ""
	set addon ""
	set auswahl ""

	append_entry auswahl liste "(I)nformationen und Hilfe"
	append_entry auswahl liste "Mitteilungen (A)brufen"
	append_entry auswahl liste "Mitteilungen (E)ingeben"
	append_entry auswahl liste "(B)enutzerliste ansehen"
	append_entry auswahl liste "(H)ilfsfunktionen"
	append_entry auswahl liste "(P)rogrammteil"
	if [string compare "0" [tom_getvar "%ul"]] {
		append_entry auswahl liste "Neu-(L)ogin"
	} else { 
		append_entry auswahl liste "Als Ben(U)tzer eintragen"
	}
	append_entry auswahl liste "Quark(M)eter"
	if {0==[string compare "9" [tom_getvar "%ul"]]} {
		append_entry auswahl liste "(N)ur fr Sysops"
	}
	append_entry auswahl liste "(G)ruppenverwaltung"
	append_entry auswahl liste "(K)ommunikation mit dem Sysop (Chat)"
	append_entry auswahl liste "Maus(T)ausch"
	append_entry auswahl liste "(Q)uarkoberflche"
	append_entry auswahl liste "(S)chlu"

	if {$lang} {
		do_help $off $liste
		return "${auswahl}"
	}

	kurz_menue_hilfe "$auswahl"
	return "$auswahl?"
}

proc mainmenu { } {
	global programmteilcmd
	global logout_modus

	while { 1 } {
		if {$logout_modus } { return }
		set wahl [work_menu "Hauptmen" mainmenuhelp]

		if { "$wahl" == "Q"  } {
			return
		} elseif { "$wahl" == "I" } {
			do_infomenu infos
		} elseif { "$wahl" == "A" } {
			abrufmenu
		} elseif { "$wahl" == "B" } {
			tom_befehl "TEILNEHMER *"
			wait_after
		} elseif { "$wahl" == "E" } {
			eingabemenu
		} elseif { "$wahl" == "H" } {
			hilfsfktmenu
		} elseif { "$wahl" == "M" } {
			quarkmetermenu
		} elseif { "$wahl" == "L" } {
			tom_puts "Neu einloggen"
			tom_befehl RELOGIN
		} elseif { "$wahl" == "N" } {
			if [string compare "9" [tom_getvar "%ul"]] {
				tom_puts "Bitte?"
			} else {
				sysopmenu
			}
		} elseif { "$wahl" == "P" } {
			# tom_befehl "$programmteilcmd"
			pt_mainmenu
			#progmenu
		} elseif { "$wahl" == "S" } {
			tom_befehl LOGOUT
		} elseif { "$wahl" == "T" } {
			tom_befehl TAUSCH
		} elseif { "$wahl" == "U" } {
			tom_befehl USERANTRAG
		} elseif { "$wahl" == "K" } {
			tom_befehl CHAT
			wait_after
		} elseif { "$wahl" == "G" } {
			gruppenmenu
		} else { 
			tom_puts "????" 
		}
	} 
}

#
# Hauptprogramm
#
set mausmainmenuflag 1

source $tomtcl_dir/maus/_functions.tcl
source $tomconfig_dir/mausconf.tcl
source $tomtcl_dir/maus/quarkmeter.tcl
source $tomtcl_dir/maus/gruppen.tcl
source $tomtcl_dir/maus/hilfsfunktionen.tcl
source $tomtcl_dir/maus/informationen.tcl
source $tomtcl_dir/maus/sysop.tcl
source $tomtcl_dir/maus/abruf.tcl
source $tomtcl_dir/maus/eingabe.tcl

source $tomtcl_dir/maus/pt_main.tcl
unset mausmainmenuflag

mainmenu

