/* call_sys_prg.c : Programme in tom/bin starten. */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/

#include <portab.h>
#include <stdlib.h>
#include <stdio.h>
#include <limits.h>
#include <string.h>

#include "tomsysdep.h"
#include "tompaths.h"
#include "box_conf.h"
#include "prototyp.h"

/*
	Systemprogramm ausfhren

	Systemprogramme befinden sich grundstzlich in tom/bin

	18.01.93 Frank
	14.02.93 Frank

	->			prg	:	Programmname inkl. Pfad
				cmd	:	Kommandozeile bzw. NULL
*/
int call_system_prg(const char *prg,const char *cmd)
{
	char *programm=NULL;

	asprintf(&programm,"%s%s %s",box_conf.bin_dir,prg,cmd);
	XNULLCHECK(programm);
	return call_extern(programm,
		NULL,                 /* spezielles Arbeitsverzeichnis */
		time(NULL)+600,       /* killzeitpunkt,just for the case */
		FALSE,                /* ignore_exitcode */
		FALSE);               /* nicht unter der uid des aufrufenden Users */
} /* call_system_prg */

