/* cmd.h : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#ifndef CMD_H
#define CMD_H

/*
	Beschreibung des Befehlsformates als Struktur

	"S|SUchenabcdef/{*}       |SUCHEN      /{*}       |  23456789 | |?|B|-|",

*/

#define CMDPARA_BRETT      0x01
#define CMDPARA_USER       0x02
#define CMDPARA_MESSAGENR  0x04

typedef struct box_cmd_t
{
	char *name_ext;
	char *para_ext;
	char *name_int;
	char *para_int;
	char *optionen;
	BOOLEAN level[ULV_MAX+1];
	BOOLEAN systembefehl;
	BOOLEAN auch_chef;          /* Unabhngig von Lv. auch dem Chef erlaubt? */
	BOOLEAN nur_chef;          /* Unabhngig von Lv. auch dem Chef erlaubt? */
	BOOLEAN nur_zahler;         /* Nur fr Zahler? */
	BOOLEAN fragezeichen;       /* Bei ? anzeigen */
	BOOLEAN batch_freigabe;     /* Einsatz im Batch erlaubt? */
	BOOLEAN hilfe;              /* obsolet, unbeachtet */
	BOOLEAN ist_relogin_cmd;    /* dies ist RELOGIN. Optimierung, mehr nicht */
	char *acl;                  /* Access Control List */
	char *acltype;              /* und Zugriffstyp */
	short parameter_hint;       /* fr completion */

	struct box_cmd_t *next;

} box_cmd_t;

#define COMMAND_ALLOWED(bef,lv) \
    ((bef->level[lv] \
    || (bef->auch_chef && user.nummer == akt_brett.grp_chef) \
    || (akt_anruf.ist_relogin && box_conf.relogin_for_relogins \
    && bef->ist_relogin_cmd)) \
    && (!bef->nur_chef || (user.nummer==akt_brett.grp_chef || lv==9)) \
    && (!bef->acl || acl_check(bef->acl,user.name,level(),\
        bef->acltype ? *bef->acltype : '\0', NULL)))

box_cmd_t *befehl_find(const char *cmd, const char *para);
box_cmd_t *befehl_get_anker(void);

#endif
