/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact1: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#ifndef QUARK_IO_H
#define QUARK_IO_H
/*
	IO-Routinen
*/
extern int user_in_fd;
extern int user_out_fd;
extern int sysop_in_fd;
extern int sysop_out_fd;

BOOLEAN io_charavail(int device);
BOOLEAN io_test_carrier(int fd);

BOOLEAN io_set_baud(int fd, unsigned long baud);
	/* to be called ONLY ONCE! */
BOOLEAN io_mode_work(int fd, BOOLEAN getty_mode);
	/* Terminaleinstellungen fr externe Programme */
BOOLEAN io_mode_sane(int fd);
	/* RTS/CTS irgendwie anschalten. Aus io_mode_work ausgegliedert, weil
	 * das scheulich aussah 
	 */
BOOLEAN io_set_handshake(int fd);
BOOLEAN io_set_cr_mapping(int fd, BOOLEAN crnl);
	/* Speichern vor Aufruf externer Programm, subern danach */
BOOLEAN io_save_restore_attribs(int fd, BOOLEAN save);

	/* Terminaleinstellungen von stdin am Programmende zurcksetzen */
void io_save_stdin(void);
void io_restore_stdin(void);

void io_flush(int fd);
void io_drain(int fd);

void io_send_break(int fd);

BOOLEAN io_set_ECHO(int fd, BOOLEAN on);
BOOLEAN io_set_ONLCR(int fd, BOOLEAN on);
BOOLEAN io_set_ICRNL(int fd, BOOLEAN on);
BOOLEAN io_set_IGNCR(int fd, BOOLEAN on);
BOOLEAN io_set_INLCR(int fd, BOOLEAN on);
BOOLEAN io_set_CLOCAL(int fd, BOOLEAN on);
BOOLEAN io_set_DTR(int fd, BOOLEAN on);
BOOLEAN io_set_ISIG(int fd, BOOLEAN on);



void io_tty_test(int fd);
void io_change_term_size (int fd, int xsize, int ysize);
BOOLEAN io_get_term_size (int fd, int *xsize, int *ysize);
	/* TRUE: fd zeigt auf Modemdevice, 
	 * FALSE: zeigt nicht (oder dies ist nicht feststellbar)
	 */
BOOLEAN io_test_modem_lines(int fd);


#define RESIZE_MODE_NORMAL    0
#define RESIZE_MODE_INQUIRE   1
#define RESIZE_MODE_FORCE_VT  2
#define RESIZE_ANS_OK         0
#define RESIZE_ANS_NOT_TERM   1
#define RESIZE_ANS_NOT_CAP    2
#define RESIZE_ANS_FAILED     3
int io_resize_terminal(int fdin, int fdout, int mode);

size_t xwrite_tty(int fd, const char *data, size_t count);

#endif
