/* itbcompile.h : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#ifndef ITBCOMPILE_H
#define ITBCOMPILE_H

#ifndef __PORTAB__
typedef char BOOLEAN;
#define TRUE (1)
#define FALSE (0)
#endif

struct telefon {
	char *nummer;
	BOOLEAN geheim;
	char *art;
	struct telefon *next;
};

struct boxdomain {
	char *name;
	struct boxdomain *next;
};
struct boxgate {
	char *name;
	char *allowed;
	struct boxgate *next;
};

struct list {
	char *text;
	struct list *next;
};

struct link {
	char *kuerzel;
	long kosten;
	struct link *next;
};

struct box {
	char *name;                   /* N */
	char *kuerzel;                /* * */
	long nummer;                  /* # */
	char *serverkuerzel;          /* - */
	struct telefon *telefon;      /* T oder t ] */
	struct boxdomain *primdomain; /* D */
	struct boxdomain *secdomain;  /* Z */
	struct boxgate *gateways;    /* G */
	struct box *next; 

	struct list *userinfo;
	struct list *userinfo_last;
	struct list *sysopinfo;
	struct list *sysopinfo_last;

	BOOLEAN got_domain;
	BOOLEAN fremdbox;

	/* abgeleitete Daten */
	struct box *up;
	struct box *down;
	struct box *left;
	struct box *right;
	long upkosten;

	long kosten;                  /* hopcount */
	struct box *best_way;
};

extern struct box *box_anker;

extern struct link *links;

extern struct box *top;

#endif
