/* lock_loop.c: still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#include "tomsysdep.h"
#include <portab.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <sys/types.h>

#include "prototyp.h"
#include "lockfile.h"

int 
lock_loop(time_t timeout, time_t sleeptime, int sleepmode,
    const char *filename, int *fatal)
{
	time_t real_st;
	int f=0;
	time_t start;

	if (timeout)
		time(&start);

	real_st=sleeptime;
	while (lock_create(filename,&f))
	{
		if (f)
		{
			if (fatal)
				*fatal=f;
			return -1;
		}
		if (timeout && time(NULL)-start>timeout)
			return -1;
		if (sleepmode==1)
			real_st+=real_st/2;
		else if (sleepmode==2)
			real_st*=2;
		else if (sleepmode>2)
			real_st+=sleepmode;
		sleep(real_st);
	}
	return 0;
}
