/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
*/

#include "tomsysdep.h"

#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <limits.h>
#include <errno.h>
#include <syslog.h>
#include <signal.h>
#include <sys/time.h>

#include <portab.h>

#include "prototyp.h"
#include "argument.h"
#include "box_conf.h"
#include "log.h"
#include "protokoll.h"
#include "aktdata.h"
#include "lockfile.h" /* libquark */

extern BOOLEAN tom_locked;

BOOLEAN
lock_tom(int max_tries)
{
	char fname[PATH_MAX];
	time_t sleep_time=1;
	int err;
	int versuche=0;
	int sleep_count=0;

	strcpy(fname,"LCK..tom");

retry:
	/* Alle Sekunde noch mal nach dem Lockfile sehen */
	err=lock_create(fname,NULL);

	if (max_tries!=-1)
		max_tries--;
	if (err)
	{
		/* pid aus dem Lockfile lesen */
		FILE *f;
		char buf[128];
		pid_t killpid=0;
		versuche++;
		sleep_count++;

		if (err && versuche!=1)
		{
			puts("Box gesperrt?\r");
			fflush(stdout);
		}
		f=fopen(fname,"r");
		if (f && fgets(buf,sizeof(buf),f))
		{
			killpid=(pid_t) strtol(buf,NULL,10);
		}
		if (f)
			fclose(f);
		if (killpid)
		{
			if (argument_urgent && argument_urgent<=time(NULL))
				kill(killpid,SIGUSR2);
			else
				kill(killpid,SIGUSR1);
		}

		/* So, auf ein neues */
		if (max_tries!=0) {
			if (max_tries==-1)
			{
				if (versuche<3)
				{
					msleep(200);
				}
				else
				{
					if (sleep_count<10)
						sleep(sleep_time++);
					else
					{
						sleep_count=0;
						sleep_time=1;
					}
				}
			}
			else
			{
				/* user will rein */
				sleep(1);
			}
			goto retry;
		}
	}

	if (err)
	{
		puts("kann Lockfile nicht anlegen");
		syslog(LOG_INFO,"kann Lockfile nicht anlegen");
		return FALSE;
	}
	tom_locked=TRUE;
	return TRUE;
}
