/* post_fe.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB3 (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
	Offline - MausTausch-FrontEnd

	Message-Posting, FrontEnd-Version
	(c) 1992-95 bei Frank Baumgart

	begonnen am 30.03.1992
	Version vom 22.11.1994
*/


#include "portab.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <limits.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/types.h>

#include "system.h"

#ifdef HAVE_DIRENT_H
# include <dirent.h>
# define NAMLEN(dirent) strlen((dirent)->d_name)
#else
# define dirent direct
# define NAMLEN(dirent) (dirent)->d_namlen
# ifdef HAVE_SYS_NDIR_H
#  include <sys/ndir.h>
# endif
# ifdef HAVE_SYS_DIR_H
#  include <sys/dir.h>
# endif
# ifdef HAVE_NDIR_H
#  include <ndir.h>
# endif
# ifdef HAVE_DIRECT_H
#  include <direct.h>
# endif
#endif

#include "struktur.h"
#include "mdb_conf.h"
#include "frontend.h"
#include "tool.h"
#include "fehler.h"
#include "message.h"
#include "post_fe.h"
#include "screen/io.h"
#include "missing/missing.h"

extern CONFIG config;



static BOOLEAN message_referenz(const char *id);
static void anrede(const char *adresse,const char *name,FILE *msg_f);
static BOOLEAN wildcard(const char *string,const char *pattern);



/*
	persnliche oder ffentliche Antwort oder neue Mail

	->			gh			:	Gruppen-Handle (fr KOMMENTAR, FWD_PM) sonst 0
				typ		:	ANTWORT, KOMMENTAR, NEUE_MSG, NEUE_PM, KOMM_PM, FWD_PM
				off		:	Adressen der einzelnen Headereintrge

	<-			TRUE		:	Msg. ok bzw. leer (fhrte zur Lschung)
				FALSE		:	Msg. fehlerhaft/abgebrochen

	todo:
	gh ist Unsinn, stattdessen entweder eine Datei (besser) oder Puffer (vmtl. 
	schlechter) bergeben
*/
BOOLEAN message(int gh,int typ,OFFSET *off)
{
	char hdr_name[PATH_MAX];
	char msg_name[PATH_MAX];
	char gruppe[MAX_HDR] = "";			/* keep gcc happy */
	BOOLEAN ok;
	FILE *hdr_f;
	FILE *msg_f;
	FILE *foo_f = NULL;
	long lfd_msg_nr;
	BOOLEAN pm;
	BOOLEAN guek = FALSE;				/* gruppenbergreifender Kommentar */

	/* ggf. bestehende Antwort/Kommentar weiterbearbeiten */
	if (config.resume_mail
	&& ((typ == KOMM_PM) || (typ == ANTWORT) || (typ == KOMMENTAR)))
		if (message_referenz(off->id))
			return TRUE;

	pm = (typ == NEUE_PM) || (typ == KOMM_PM) || (typ == ANTWORT);

	/* laufende Message-Nummer ermitteln und sofort updaten */
	sprintf(msg_name,"%smsgnr",config.messages);
	if ((msg_f = fopen(msg_name,"r+")) == NULL)
	{
		lfd_msg_nr = 1;
		msg_f = fopen(msg_name,"w");
	}
	else
	{
		fgets(msg_name,10,msg_f);
		lfd_msg_nr = atol(msg_name) + 1;
		rewind(msg_f);
	}
	if (msg_f)
	{
		fprintf(msg_f,"%ld",lfd_msg_nr);
		fclose(msg_f);
	}

	/*
		ggf. forward-Gruppe ermitteln
	*/
	if ((typ==NEUE_MSG) || (typ==KOMMENTAR))
		strcpy(gruppe,off->group);
	if (typ == KOMMENTAR)
	{
		char itg[PATH_MAX];
		FILE *itg_f;

		strcpy(itg,config.infofiles);
		strcat(itg,"ITG.txt");
		if ((itg_f = fopen(itg,"r")) != NULL)
		{
			BOOLEAN gefunden = FALSE;
			char zeile[256];
			char *p;

			while (!gefunden && fgets(zeile,255,itg_f))
			{
				if (*zeile != 'G')
					continue;
				if ((p = strpbrk(zeile,"\r\n")) != NULL)
					*p = 0;
				if (stricmp(zeile+1,gruppe))
					continue;

				gefunden = TRUE;
				while (fgets(zeile,255,itg_f))
				{
					if (*zeile == 'G')
						break;
					if (*zeile == 'R')
					{
						if ((p = strpbrk(zeile,"\r\n")) != NULL)
							*p = 0;
						mprintf("Kommentar erfolgt in Gruppe <%s>\r\n",zeile+1);
						strcpy(gruppe,zeile+1);
						sleep(1);
						guek = TRUE;
						break;
					}
				}
			}
			fclose(itg_f);
		}
	}


	/*
		Message-Datei anlegen
	*/
	sprintf(msg_name,"%sm%07lu.txt",config.messages,lfd_msg_nr);
	if ((msg_f = fopen(msg_name,"w")) == NULL)
		return FALSE;

	if (typ == KOMM_PM || guek)
		fprintf(msg_f,"Kommentar zu %s in der Gruppe %s" CRLF CRLF,
		off->id,off->group);

	/* bei PMs Anrede einfgen */
	if ((typ==ANTWORT) || (typ==NEUE_PM) || (typ==KOMM_PM))
		anrede(off->author,(off->name) ? off->name : off->author,msg_f);

	/* optional gequotete MSG erzeugen */
	if (config.quote_msg
	&& ((typ==KOMMENTAR) || (typ==ANTWORT) || (typ==KOMM_PM)))
	{
		mputs("Quoting article");
		msg_writequote(gh,msg_f);
	}
	else
	if (typ == FWD_PM)
		;
/*		msg_writefwd(gh,msg_f,adressat);*/

	if ((typ==KOMMENTAR) || (typ==NEUE_MSG))
	{
		sprintf(hdr_name,"%s%s",config.messages,"footer.om");
		foo_f = fopen(hdr_name,"r");
	}
	else
	if ((typ==ANTWORT) || (typ==NEUE_PM) || (typ==KOMM_PM))
	{
		sprintf(hdr_name,"%s%s",config.messages,"footer.pm");
		foo_f = fopen(hdr_name,"r");
	}
	if (foo_f)
	{
		char zeile[256];
		while (fgets(zeile,sizeof(zeile),foo_f))
			fputs(zeile,msg_f);
		fclose(foo_f);
	}
	fclose(msg_f);



	if ((typ != FWD_PM) || (typ == FWD_PM && config.edit_fwd))
	{
		ok = call_editor(msg_name);
		if (!ok)
			return FALSE;
	}
	else
		ok = TRUE;


	/* Nachrichten ohne Inhalt lschen */
	msg_f = fopen(msg_name,"r");
	if (!msg_f || (filesize(msg_f) <= 1))
	{
		if (msg_f)
			fclose(msg_f);
		unlink(msg_name);
		unlink(hdr_name);

		return TRUE;
	}


	/*
		Headerdatei generieren
		- ID, Betreff, Datum/Zeit, Gruppe

		Spezialfall:
		wird an einer Maus getauscht, wird bei Antworten keine Referenz-ID 
		in den Header geschrieben, da die Maus 7.x grundstzlich nur die 
		Referenz-ID auswertet und die Empfngerangabe verwirft
	*/
	sprintf(hdr_name,"%sm%07lu.hdr",config.messages,lfd_msg_nr);
	if ((hdr_f = fopen(hdr_name,BIN_RW_CREATE)) == NULL)
	{
		fclose(msg_f);
		return FALSE;
	}

	/* temporre FrontEnd-ID erzeugen */
	fprintf(hdr_f,"#%s%ld\r\n",(pm) ? "PM" : "OM",lfd_msg_nr);

	/* Gruppen- bzw. Empfngername */
	if ((typ==NEUE_MSG) || (typ==KOMMENTAR))
		fprintf(hdr_f,"G%s\r\n",gruppe);
	else
	if ((typ==NEUE_PM) || (typ==KOMM_PM) || (typ==ANTWORT) || (typ==FWD_PM))
		fprintf(hdr_f,"A%s\r\n",off->author);

	/* ID bei Antworten/Kommentaren */
	/* s.obige Bemerkung zu A-Zeilen bei Antworten mit Referenz-IDs */
	if ((typ==KOMMENTAR) || (typ==ANTWORT) || (typ==KOMM_PM && config.quark))
		fprintf(hdr_f,"-%s\r\n",off->id);

	/* Betreff */
	fprintf(hdr_f,"W%s\r\n",off->topic);

	/* Zeit */
	{
		char zeit[15];
		time_t lct = time(NULL);

		/* z.B. 199205010345 */
		strftime(zeit,15,"%Y%m%d%H%M",localtime(&lct));
		fprintf(hdr_f,"E%s\r\n",zeit);
	}
	fclose(hdr_f);

	return ok;

} /* message */



/*
	User-spezifische Anrede einfgen, sofern konfiguriert

	->			adresse	:	vollst. Adresse, z.B. "godot@uni-paderborn.de"
				name		:	Realname, z.B. "Frank Baumgart, oder NULL
				msg_f		:	in diese Datei wird die Anrede geschrieben
*/
static void anrede(const char *adresse,const char *name,FILE *msg_f)
{
	char datei[PATH_MAX];
	char eintrag[200];
	FILE *anr_f;
	long zeile = 0;				/* akt. Zeilennummer */
	char *anr;						/* Anrede-Formatstring */
	char v[80],n[80];				/* Vorname, Nachname */
	char *p;

	strcpy(datei,config.messages);
	strcat(datei,"anrede.lst");
	if ((anr_f = fopen(datei,"r")) == NULL)
		return;

	while (fgets(eintrag,sizeof(eintrag),anr_f))
	{
		zeile++;
		if (!*eintrag || strchr("#;\r\n",*eintrag))
			continue;
		if ((p = strpbrk(eintrag,"\r\n")) != NULL)
			*p = 0;
		/* nicht-leere Anreden trennen (Adresse(-muster)/Anrede) */
		if ((anr = strchr(eintrag,'\t')) != NULL)
		{
			*anr++ = 0;
			while (isspace(*anr))
				anr++;
		}

		/* Angaben ohne @ gelten fr alle Adress(variant)en */
		if (!strchr(eintrag,'@'))
			strcat(eintrag,"*");

		if (!wildcard(adresse,eintrag))
			continue;

		/* gar keine Anrede ? (z.B. an Daemonen etc.) */
		if (!anr)
			break;

		/* "richtigen" Namen in Vor- und Nachname unterteilen */
		/* ### todo: @ abschneiden */
		if (name)
		{
			strcpy(v,name);
			if ((p = strchr(v,' ')) != NULL)
			{
				*p = 0;
				strcpy(n,p+1);
			}
			else
				*n = 0;
		}

		/* Tokens auflsen */
		while ((p = strchr(anr,'%')) != NULL)
		{
			fprintf(msg_f,"%.*s",(int)(p - anr),anr);
			anr = p+1;
			if (*anr == 'v')
				fprintf(msg_f,"%s",(*v) ? v : "");
			else
			if (*anr == 'n')
				fprintf(msg_f,"%s",(*n) ? n : "");
			else
				fputs("[falsches Token]",msg_f);
			anr++;
		}
		fputs(anr,msg_f);
		fputs(CRLF,msg_f);
		break;
	}
	fclose(anr_f);

} /* anrede */



/*
 * Untersuchen, ob ein String auf den angegebenen Wildcard-Ausdruck mit den
 * Metazeichen '*', '?' pat.
 * Exit: TRUE/FALSE
 */
static BOOLEAN wildcard(const char *string,const char *pattern)
{
    for (; *pattern != '\0'; pattern++, string++)
    {
        switch(*pattern)
        {
        case '*':
            if (*++pattern == '\0') /* '*' am Ende passt immer */
                return(TRUE);
            do  /* Sonst gucken, ob's irgendwo weiter hinten passt */
            {
                if (wildcard(string, pattern))   /* Rekursion */
                    return(TRUE);          /* Bis Match oder ... */
            } while(*string++ != '\0');    /* ... String-Ende */
            return(FALSE);
        case '?':
            if (*string == '\0')           /* Noch was da? */
                return(FALSE);
            break;
        default:                           /* Zeichenmenge? */
            if (*pattern != *string)       /* Direkter Vergleich */
                return(FALSE);
        }
    } /* for */
    return(*string == '\0');               /* Komplett gepasst? */
}



/*
	Datei in externem Editor bearbeiten
*/
BOOLEAN call_editor(const char *datei)
{
	char tmp[PATH_MAX];
	FILE *check;
	long bytes;
	int ret;
	char *p;

	if (!*config.editor)
		if ((config.editor = getenv("EDITOR")) == NULL)
			config.editor = "vi";

	/* Kommando zusammensetzen */
	strcpy(tmp,config.editor);
	if ((p = strstr(config.editor,"%f")) != NULL)
	{
		tmp[p-config.editor] = 0;
		strcat(tmp,datei);
		strcat(tmp,p+2);
	}
	else
	{
		strcat(tmp," ");
		strcat(tmp,datei);
	}

	ret = shell(tmp);
	if (ret == -1)
	{
		fehler(EXEC_ERR);
		return FALSE;
	}

	/* Textdateigre berprfen: zu kleine/leere Dateien werden gelscht */
	if ((check = fopen(datei,"a")) == NULL)
		return FALSE;
	bytes = filesize(check);
	fclose(check);
	if (bytes <= 2)
	{
		unlink(datei);
		return FALSE;
	}

	if (bytes > 16000)
	{
		puts("Achtung: derzeit knnen nur Quark II Mailboxen Mails > 16 kB verarbeiten");
		taste();
	}

	return TRUE;

} /* call_editor */



/*
	feststellen, ob eine Nachricht bereits beantwortet/kommentiert wurde
	falls ja, wird angeboten, die Antwort bzw. Kommentar zu laden und 
	weiter zu bearbeiten

	->			id		:	Referenz-ID, ohne CR/LF

	<-			TRUE	:	bestehende Antwort/Kommantar wurde bearbeitet
				FALSE	:	neue Antwort/Kommentar wurde gewnscht
*/
static BOOLEAN message_referenz(const char *id)
{
	char hdr_name[PATH_MAX];
#if defined(__WATCOMC__)
	char ts[PATH_MAX];
#endif
	DIR *dir;
	struct dirent *entry;

	/* berblick ber Nachrichten im messages-Verzeichnis verschaffen */
#if defined(__WATCOMC__)
	strcpy(ts,config.messages);
	strcat(ts,"*.*");
	if ((dir = opendir(ts)) == NULL)
#else
	if ((dir = opendir(config.messages)) == NULL)
#endif
		return FALSE;
	while ((entry = readdir(dir)) != NULL)
	{
		/* Header-Dateien auslesen */
#if defined(__WATCOMC__)
		strlwr(entry->d_name);
#endif
		if ((entry->d_name[0] == 'm') && (atoi(entry->d_name+1))
		&& (strlen(entry->d_name) == strlen("m0000001.hdr"))
		&& (!strcmp(entry->d_name+9,"hdr")))
		{
			char zeile[MAX_HDR];
			char empfaenger[MAX_HDR];
			char betreff[MAX_HDR];
			char referenz[MAX_HDR];
			BOOLEAN pm = FALSE;				/* keep gcc happy */
			FILE *hdr_f;
			char *p;

			*empfaenger = *betreff = *referenz = 0;
			strcpy(hdr_name,config.messages);
			strcat(hdr_name,entry->d_name);
			if ((hdr_f = fopen(hdr_name,"r")) == NULL)
				continue;
			fgets(zeile,sizeof(zeile),hdr_f);

			/* Empfnger bzw. Gruppe */
			do
			{
				if (!fgets(zeile,sizeof(zeile),hdr_f))
					break;
				if ((p = strpbrk(zeile,"\r\n")) != NULL)
					*p = 0;

				switch (*zeile)
				{
					case 'A':
						strcpy(empfaenger,zeile+1);
						pm = TRUE;
						break;

					case 'G':
						strcpy(empfaenger,zeile+1);
						pm = FALSE;
						break;

					case 'W':
						strcpy(betreff,zeile+1);
						break;

					case '-':
						strcpy(referenz,zeile+1);
						break;
				}
			}
			while (!*empfaenger || !*betreff);
			fclose(hdr_f);

			if (!strcmp(referenz,id))
			{
				mprintf(" %-32s %-40s\r\n",empfaenger,betreff);
				if (pm)
					mputs("bereits vorhandene Antwort weiterbearbeiten ? (j/n)");
				else
					mputs("bereits vorhandenen Kommentar weiterbearbeiten ? (j/n)");
				if (taste() == 'j')
				{
					char msg_name[PATH_MAX];

					mputs("ja");
					strcpy(msg_name,hdr_name);
					msg_name[strlen(msg_name)-3] = 0;
					strcat(msg_name,"txt");
					(void) call_editor(msg_name);
					closedir(dir);
					return TRUE;
				}
				else
					mputs("nein");
			}
		}
	}
	closedir(dir);

	return FALSE;

} /* message_referenz */
