/* loeschen.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB3 (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
	Offline - MausTausch-FrontEnd

	Lsch-Routinen
	(c) 1992-95 bei Frank Baumgart

	begonnen am 02.04.1992
	Version vom 27.01.1995
*/


#include "portab.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <limits.h>
#include <unistd.h>

#include "system.h"
#include "mdb_conf.h"
#include "struktur.h"
#include "mdb_glob.h"
#include "mdb_intr.h"
#include "msgid.h"
#include "message.h"
#include "screen/io.h"
#include "tool.h"
#include "fehler.h"
#include "puffer.h"

extern CONFIG config;


/*
	Positionsbestimmung innerhalb einer Gruppe
	Angabe von Nummer, Zeit/Datum oder Msg.ID
*/


static void loesche_verkettung(INDEX *ix,MESSAGE max_nr);

static long anz_gel_om = 0;		/* Anzahl gelschter OMs */
static long anz_gel_pm = 0;		/* dito PMs */



/*
	alle Gruppen oder User putzen

	->			pm		:	User (TRUE) oder Gruppe (FALSE)
				immer	:	putze_immer (TRUE) oder putze_gruppe (FALSE)

	<-			TRUE	:	ok
				FALSE	:	abgebrochen
*/
BOOLEAN mdb_putze_alles(BOOLEAN pm,BOOLEAN immer)
{
	BOOLEAN ok = TRUE;
	char name[MAX_CPG];
	time_t startzeit;
	long old = config.min_putz;;

	startzeit = time(NULL);
	anz_gel_om = anz_gel_pm = 0;

	if (!open_grplst(pm))
		return FALSE;

	if (immer)
		config.min_putz = 0;

	while (read_grplst(name))
	{
		mputs(name);
		ok = mdb_putze_gruppe(name,pm,immer,NULL);
	}
	close_grplst();

	if (immer)
		config.min_putz = old;

	if (ok)
		mputs("\nDatenbankputz fehlerlos\n");

	if (config.putz_log)
	{
		char datei[PATH_MAX];
		FILE *putz_f;
		time_t endzeit = time(NULL);

		sprintf(datei,"%s%s%s.log",config.log,"pt",yymmdd());
		if ((putz_f = fopen(datei,"a")) != NULL)
		{
			char zeile[80];

			strftime(zeile,70,"Putz am: %A, %d. %B %Y, %H:%M - ",localtime(&startzeit));
			fputs(zeile,putz_f);
			strftime(zeile,20,"%H:%M\r\n",localtime(&endzeit));
			fputs(zeile,putz_f);
			fprintf(putz_f,"%ld OMs , %ld PMs\r\n\r\n",anz_gel_om,anz_gel_pm);
			fclose(putz_f);
		}
	}

	return ok;

} /* mdb_putze_alles */



/*
	Putzen
	zu lschende und teilzulschende Datenstze in einer Gruppe 
	entfernen und Index- und Datendatei neu aufbauen

	- ein evtl. in der kommentierten Mail gespeicherter Index des 
	  LETZTEN Kommentares wird bereits bearbeitet (?)

	->			name	:	Name der zu putzenden Gruppe/User
				pm		:	TRUE = PM , FALSE = Gruppe
				immer	:	unabh. von Anzahl zu lschender Mails immer putzen (TRUE)

	<-			FALSE	:	Fehler aufgetreten
				TRUE	:	alles ok

	Fehlermglichkeiten:
	- Datei enthlt keine Datenstze
	- Zugriff auf DB ist gesperrt
	- zuwenig Speicher fr Verweispuffer
	- zuwenig externer Speicher
*/
BOOLEAN mdb_putze_gruppe(const char *name,BOOLEAN pm,BOOLEAN immer, BOOLEAN *dummy)
{
	char ind_name[PATH_MAX],
	     dat_name[PATH_MAX];
	char i_t_name[PATH_MAX],
	     d_t_name[PATH_MAX];
	FILE *dat_f;					/* alte Datendatei */
	FILE *ind_tmp,					/* tmp. Dateien fr aktualisierte Gruppe */
	     *dat_tmp;					/* fr Index- und Datendatei */
	char id[MAX_HDR];				/* ID der akt. Nachricht, wg. Ref-DB */
	KENNUNG kennung;
	INDEX ix;
	GLOBAL_REF gref;				/* neue Referenz */
	ULONG pos_offset = 0;		/* Anpassung der Textposition */
	MESSAGE nr_akt = 0,			/* aktuelle und sptere Indexnummer */
	        nr_neu = 0,
	        max_nr;				/* maximale Indexnummer, zur Kontrolle */
	MESSAGE msgs;					/* Anzahl Messages in der Gruppe */
	MESSAGE geloescht = 0;		/* Anzahl gelschter Messages */
	MESSAGE ungelesen = 0;		/* jetzt noch ungelesen */
	MESSAGE count;					/* Messagezhler */
	BOOLEAN ok = TRUE;			/* Flag, ob Putzen erfolgreich */
	char *buf;						/* Message-Puffer */
	BOOLEAN konsistent = TRUE;	/* kein Verdacht auf kaputte Indexdaten */
	long next = 0;					/* Erwartete nchste Position */
	long gnr;						/* Gruppen/Usernummer */

	struct VERWEIS
	{
		MESSAGE nummer;			/* neue Nummer */
		BOOLEAN putzen;			/* Putzen ja/nein */

	} *verweis;						/* Zeiger auf Verweispuffer */


	/*
		Falls die DB gelockt ist, wird nicht auf Freigabe gewartet, da das 
		lange dauern knnte. Eigentlich ist es aber Aufgabe des Schedulers, 
		den Putz nur fr "freie" Gruppen aufzurufen.
	*/
	if (!group_lock(name,pm,FALSE))
		return FALSE;

	/* feststellen, ob berhaupt (genug) Datenstze zu lschen sind */
	if (!group_info(name,pm,&kennung))
	{
		group_unlock(name,pm);
		return FALSE;
	}
	/*
		lohnt sich das Putzen ?
		todo:
		im Boxbetrieb erstmal abwarten, was die PM-Lschungen ergaben/ergeben
	*/
	if (
	!immer &&
#ifdef BOX
	!pm &&
#endif
	   ((kennung.min_putz && (kennung.min_putz > kennung.putzen))
	|| (!kennung.min_putz && (config.min_putz) && (kennung.putzen < config.min_putz))
	|| (!kennung.putzen)))
	{
		group_unlock(name,pm);
		return TRUE;
	}

	/* Pfade holen */
	if ((gnr = group_path(name,dat_name,pm)) < 0)
	{
		group_unlock(name,pm);
		fehler(NO_GROUP);
		return FALSE;
	}
	strcpy(ind_name,dat_name);
	strcat(ind_name,"ind");
	strcat(dat_name,"dat");

	/* Puffer fr Messagetext */
	if ((buf = (char *) malloc(MSG_SIZE)) == NULL)
	{
		group_unlock(name,pm);
		fehler(NO_MEMORY);
		return FALSE;
	}

	/* Index- und Datendatei der entsprechenden Gruppe ffnen */
	if (!i_open(ind_name))
	{
		free(buf);
		group_unlock(name,pm);
		return FALSE;
	}

#ifdef BOX
	/*
		ungelesene/ungetauschte PMs nach "KillUnread"
		gelesene/ungetauschte PMs nach "KillRead"
		getauschte PMs nach "KillExported"
		Tagen lschen.
		Wenn die CNF-Variablen nicht gesetzt sind, sparen wir uns den Durchlauf
	*/
	if (pm && (config.kill_exported || config.kill_read || config.kill_unread))
	{
		time_t jetzt = time(NULL);
		time_t day = 60L*60*24;		/* Sekunden pro Tag */
		BOOLEAN kill;
		BOOLEAN changed = FALSE;

		msgs = i_anzahl();
		i_read(&kennung,sizeof(KENNUNG));
		while (msgs--)
		{
			if (!i_read(&ix,sizeof(INDEX)))
				break;
			if (ix.flags & (TOTAL | GESCHUETZT | DEFEKT))
				continue;
			kill = FALSE;

			/* exportiert? (getauscht) */
			if (config.kill_exported
			&& ix.getauscht
			&& (jetzt - ix.getauscht)/day > config.kill_exported)
				kill = TRUE;
			else
			/* gelesen und ungetauscht? */
			if (config.kill_read
			&& !ix.getauscht && (ix.flags & GELESEN)
			&& (jetzt - ix.zeit)/day > config.kill_read)
				kill = TRUE;
			else
			/* ungelesen und ungetauscht? */
			if (config.kill_unread
			&& !ix.getauscht && !(ix.flags & GELESEN)
			&& (jetzt - ix.zeit)/day > config.kill_unread)
				kill = TRUE;
			if (kill)
			{
				ix.flags |= TOTAL;
				i_back();
				(void) i_write(&ix,sizeof(INDEX));
				i_seek(i_tell());
				kennung.putzen++;
				changed = TRUE;
			}
		}
		if (changed)
		{
			i_rewind();
			i_write(&kennung,sizeof(KENNUNG));
		}
		i_rewind();
	}
#endif

	if ((dat_f = fopen(dat_name,BINREAD)) == NULL)
	{
		i_close(FALSE);
		free(buf);
		group_unlock(name,pm);
		fehler(DAT_OPEN);
		return FALSE;
	}
	pufferung(dat_f,NULL,_IOFBF,16384);

	/* zwei Namen fr temporre Dateien (fr Index und Daten) anfordern */
	/* und temporre Dateien zum Anhngen erffnen */
	strcpy(i_t_name,(pm) ? config.new_us : config.new_gr);
	/* evtl. Partitions- und Pfadname entfernen */
	{
		char *tmp = tmpnam(NULL);
		if (strrchr(tmp,'/'))
			strcat(i_t_name,strrchr(tmp,'/')+1);
		else
		if (strrchr(tmp,'\\'))
			strcat(i_t_name,strrchr(tmp,'\\')+1);
		else
			strcat(i_t_name,tmp);
	}
	ind_tmp = fopen(i_t_name,BINWRITE);
	strcpy(d_t_name,(pm) ? config.new_us : config.new_gr);
	{
		char *tmp = tmpnam(NULL);

		if (strrchr(tmp,'/'))
			strcat(d_t_name,strrchr(tmp,'/')+1);
		else
		if (strrchr(tmp,'\\'))
			strcat(d_t_name,strrchr(tmp,'\\')+1);
		else
			strcat(d_t_name,tmp);
	}
	dat_tmp = fopen(d_t_name,BINWRITE);

	if (!ind_tmp || !dat_tmp)
	{
		if (ind_tmp)
			fclose(ind_tmp);
		if (dat_tmp)
			fclose(dat_tmp);
		fclose(dat_f);
		i_close(FALSE);
		free(buf);
		group_unlock(name,pm);
		fehler(NO_TMP);
		return FALSE;
	}

	/* temporre Dateien puffern */
	if ((size_t)32768L == 0 || pufferung(dat_tmp,NULL,_IOFBF,(size_t)32768L))
		pufferung(dat_tmp,NULL,_IOFBF,16384);
	if ((size_t)32768L == 0 || pufferung(ind_tmp,NULL,_IOFBF,(size_t)32768L))
		if (pufferung(ind_tmp,NULL,_IOFBF,16384))
			pufferung(ind_tmp,NULL,_IOFBF,8192);

	/* an den Anfang der Datendatei fahren */
	rewind(dat_f);

	/* diese Komponente ndert sich ja nicht */
	gref.grp_nr = (pm) ? gnr | 0x8000 : gnr;


	/*
		1. Schritt

		Indexdatei komplett auswerten und Verweispuffer aufbauen
	*/

	/* Anzahl der Indexdatenstze ermitteln */
	msgs = i_anzahl();

	mputs("");
	mprintf("%lu Datenstze\r\n",(ULONG)msgs);

	/* Speicher fr Verweispuffer anfordern */
	verweis = (struct VERWEIS *) calloc(msgs,sizeof(struct VERWEIS));
	if (!verweis)
	{
		fehler(NO_MEMORY);
		ok = FALSE;
		goto abbruch;
	}

	/* Kennung berlesen */
	i_seek(sizeof(KENNUNG));

	mputs("1st Pass");
	/* maximale Msganzahl merken, um berschreitungen entdecken zu knnen */
	max_nr = msgs;
	count = msgs;

	/* und los geht's */
	while (count--)
	{
		/* alten Indexdatensatz einlesen */
		if (!i_read(&ix,sizeof(INDEX)))
		{
			free(verweis);
			fputs("Index lesen fehlerhaft -> Abbruch",stderr);
			ok = FALSE;
			goto abbruch;
		}

		if (ix.pos != next)
			konsistent = FALSE;
		next = ix.pos+ix.len;
		if (next==0)
			konsistent = FALSE;

		/* feststellen, ob dieser gelscht werden soll */
		if (!(ix.flags & GESCHUETZT)
		&& (ix.flags & TOTAL
		|| ix.flags & DEFEKT
		|| (ix.flags & TEIL
			&& ix.oben == LEER
			&& ix.unten == LEER
			&& ix.links == LEER
			&& ix.rechts == LEER)))
		{
			/* der nchste Datensatz bekommt eine um eins geringere Nummer */
			verweis[nr_akt].nummer = LEER;
			verweis[nr_akt].putzen = TRUE;

			/* Verkettung umhngen und entfernen */
			loesche_verkettung(&ix,max_nr);

			/*
				der jetzige, erneuerte Index mu nicht einmal zurckgespeichert
				werden, da der 2.Pass bei gelschten Messages grundstzlich von 
				bereits entfernter Kommentarverkettung ausgehen kann.
				(ber das putzen-Flag im Verweispuffer)
				Damit kann auch loesche_verkettung() etwas vereinfacht werden.
				Die folgenden Zeilen sind daher nur dann notwendig, wenn der 
				2.Pass NICHT durchlaufen wird.
			*/
#if 1
			ix.oben = ix.unten = ix.links = ix.rechts = LEER;
			i_back();
			(void) i_write(&ix,sizeof(INDEX));
			/* Wechsel zwischen Schreiben und Lesen per fseek */
			i_seek(i_tell());
#endif
			geloescht++;
		}
		else
		{
			verweis[nr_akt].nummer = nr_neu;
			verweis[nr_akt].putzen = FALSE;
			nr_neu++;

			if (!(ix.flags & GELESEN))
				ungelesen++;
		}
		nr_akt++;
	}


	/*
		2. Schritt

		Lesen aus der alten und Schreiben der aufgrund des Verweis-
		puffers aktualisierten Indexdatenstze sowie Messages
	*/

	mputs("2nd Pass");

	i_rewind();

	/* Kennung in neue Indexdatei kopieren */
	i_read(&kennung,sizeof(KENNUNG));
	/*
		Kennung aktualisieren:
		- Lschdatum/zeitpunkt
		- Anzahl Gesamtmessages
		- Anzahl neuer Messages
		- Anzahl zu lschender Messages
	*/
	if (kennung.anzahl - geloescht != nr_neu)
	{
		fprintf(stderr,"es sind %lu Msgs. zu lschen\n",(ULONG)(kennung.anzahl - nr_neu));
		fprintf(stderr,"gelscht= %lu Msgs.\n",(ULONG)geloescht);
		fputs("ungleich\n",stderr);
		protokoll("putze_gruppe: Anzahl zu lschender Messages fehlerhaft\n");
		protokoll_schliessen();
		free(verweis);
		ok = FALSE;
		goto abbruch;
	}
	kennung.geputzt = time(NULL);
	kennung.anzahl -= geloescht;
	kennung.neue    = ungelesen;
	kennung.putzen  = 0;
	if (kennung.letzte>msgs)
		kennung.letzte = 0;
	else if (verweis[kennung.letzte].nummer == LEER)
		kennung.letzte = 0;
	else
		kennung.letzte = verweis[kennung.letzte].nummer;
	/*
		Verweise in der Kennung auf Startnummern der Mails der Importe der 
		letzten 10 Tage aktualisieren.
		Da fr gelschte Nachrichten kein Verweis auf die nchste ungelschte
		Nachricht existiert, wird, um nicht immer bei Mail 0 beginnen zu 
		mssen, der letzte Verweis != 0 gemerkt und ggf. eingesetzt
	*/
	nr_akt = 0;
	nr_neu = 0;
	for (nr_akt = 0; nr_akt < 10; nr_akt++)
	{
		MESSAGE pos;
		if (kennung.imp_anf[nr_akt] > msgs)
		{
			/* should not happen, but it does. -- uwe */
			kennung.imp_anf[nr_akt] = 0; /* hack ... */
			continue;
		}

		pos = verweis[kennung.imp_anf[nr_akt]].nummer;
		if (pos != LEER)
		{
			kennung.imp_anf[nr_akt] = pos;
			nr_neu = pos;
		}
		else
			kennung.imp_anf[nr_akt] = nr_neu;
	}
	rewind(ind_tmp);
	fwrite(&kennung,sizeof(KENNUNG),1,ind_tmp);

	count = msgs;
	nr_akt = 0;

	/* alle Indexdatenstze nacheinander einlesen */
	while (count--)
	{
		if (!i_read(&ix,sizeof(INDEX)))
		{
			fputs("Index lesen fehlerhaft -> Abbruch",stderr);
			ok = FALSE;
			break;
		}

		/* Verweise aufgrund des Verweispuffers anpassen */
		if (ix.oben != LEER)
			ix.oben   = verweis[ix.oben].nummer;
		if (ix.unten != LEER)
			ix.unten  = verweis[ix.unten].nummer;
		if (ix.links != LEER)
			ix.links  = verweis[ix.links].nummer;
		if (ix.rechts!= LEER)
			ix.rechts = verweis[ix.rechts].nummer;
		if (ix.letzter != LEER)
			ix.letzter = verweis[ix.letzter].nummer;

		/* Komplett- bzw. Teillschung ohne Verkettungen ? */
		if (verweis[nr_akt].putzen)
		{
			if (konsistent)
			{
				if (ix.flags & XP_REF)
				{
#ifdef REFS_WITH_HEADER
					/* nur Header ein- = berlesen */
					fread(buf,1,ix.t_text,dat_f);
					pos_offset += ix.t_text;
#endif
				}
				else
				{
					/* kleine Datenteile ein- statt berlesen statt fseek, da letzteres flusht */
					fgets(id,sizeof(id),dat_f);
					if (ix.len < 4096)
						fread(buf,1,ix.len - strlen(id),dat_f);
					else
						fseek(dat_f,(long) (ix.len - strlen(id)),SEEK_CUR);
					pos_offset += ix.len;
				}
			}
		}
		/* Teillschung vornehmen ? */
		else if (ix.flags & TEIL)
		{
			/* nur Headerdaten einlesen */
			if (!konsistent)
			{
				fseek(dat_f,(long)ix.pos,SEEK_SET);
				ix.pos = ftell(dat_tmp);
			}
			else
			{
				ix.pos -= pos_offset;
				pos_offset += ix.t_text;
			}
			fread(buf,ix.t_text,1,dat_f);
			strncpy(id,buf,sizeof(id));

			/* nur den Messagetext vor dem ':' bernehmen */
			ix.len = ix.t_text;

			/* Indexdatensatz schreiben */
			fwrite(&ix,sizeof(INDEX),1,ind_tmp);
			/* (teilgelschten) Datensatz schreiben */
			if (!fwrite(buf,ix.t_text,1,dat_tmp))
			{
				ok = FALSE;
				break;
			}
		}
		/* weder Teil- noch Komplettlschung */
		else
		{
			size_t bytes;

			if (konsistent)
				ix.pos -= pos_offset;
			else
			{
				fseek(dat_f,(long)ix.pos,SEEK_SET);
				ix.pos = ftell(dat_tmp);
			}

			/* Indexdatensatz ansonsten unverndert bernehmen */
			fwrite(&ix,sizeof(INDEX),1,ind_tmp);

			/* ebenso kompletten Datenteil, sofern keine XP-Referenz */
#ifdef REFS_WITH_HEADER
			bytes = (ix.flags & XP_REF) ? ix.t_text : ix.len;
#else
			bytes = (ix.flags & XP_REF) ? 0 : ix.len;
#endif
			*id = 0;
			while (bytes)
			{
				size_t block;

				block = (bytes > MSG_SIZE) ? MSG_SIZE : bytes;
				fread(buf,block,1,dat_f);
				if (!*id)
				{
					char *p;
					strncpy(id,buf,sizeof(id));
					id[sizeof(id)-1] = 0;
					if ((p = strpbrk(id,"\r\n")) != NULL)
						*p = 0;
				}
				if (!fwrite(buf,block,1,dat_tmp))
				{
					ok = FALSE;
					break;
				}
				bytes -= block;
			}
		}

		if (konsistent)
		{
			/* ID aus Ref-DB lschen */
			if (verweis[nr_akt].putzen && !(ix.flags & XP_REF))
			{
				msgid_delete(id+1);
			}
			/* nderung nur bei Bedarf merken */
			else
			if (pos_offset)
			{
				/* neue Message-Nr. eintragen */
				gref.msg_nr = verweis[nr_akt].nummer;
				msgid_change(id+1,&gref);
			}
		}

		nr_akt++;

	}	/* while */

	/* Verweispuffer wieder freigeben */
	free(verweis);



abbruch:

	/* Nachbereitung */
	fclose(dat_f);

	/* wenn alles ok, braucht die alte Indexdatei nicht gesichert werden */
	if (ok)
		i_close(FALSE);
	else
		i_close(TRUE);

	/* temporre Dateien schlieen */
	fclose(ind_tmp);
	fclose(dat_tmp);

	free(buf);

	if (ok)
	{
		/* alte Dateien lschen und temporre umbenennen */
		/* try to do it more atomical */
		unlink(ind_name);
		rename(i_t_name,ind_name);

		unlink(dat_name);
		rename(d_t_name,dat_name);
	}
	else
	{
		/*
			da der Indexdateipuffer durch i_close bereits zurckgespeichert
			wurde, sind, wenn die Zugriffe nicht sowieso transparent in der  
			Datei erfolgten, die Verkettungen smtlicher zu lschender Msgs.
			bereits entfernt
		*/
		unlink(i_t_name);
		unlink(d_t_name);
		fehler(NO_PUTZ);
	}

	group_unlock(name,pm);

	if (pm)
		anz_gel_pm += geloescht;
	else
		anz_gel_om += geloescht;

	return ok;

} /* mdb_putze_gruppe */



/*
	Verkettung des aktuellen Datensatzes komplett entfernen bzw. umhngen

	ohne besondere Optimierungen
	ohne Beachtung gruppenbergreifender Kommentare

	->			ix			:	Indexdatensatz der zu lschenden Message
				max_nr	:	maximaler Index (= Anzahl Messages insgesamt)

	<-			FALSE		:	Fehler aufgetreten
				TRUE		:	alles ok

	11.9.92	mit Bereichsberprfung der Indizes
*/
static void loesche_verkettung(INDEX *ix,MESSAGE max_nr)
{
	/*
		das Umhngen/Entfernen der Kommentarverkettung ist noch nicht 
		optimal, da noch zu viele fseek's erfolgen
	*/

	/* handelt es sich um einen Kommentar ? */
	if (ix->oben != LEER && ix->oben > max_nr)
	{
		protokoll("Verweis (oben) fehlerhaft -> entfernt\n");
		ix->oben = LEER;
	}
	if (ix->oben != LEER)
	{
		INDEX kommentiert;
		MESSAGE akt_nr;			/* Nummer des zu lschenden Datensatzes */
		long old_pos;

		/* jetzige Dateiposition merken */
		old_pos = i_tell();

		/* Nummer des zu lschenden Datensatzes ber Dateiposition ermitteln */
		akt_nr = (MESSAGE) ((old_pos - sizeof(KENNUNG)) / sizeof(INDEX));
		/* der Indexdateizeiger steht bereits HINTER dem akt. Indexdatensatz */
		akt_nr--;

		/*
			kommentierte Msg. ermitteln
			da die Anzahl der zu diesem Zeitpunkt bereits entfernten Index-
			strukturen bekannt ist, kann die exakte Position innerhalb der 
			aktualisierten Datei damit berechnet werden
		*/
		i_goto(ix->oben);
		i_read(&kommentiert,sizeof(INDEX));

		/* Anzahl der Kommentare darin verringern */
		kommentiert.kommentare--;
		/* liegen noch weitere Kommentare vor ? */
		if (kommentiert.kommentare)
		{
			/* handelt es sich bei dem zu lschenden Datensatz um
				den ERSTEN Kommentar ? */
			if (kommentiert.unten == akt_nr)
			{
				/* dann wird der nchste eingetragen */
				kommentiert.unten = ix->rechts;
			}
			/* handelt es sich bei dem zu lschenden Datensatz um
				den LETZTEN Kommentar ? */
			if (kommentiert.letzter == akt_nr)
			{
				/* dann wird der vorangehende eingetragen */
				kommentiert.letzter = ix->links;
			}
		}
		else
		{
			/* keine weiteren Kommentare, also Verweis lschen */
			kommentiert.unten = LEER;
		}

		/* Indexdatensatz zurckschreiben */
		i_back();
		(void) i_write(&kommentiert,sizeof(INDEX));

		/* alte Dateiposition wiederanfahren */
		i_seek(old_pos);
	}

	/* gibt es Kommentare zum zu lschenden Datensatz ? */
	if (ix->unten != LEER && ix->unten > max_nr)
	{
		protokoll("Verweis (unten) fehlerhaft -> entfernt\n");
		ix->unten = LEER;
	}
	if (ix->unten != LEER)
	{
		INDEX nachfolger;
		MESSAGE next;
		long old_pos;

		/* jetzige Dateiposition merken */
		old_pos = i_tell();

		/*
			alle Kommentare durchgehen und darin den Verweis auf
			die zu lschende Nachricht entfernen. Smtliche Kommentare 
			stehen natrlich im noch NICHT abgearbeiteten Teil der 
			Indexdatei. Hier gbe es durch ein "Sammeln" der Verweise 
			auch noch gute Optimierungsmglichkeiten.
			Anstatt zum jetzigen Zeitpunkt bereits alle Verweise mit 
			umstndlichen und evtl. weit gestreuten Dateizugriffen 
			anpassen zu mssen, kann die Anpassung dann bei der 
			normalen, sequentiellen Abarbeitung der Indexdatenstze 
			erfolgen
		*/

		/* ersten Kommentar ermitteln */
		next = ix->unten;
		do
		{
			i_goto(next);
			i_read(&nachfolger,sizeof(INDEX));
			nachfolger.oben = LEER;
			i_back();
			(void) i_write(&nachfolger,sizeof(INDEX));

			/* Nachfolger ermitteln */
			next = nachfolger.rechts;
		}
		while (next != LEER);

		/* alte Dateiposition wiederanfahren */
		i_seek(old_pos);
	}

	/* gibt es Vorgnger/Nachfolger auf gleicher Ebene ? */
	if (ix->links != LEER && ix->links > max_nr)
	{
		protokoll("Verweis (links) fehlerhaft -> entfernt\n");
		ix->links = LEER;
	}
	if (ix->links != LEER)
	{
		INDEX prev;
		long old_pos;

		/* jetzige Dateiposition merken */
		old_pos = i_tell();

		/* Index des Vorgngers ermitteln (liegt bereits in der tmp-Datei) */
		i_goto(ix->links);
		i_read(&prev,sizeof(INDEX));

		/* Vorgnger ex., gibt es auch einen Nachfolger? */
		if (ix->rechts != LEER)
		{
			INDEX next;
			long save_pos;

			/* dann wird der Vorgnger auf den Nachfolger verwiesen */
			prev.rechts = ix->rechts;
			/* sowie der Nachfolger auf den Vorgnger */
			save_pos = i_tell();
			i_goto(ix->rechts);
			i_read(&next,sizeof(INDEX));
			next.links = ix->links;
			i_back();
			(void) i_write(&next,sizeof(INDEX));
			i_seek(save_pos);
		}
		else
		{
			/* sonst wird der Nachfolger des Vorgngers gelscht */
			prev.rechts = LEER;
		}

		i_back();
		(void) i_write(&prev,sizeof(INDEX));

		/* alte Dateiposition wiederanfahren */
		i_seek(old_pos);
	}
	else
	if (ix->rechts != LEER && ix->rechts > max_nr)
	{
		protokoll("Verweis (rechts) fehlerhaft -> entfernt\n");
		ix->rechts = LEER;
	}
	else
	if (ix->rechts != LEER)		/* nur ein Nachfolger? */
	{
		INDEX next;
		long old_pos;

		/* jetzige Dateiposition merken */
		old_pos = i_tell();

		/* Indexstruktur des Nachfolgers ermitteln */
		i_goto(ix->rechts);
		i_read(&next,sizeof(INDEX));

		/* Verweis auf Vorgnger des Nachfolgers lschen */
		next.links = LEER;

		i_back();
		(void) i_write(&next,sizeof(INDEX));

		/* alte Dateiposition wiederanfahren */
		i_seek(old_pos);
	}

	/* ### hier fehlt noch die Behandlung gruppenbergreifender Verkettungen */

	protokoll_schliessen();

} /* loesche_verkettung */



#if 0
/*
	Querverkettung

	Die Querverkettung smtlicher Kommentare zur aktuellen Msg. (Shne) 
	wird aktualisiert, wobei zu lschende Msgs. aus der Verkettung heraus-
	genommen und deren Verweis auf den Vater entfernt werden

	WICHTIG: diese Routine verndert ggf. den Inhalt des Vaterdatensatzes,
				schreibt diesen jedoch nicht zurck
				Nach Beendigung der Routine gibt es keine Vernderung der
				aktuellen Dateiposition

	->				vater		:	Zeiger auf Indexdatensatz des Vaters

	ACHTUNG: Routine zur Zeit unbenutzt/berflssig
*/
static void querverkettung(INDEX *vater)
{
	long old_pos;
	INDEX ix;
	MESSAGE nr;				/* Index des aktuellen Kommentars */
	MESSAGE letzter;		/* Index des letzten Kommentars */

	/* alte Position merken */
	old_pos = ftell(ind_f);

	/* sicherheitshalber (noch einmal) berprfen, ob berhaupt ein 
		Kommentar (Sohn) existiert */
	if (vater->unten == LEER)
		return;

	nr = vater->unten;

	/* erster Kommentar ist vorlufig auch letzter */
	letzter = vater->unten;

	/* markieren, da ein neuer erster Sohn eingefgt wird */
	vater->unten = LEER;

	do
	{
		fseek(ind_f,sizeof(KENNUNG) + nr * sizeof(INDEX),SEEK_SET);
		get_index(&ix);

		/* schon mal Nummer des Nachfolgers merken */
		nr = ix.rechts;

		/* aktueller Kommentar ist vorlufig auch letzter */
		letzter = nr;

		/* soll dieser Kommentar spter gelscht werden ? */
		if (ix.flags & TOTAL)
		{
			/* Anzahl der Kommentare des Vaters verringern */
			vater->kommentare--;

			/* gibt es einen Nachfolger ? (Kommentar gleicher Ebene) */
			if (ix.rechts != LEER)
			{
				/* dann ersten Kommentarverweis des Vaters auf diesen setzen */
				/* natrlich nur, wenn dies der erste Kommentar ist */
				if (vater->unten == LEER)
					vater->unten = ix.rechts;
			}

			/* gibt es einen Vorgnger- und Nachfolgekommentar ? */
			if (ix.links != LEER)
			{
				/* dann Vorgnger- auf den Nachfolgekommentar setzen */
				INDEX prev;
				long save_pos;

				save_pos = ftell(ind_f);

				fseek(ind_f,sizeof(KENNUNG) + ix.links * sizeof(INDEX),SEEK_SET);
				get_index(&prev);
				prev.rechts = ix.rechts;
				fback();
				put_index(&prev);

				/* sowie Nachfolge- auf den Vorgngerkommentar setzen */
				fseek(ind_f,sizeof(KENNUNG) + ix.rechts * sizeof(INDEX),SEEK_SET);
				get_index(&prev);
				prev.links = ix.links;
				fback();
				put_index(&prev);

				/* Verweise im zu lschenden Kommentar entfernen */
				ix.links = ix.rechts = LEER;

				fseek(ind_f,save_pos,SEEK_SET);
			}

			/* Verweis auf den Vater entfernen */
			ix.oben = LEER;

			/* aktualisierten Indexdatensatz schreiben */
			fback();
			get_index(&ix);
		}
	}
	while (nr != LEER);

	vater->letzter = letzter;

	/* alte Position restaurieren */
	fseek(ind_f,old_pos,SEEK_SET);

} /* querverkettung */
#endif

