/* grp_tool.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB3 (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
	Offline - MausTausch-FrontEnd

	Gruppen- & Userlisten-Tools mit Ausgaben
	(c) 1992-95 bei Frank Baumgart

	begonnen am  2.04.1992
	Version vom 12.01.1995
*/


#include "portab.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <limits.h>

#include "system.h"
#include "frontend/frontend.h"
#include "mdb_glob.h"
#include "message.h"
#include "io.h"
#include "missing/missing.h"
#include "mdb_conf.h"

#ifdef BOX
extern BOOLEAN userbreak(void);	/* fr mdb_dump_group */
#endif

extern CONFIG config;

extern WORK *msg[];



/*
	Gruppenlisting ausgeben
	Informationen ber smtliche Gruppen ausgeben

	<-			TRUE = ok , FALSE = Fehler aufgetreten
*/
BOOLEAN gruppenlisting(void)
{
	ULONG gesamt=0,overall=0,neue=0,putzen=0;
	ULONG grp_anzahl = 0,usr_anzahl = 0;
	ULONG bytes;

	tprint("cl");
	mputs("Datenbank-Info");
	mputs("");

	mdb_info(&usr_anzahl,&grp_anzahl,&gesamt,&bytes,&overall,&neue,&putzen);

	/* Gesamtergebnis ausgeben */
	mprintf("Gruppen   : %lu\r\n",grp_anzahl);
	mprintf("User      : %lu\r\n",usr_anzahl);
	mputs("");
	mprintf("gesamt    : %lu\r\n",gesamt);
	mprintf("berhaupt : %lu\r\n",overall);
	mprintf("ungelesene: %lu\r\n",neue);
	mprintf("zu putzen : %lu\r\n",putzen);

	taste();

	return TRUE;

} /* gruppenlisting */



/*
	Gruppen/Userinfo ausgeben
	ausfhrliche Informationen ber eine einzelne Gruppe/User

	->			name	:	Name von Gruppe/User
				pm		:	TRUE = User, FALSE = Gruppe

	<-			TRUE = alles ok , FALSE = Fehler ist aufgetreten
*/
BOOLEAN gruppeninfo(const char *name,BOOLEAN pm)
{
	KENNUNG kennung;
	char datime[30];

	if (!name || !*name)
		return FALSE;

	if (!group_info(name,pm,&kennung))
		return TRUE;

#ifdef TEXT_FRONTEND
	tprint("cl");
	if (pm)
		mprintf("Username   : %s\r\n",kennung.name);
	else
		mprintf("Gruppenname: %s\r\n",kennung.name);
#endif
	mputs("");
	mprintf("DB-Version : %u.%02u\r\n",kennung.major,kennung.minor);
	mputs("");
	strftime(datime,30,"%d.%m.%y um %H:%M",localtime(&kennung.created));
	mprintf("angelegt am: %s\r\n",datime);
	strftime(datime,30,"%d.%m.%y um %H:%M",localtime(&kennung.changed));
	mprintf("gendert am: %s\r\n",datime);

	if (kennung.geputzt)
	{
		strftime(datime,30,"%d.%m.%y um %H:%M",localtime(&kennung.geputzt));
		mprintf("geputzt am : %s\r\n",datime);
	}
	else
		mputs("geputzt    : nie");

	mprintf("last access: ");
	if (kennung.latest)
	{
		strftime(datime,30,"%d.%m.%y um %H:%M",localtime(&kennung.latest));
		mprintf("%s\r\n",datime);
	}
	else
		mputs("nie");

	mprintf("last check : ");
	if (kennung.tested)
	{
		strftime(datime,30,"%d.%m.%y um %H:%M",localtime(&kennung.tested));
		mprintf("%s\r\n",datime);
	}
	else
		mputs("nie");

	mputs("");
	mprintf("Msgs.gesamt: %lu\r\n",(ULONG) kennung.anzahl);
	if (kennung.anzahl != kennung.overall)
		mprintf("Msgs.(ewig): %lu\r\n",kennung.overall);
#ifndef BOX
	mprintf("ungelesen  : %lu\r\n",(ULONG) kennung.neue);
#endif
	mprintf("zu putzen  : %lu\r\n",(ULONG) kennung.putzen);
	mputs("");

	mprintf("max. Msgs. : ");
	if (kennung.max_msgs)
		mprintf("%lu\r\n",kennung.max_msgs);
	else
		mputs("Standard");

	mprintf("max. Gre : ");
	if (kennung.max_size)
		mprintf("%lu kB\r\n",kennung.max_size);
	else
		mputs("Standard");

	mprintf("Haltezeit  : ");
	if (kennung.max_time)
		mprintf("%lu Tage\r\n",kennung.max_time);
	else
		mputs("Standard");

/*
	mprintf("Putzgrenze : ");
	if (kennung.min_putz)
		mprintf("%lu\r\n",kennung.min_putz);
	else
		mputs("Standard");
*/

	/*
		Gruppen-spezifische Angaben aus den Infofiles:
		- IGL: lange Gruppenbeschreibung
		- ING: Abnehmer-Boxen
		- ITG: Netzgruppenflags etc.
	*/
	if (!pm)
	{
		char datei[PATH_MAX];
		FILE *info_f;
		char zeile[256];
		char aus[100];
		size_t len = strlen(name);
		char *p;

		strcpy(datei,config.infofiles);
		strcat(datei,"IGL.txt");
		info_f = fopen(datei,"r");

		while (info_f && fgets(zeile,sizeof(zeile),info_f))
		{
			BOOLEAN geheim = FALSE;

			if (strlen(zeile) < 4)
				continue;
			if (zeile[2] == '?')
				geheim = TRUE;
			if (!strnicmp(name,zeile+2 + geheim,len))
			{
				mputs("");
				mputs("Beschreibung:");
				while (fgets(zeile,sizeof(zeile),info_f))
				{
					if ((p = strpbrk(zeile,"\r\n")) != NULL)
						*p = 0;
					if (!*zeile)
						break;
					mputs(zeile+2);
				}
				break;
			}
		}
		if (info_f)
			fclose(info_f);

		strcpy(datei,config.infofiles);
		strcat(datei,"ING.txt");
		info_f = fopen(datei,"r");
		*aus = 0;
		while (info_f && fgets(zeile,sizeof(zeile),info_f))
		{
			if (strlen(zeile) < 4 || (zeile[0] == ' '))
				continue;
			if (!strnicmp(name,zeile+4,len))
			{
				size_t zlen = 0;

				mputs("");
				mputs("Leser in:");
				while (fgets(zeile,sizeof(zeile),info_f))
				{
					if ((p = strpbrk(zeile,"\r\n")) != NULL)
						*p = 0;
					if (*zeile && atoi(zeile))
						break;

					p = strtok(zeile," ");
					while (p)
					{
						if (zlen + 4 >= 80)
						{
							mputs(aus);
							*aus = 0;
							zlen = 0;
						}
						sprintf(aus+zlen,"%3.3s ",p);
						zlen += 4;
						p = strtok(NULL," ");
					}
				}
				mputs(aus);
				break;
			}
		}
		if (info_f)
			fclose(info_f);

		strcpy(datei,config.infofiles);
		strcat(datei,"ITG.txt");
		info_f = fopen(datei,"r");

		while (info_f && fgets(zeile,sizeof(zeile),info_f))
		{
			if (*zeile != 'G')
				continue;
			if ((p = strpbrk(zeile,"\r\n")) != NULL)
				*p = 0;
			if (!stricmp(name,zeile+1))
			{
				mputs("");
				while (fgets(zeile,sizeof(zeile),info_f))
				{
					if (*zeile == 'G')
						break;
					if ((p = strpbrk(zeile,"\r\n")) != NULL)
						*p = 0;

					p = zeile;
					switch (*p++)
					{
						case 'F' :
							mprintf("Flags      : ");
							while (*p)
							{
								switch (*p)
								{
									case 'L' :
										switch (p[1])
										{
											case '+' :
												mprintf("[eingeschaltet]");
												break;
											case 'C' :
												mprintf("[Leserecht ber Gruppenchef]");
												break;
											case 'P' :
												mprintf("[Pflicht]");
												break;
											case 'S' :
												mprintf("[lokal nicht vorhanden]");
												break;
										}
										break;

									case 'S' :
										switch (p[1])
										{
											case 'C' :
												mprintf("[Schreibrecht ber Gruppenchef]");
												break;
											case 'S' :
												mprintf("[lokal nicht vorhanden]");
												break;
										}
										break;

									case 'V' :
										switch (p[1])
										{
											case '+' :
												mprintf("[vernetzt]");
												break;
											case '-' :
												mprintf("[lokal]");
												break;
											case '=' :
												mprintf("[lokal nicht vorhanden]");
												break;
										}
										break;

									case 'G' :
										switch (p[1])
										{
											case '*' :
												mprintf("[Chef]");
												break;
											case '+' :
												mprintf("[Mitglied]");
												break;
										}
										break;

									case 'P' :
										if (p[1] == '+')
											mprintf("[GPT vorhanden]");
										break;

									case '$' :
										if (p[1] == '+')
											mprintf("[nur fr Zahler]");
										break;
								}
								p += 2;
							}
							mputs("");
							break;

						case 'N' :
							mprintf("Netzname   : %s\r\n",p);
							break;

						case 'C' :
							mprintf("Chef       : %s\r\n",p);
							break;

						case 'R' :
							mprintf("FollowUpTo : %s\r\n",p);
							break;

						case 'S' :
							mprintf("Sysop-Info : %s\r\n",p);
							break;

						case 'U' :
							mprintf("User-Info  : %s\r\n",p);
							break;
					}
				}
				break;
			}
		}
		if (info_f)
			fclose(info_f);
	}

#ifdef TEXT_FRONTEND
	if (taste() == 'q')
		return TRUE;

	gruppen_traffic(name,pm);
#endif

	return TRUE;

} /* gruppeninfo */



/*
	monatlichen Traffic einer/aller Gruppe(n)/User ausgeben

	->			name	:	Name von Gruppe bzw. User bzw. NULL/"" fr alle
				pm		:	TRUE = User, FALSE = Gruppe
*/
BOOLEAN gruppen_traffic(const char *name,BOOLEAN pm)
{
	KENNUNG kennung;
	char grp_name[MAX_CPG];
	long traffic[12][2];
	int monat;
	ULONG mails = 0,bytes = 0;

	static const char *monatsname[] =
	{
		"Januar", "Februar", "Mrz", "April", "Mai", "Juni", "Juli",
		"August", "September", "Oktober", "November", "Dezember"
	};

	memset(traffic,0,sizeof(traffic));

	if (name && *name)
	{
		if (!group_info(name,pm,&kennung))
			return FALSE;

		for (monat = 0; monat < 12; monat++)
		{
			traffic[monat][0] = kennung.imp_mon_anz[monat];
			traffic[monat][1] = kennung.imp_mon_byt[monat];
			mails += kennung.imp_mon_anz[monat];
			bytes += kennung.imp_mon_byt[monat];
		}
	}
	else
	{
		/* in mdb_info bernehmen ??? */
		char *tmp;
		FILE *tmp_f;
		long anzahl;
		char *p;

		tmp = tmpnam(NULL);
		if (!mdb_grouplist(tmp,pm,&anzahl) || !anzahl)	/* richtig wre: "om und/oder pm" */
			return FALSE;
		if ((tmp_f = fopen(tmp,"r")) == NULL)
			return FALSE;

		while (fgets(grp_name,sizeof(grp_name),tmp_f))
		{
			if ((p = strpbrk(grp_name,",\r\n")) != NULL)
				*p = 0;
			if (!group_info(grp_name,FALSE,&kennung))
				continue;

			for (monat = 0; monat < 12; monat++)
			{
				traffic[monat][0] += kennung.imp_mon_anz[monat];
				traffic[monat][1] += kennung.imp_mon_byt[monat];
				mails += kennung.imp_mon_anz[monat];
				bytes += kennung.imp_mon_byt[monat];
			}
		}
		fclose(tmp_f);
		unlink(tmp);
	}

#ifdef TEXT_FRONTEND
	tprint("cl");
#endif
	mputs("Monat          Anzahl   Datenmenge");
	mputs("==================================");
	for (monat = 0; monat < 12; monat++)
	{
		mprintf("%-12s %8ld  %8ld kB\r\n",
			monatsname[monat],
			traffic[monat][0],
			(traffic[monat][1] + 500)/1000);
	}
	mputs("==================================");
	mprintf("%-12s %8ld  %8ld kB\r\n","Gesamt:",mails,(bytes + 500)/1000);

#ifdef TEXT_FRONTEND
	taste();
#endif

	return TRUE;

} /* gruppen_traffic */



/*
	Dump der Indexdaten .pos und .len 

	<-			TRUE	:	ok
				FALSE	:	Gruppe ex. nicht/konnte nicht geffnet werden
*/
BOOLEAN gruppen_dump(const char *name,BOOLEAN pm)
{
	WORK *mp;
	MESSAGE nr = 0;				/* aktuelle Messagenummer */
	long next = 0;					/* nchster erwarteter Msg-Anfang */
	int gh;

	if ((gh = group_open(getpid(),name,pm,FALSE)) < 0)
		return FALSE;

	mp = msg[gh];

	while (index_read(gh))
	{
		mprintf("%5ld   %8ld   %8ld   %8ld %s%s%s%s%s\r\n",
			(long) nr+1,mp->ix.pos,mp->ix.len,mp->ix.pos + mp->ix.len-1,
			next != mp->ix.pos ? "*" : "",
			mp->ix.flags & GESCHUETZT ? "G" : "",
			mp->ix.flags & TOTAL ? "L" : "",
			mp->ix.flags & TEIL ? "E" : "",
			mp->ix.flags & DEFEKT ? "D" : ""
			);
		next = mp->ix.pos + mp->ix.len;
#ifdef BOX
		if (userbreak())
			break;
#endif
		if (!index_next(gh))
			break;
		nr++;
	}

	group_close(gh,getpid());

	return TRUE;

} /* gruppen_dump */
