/* system.h : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
	Systemabhngigkeiten

	Stand: 21.06.1994

	Diese Datei darf erst _NACH_ den System-Headerdateien eingebunden werden,
	damit alle System-Makros und Konstanten bereits gesetzt sind.
*/


#ifndef OFF_SYSTEM_H
#define OFF_SYSTEM_H

#include "ofconfig.h"

#if defined(LEAK_CHECK) && !defined(LEAK_CHECK_MACROS_DEFINED)
#define LEAK_CHECK_MACROS_DEFINED
#define GC_DEBUG
#define FIND_LEAK
#include "gc.h"
#define malloc(x) GC_MALLOC(x)
#define realloc(x,y) GC_REALLOC(x,y)
#define calloc(m,n) GC_MALLOC((m)*(n))
#define free(x) GC_FREE(x)
#define strdup(x) XSTRDUP(x)
#ifndef XSTRDUP
#define XSTRDUP(x) libquark_xstrdup(x,__FILE__,__LINE__)
#endif
#endif

#ifndef PATH_MAX
#ifdef _POSIX_PATH_MAX
#define PATH_MAX			_POSIX_PATH_MAX
#else
#define PATH_MAX			256
#endif
#endif


/*
	open-Modi fr binr-streams
*/
#ifdef __UNIX__

#define BINREAD			"r"
#define BINWRITE			"w"
#define BINAPPEND			"a"
#define BIN_RW_OPEN		"r+"
#define BIN_RW_CREATE	"w+"
#define BIN_R_APPEND		"a+"

#else

#define BINREAD			"rb"
#define BINWRITE			"wb"
#define BINAPPEND			"ab"
#define BIN_RW_OPEN		"rb+"
#define BIN_RW_CREATE	"wb+"
#define BIN_R_APPEND		"ab+"

#endif


/* path separator */
#if defined(__DOS__) || defined(__OS2__)
#	define PS					"\\"
#else
#	define PS					"/"
#endif


/* Zeilenende fr Dateien */
#if defined(__UNIX__)
#define CRLF				"\n"
#else
#define CRLF				"\r\n"
#endif


#if defined(__IBMC__)
#	include <conio.h>
#	include <io.h>
#	include <stdio.h>
#	include <fcntl.h>
#	include <sys/stat.h>

#	define lseek				_lseek
#	define write				_write
#	define read					_read
#	define open					_open
#	define close				_close

#	define getch				_getch
#endif

#endif

