/* simplelist.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/
#include <portab.h>
#include <stdlib.h>
#include <string.h>

#include "simplelist.h"

void 
simple_free (simplelist_t * l)
{
	if (l) {
		if (l->data)
			free (l->data);
		if (l->xstring)
			free (l->xstring);
		free (l);
	}
}

simplelist_t *
simple_alloc (const char *data)
{
	simplelist_t *n;
	n = malloc (sizeof (simplelist_t));
	if (!n)
		return NULL;
	if (data) {
		n->data = strdup (data);
		if (!n->data) {
			free (n);
			return NULL;
		}
	} else
		n->data = NULL;
	n->xstring = NULL;
	n->xulong = 0;
	n->next = NULL;
	return n;
}

void 
simple_free_chain (simplelist_t * l)
{
	while (l) {
		simplelist_t *next = l->next;
		simple_free (l);
		l = next;
	}
}
