/* discard_deliver.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
 * discard-deliver: Dieses File implementiert ein besonders effizientes
 * /dev/null.
 */

#include "tomsysdep.h"

#include <portab.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>
#include <ctype.h>
#include <syslog.h>
#include <time.h>

#include "prototyp.h"
#include "user.h"
#include "routing.h"
#include "route_int.h"
#include "msg.h"

#ifndef LINEEND
#define LINEEND "\r\n"
#endif

static BOOLEAN r_t_discard_deliver(message_t *head, r_adr_t *adr);
static BOOLEAN r_t_discard_flush(void);

r_transport_t *r_t_discard;

void 
r_t_discard_define(char *str) 
{
	r_transport_t *n;
	if (stricmp(str,"discard") != 0) {
		syslog(LOG_WARNING,"discard_define called for unknown funktion %s",str);
		return;
	}
    n=XMALLOC(sizeof(r_transport_t));
    strlwr(str);
    n->name=XSTRDUP(str);
    n->deliver=r_t_discard_deliver;
    n->flush=r_t_discard_flush;
    r_t_discard=n;
    r_t_chain_transport(n);
}
										
static BOOLEAN
r_t_discard_deliver(message_t *head, r_adr_t *adr)
{
	if (head->msgtyp==pers_msg || head->msgtyp==status_msg)
	{
		for ( ; adr; adr=adr->next)
		{
			if (adr->transport==&r_t_discard
				&& TRANSPORT_ALLOWED(adr))
			{
				char idbuf[256];
				char *id;

				if (adr->flags & R_F_NEUE_ID)
				{
					make_msg_id(idbuf,TRUE, NULL, NULL);
					id=idbuf;
				}
				else
					id=head->msg_id;

				/* der eigentliche Transport */
				adr->flags |= R_F_ZUGESTELLT;

				/* Eintrge ins Messagelog */
				if (head->msgtyp==pers_msg)
				{
					msglog("  Tdiscard\n");
					msglog("  =%s\n",id);
				}
				else
					/* Status */
					msglog("  =%s (Status)\n",id);

				/*
				 * Tauschlog
				 */
				r_tauschuserlog(adr, ":!discard deliver called\r\n",id);
				r_tauschuserlog(adr, ":=%s\r\n",id);
			}
		}
	}
	else /* Gruppennachricht */
	{
		msglog("  !discard_deliver\n",head->msg_id);
		msglog("  =%s\n",head->msg_id);
		r_tauschuserlog(adr, ":!discard_deliver\r\n",head->msg_id);
		r_tauschuserlog(adr, ":=%s\r\n",head->msg_id);
	}
	return TRUE;
}

static BOOLEAN
r_t_discard_flush(void)
{
	return TRUE;
}
