/* hi emacs, this is -*- C -*-
 * Tausch
 * 
 * Kommandoauswertung.
 * 
 */


#include <portab.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>
#include <syslog.h>
#include <ctype.h>

#include "tomsysdep.h"
#include "prototyp.h"
#include "aktdata.h"
#include "user.h"

#include "tausch.h"
#include "ta_int.h"
#include "ta_ext.h"
#include "ta_cmd.h"
#include "box_conf.h"
#include "tomtcl.h"

BOOLEAN ta_cmd_init_done;

ta_command_t *kommandos = NULL;

void ta_cmd_init(void);

void
ta_cmd_work (char *cmd)
{
	ta_command_t *c;

	strtrim (cmd);

	if (!ta_cmd_init_done)
	{
		ta_cmd_init ();
		ta_cmd_init_done = TRUE;
	}

	c = kommandos;
	while (c && c->magic)
	{
		size_t l = strlen (c->magic);
		size_t l2=0;
		
		 if (c->magic2 && *c->magic2)
		 	l2 = strlen (c->magic2);

		if (!strncmp (cmd, c->magic, l) 
			|| (l2 > 0 && !strncmp(cmd,c->magic2,l2)))
		{
			BOOLEAN ok=TRUE;
			/* Hack!, sollte eigentlich Flag sein, aber naja. */
			if (c != &ta_icmd_desc_info)
			{
				ta_do_log (":\"%s\"\r\n", cmd);
				if (c->minlevel>level())
					ok=FALSE;
			}
			if (ok && !c->fn)  {
				ta_do_log_error ("interner Fehler: Keine Funktion zu Kommando bekannt");
				return;
			}
			if (ok) {
				c->fn (cmd, c->textpara, c->numpara);
				return;
			}
			/* else: Nicht loggen, da mglicherweise Varianten des Kommandos
			 * existieren, die benutzbar sind (U$=? z.B.).
			 */
		}
		c = c->next;
	}
	ta_do_log (":\"%s\"\r\n", cmd);
	ta_do_log_error ("unbekanntes Kommando!");
}

void
ta_cmd_end (void)
{
	ta_icmd_end();
}

BOOLEAN
ta_cmd_get_user (const char *username, USERNR * unr, USER * u, BOOLEAN lock)
{
	if (!ub_find_username (unr, username))
	{
		ta_do_log_error ("unbekannte(r) Benutzer(in)!");
		return FALSE;
	}
	/* Daten des Users lesen, wird fr sptere Prfungen bentigt */
	if (!ub_read_user (*unr, u, lock))
	{
		ta_do_log_error (
				  "Zugriff auf Userdaten nicht mglich (internes Problem)");
		return FALSE;
	}
	if (u->geloescht)
	{
		ta_do_log (":? %s gibt es hier nicht mehr!\r\n", username);
		if (lock)
			ub_write_user (u, TRUE);
		return FALSE;
	}
	return TRUE;
}

BOOLEAN
ta_cmd_get_group (const char *grpname, BRETTNR * bnr, BOOLEAN lock)
{
	*bnr = brettnr (grpname);
	if (!*bnr)
	{
		ta_do_log_error ("unbekannte Gruppe!");
		return FALSE;
	}
	/* Brettdaten lesen, Lock setzen */
	if (!bb_read_brett (*bnr, lock))
	{
		/* Brett konnte nicht gelesen werden */
		ta_do_log_error (
			"konnte Gruppendaten nicht lesen oder keinen Lock setzen!");
		return FALSE;
	}
	return TRUE;
}

void
ta_cmd_init (void)
{
   /* Die Tabelle verketten - erledigt durch m4 */
#line 83 "stdin"
	ta_icmd_desc_info.next=NULL;
#line 204 "stdin"
	ta_gcmd_desc_mitgliederliste.next=&ta_icmd_desc_info;
#line 302 "stdin"
	ta_gcmd_desc_mitglied.next=&ta_gcmd_desc_mitgliederliste;
#line 489 "stdin"
	ta_gcmd_desc_bestellen.next=&ta_gcmd_desc_mitglied;
#line 618 "stdin"
	ta_gcmd_desc_anlegen.next=&ta_gcmd_desc_bestellen;
#line 680 "stdin"
	ta_gcmd_desc_loeschen.next=&ta_gcmd_desc_anlegen;
#line 736 "stdin"
	ta_gcmd_desc_ren.next=&ta_gcmd_desc_loeschen;
#line 836 "stdin"
	ta_gcmd_desc_chef.next=&ta_gcmd_desc_ren;
#line 919 "stdin"
	ta_gcmd_desc_status.next=&ta_gcmd_desc_chef;
#line 1014 "stdin"
	ta_gcmd_desc_rename.next=&ta_gcmd_desc_status;
#line 1113 "stdin"
	ta_gcmd_desc_followup.next=&ta_gcmd_desc_rename;
#line 1223 "stdin"
	ta_gcmd_desc_sprache.next=&ta_gcmd_desc_followup;
#line 1326 "stdin"
	ta_gcmd_desc_herkunft.next=&ta_gcmd_desc_sprache;
#line 1419 "stdin"
	ta_gcmd_desc_beschreibung.next=&ta_gcmd_desc_herkunft;
#line 1605 "stdin"
	ta_gcmd_desc_zugriff.next=&ta_gcmd_desc_beschreibung;
#line 1792 "stdin"
	ta_gcmd_desc_alias.next=&ta_gcmd_desc_zugriff;
#line 1953 "stdin"
	ta_mcmd_desc_maxlen.next=&ta_gcmd_desc_alias;
#line 2004 "stdin"
	ta_mcmd_desc_oeff_crosspostings.next=&ta_mcmd_desc_maxlen;
#line 2034 "stdin"
	ta_mcmd_desc_oe.next=&ta_mcmd_desc_oeff_crosspostings;
#line 2062 "stdin"
	ta_mcmd_desc_on.next=&ta_mcmd_desc_oe;
#line 2095 "stdin"
	ta_mcmd_desc_pn.next=&ta_mcmd_desc_on;
#line 2124 "stdin"
	ta_mcmd_desc_pe.next=&ta_mcmd_desc_pn;
#line 2156 "stdin"
	ta_mcmd_desc_ps.next=&ta_mcmd_desc_pe;
#line 2186 "stdin"
	ta_mcmd_desc_ts .next=&ta_mcmd_desc_ps;
#line 2249 "stdin"
	ta_mcmd_desc_dupe.next=&ta_mcmd_desc_ts ;
#line 2309 "stdin"
	ta_mcmd_desc_tauschdatum.next=&ta_mcmd_desc_dupe;
#line 2383 "stdin"
	ta_mcmd_desc_transferzeit.next=&ta_mcmd_desc_tauschdatum;
#line 2436 "stdin"
	ta_mcmd_desc_tausch_brett.next=&ta_mcmd_desc_transferzeit;
#line 2607 "stdin"
	ta_ucmd_desc_anlegen.next=&ta_mcmd_desc_tausch_brett;
#line 2724 "stdin"
	ta_ucmd_desc_passwort.next=&ta_ucmd_desc_anlegen;
#line 2830 "stdin"
	ta_ucmd_desc_level.next=&ta_ucmd_desc_passwort;
#line 2857 "stdin"
	ta_ucmd_desc_level_abfragen.next=&ta_ucmd_desc_level;
#line 2977 "stdin"
	ta_ucmd_desc_vertreter.next=&ta_ucmd_desc_level_abfragen;
#line 3100 "stdin"
	ta_ucmd_desc_restzeit.next=&ta_ucmd_desc_vertreter;
#line 3192 "stdin"
	ta_ucmd_desc_konto_geben.next=&ta_ucmd_desc_restzeit;
#line 3224 "stdin"
	ta_ucmd_desc_konto_aendern.next=&ta_ucmd_desc_konto_geben;
#line 3251 "stdin"
	ta_ucmd_desc_konto_frage.next=&ta_ucmd_desc_konto_aendern;
#line 3411 "stdin"
	ta_ucmd_desc_zeilenlaenge.next=&ta_ucmd_desc_konto_frage;
#line 3444 "stdin"
	ta_ucmd_desc_bildschirmlaenge.next=&ta_ucmd_desc_zeilenlaenge;
#line 3489 "stdin"
	ta_ucmd_desc_umlaut.next=&ta_ucmd_desc_bildschirmlaenge;
#line 3528 "stdin"
	ta_ucmd_desc_terminaltyp.next=&ta_ucmd_desc_umlaut;
#line 3755 "stdin"
	ta_ucmd_desc_liste.next=&ta_ucmd_desc_terminaltyp;
#line 4002 "stdin"
	ta_ucmd_desc_telefon.next=&ta_ucmd_desc_liste;
#line 4032 "stdin"
	ta_ucmd_desc_plz.next=&ta_ucmd_desc_telefon;
#line 4061 "stdin"
	ta_ucmd_desc_ort.next=&ta_ucmd_desc_plz;
#line 4090 "stdin"
	ta_ucmd_desc_strasse.next=&ta_ucmd_desc_ort;
#line 4121 "stdin"
	ta_ucmd_desc_ansage.next=&ta_ucmd_desc_strasse;
#line 4121 "stdin"
	kommandos=&ta_ucmd_desc_ansage;
ta_cmd_read_tcl();
}
