/* -*- C -*- */
#ifndef TA_CMD_H
#define TA_CMD_H

typedef void (*ta_cmd_fn_t) (char *command, const char *, LONG);

	/* 
	 * Beschreibung eines Kommandos.
	 */
typedef struct ta_command_t
{
	const char          * magic;
	const char          * magic2;
	ta_cmd_fn_t           fn;
	UWORD                 minlevel;
	const char          * textpara;
	long                  numpara;
	unsigned int	    	id;    /* 0 -> *Keine* ITK, sondern Pseudokommando */
	const char          *  kommandogruppe;
	unsigned int    	version;
	const char          * typ;
	const char          * name; 
	const char          * kurzbeschreibung;
	const char          * definition;
	struct ta_command_t * next;
} ta_command_t;

extern ta_command_t *kommandos;
extern BOOLEAN ta_cmd_init_done;
extern void ta_cmd_init(void);
#line 1 "ta_icmd.c4"
/* ta_icmd.c4 : info/jedesmalinfofile-pseudo "Kommandos" -*- C -*- */
/*
    Copyright (C) 1994 1995 1996 1997 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@ohse.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
 * Tausch: Pseudokommandos fr Infofiles.
 */
#line 89 "tauschdefs.m4"
/*   Nr.     Funktion                          Zeile  Datei */
#line 84 "ta_icmd.c4"
/*    0      ta_icmd_info                         84  ta_icmd.c4           */
#line 84
extern ta_command_t ta_icmd_desc_info;
#line 89 "tauschdefs.m4"
/*   Nr.     Funktion                          Zeile  Datei */
#line 107 "ta_gcmd.c4"
/*   26      ta_gcmd_mitgliederliste             107  ta_gcmd.c4           */
#line 107
extern ta_command_t ta_gcmd_desc_mitgliederliste;
#line 205 "ta_gcmd.c4"
/*   25      ta_gcmd_mitglied                    205  ta_gcmd.c4           */
#line 205
extern ta_command_t ta_gcmd_desc_mitglied;
#line 392 "ta_gcmd.c4"
/*   36      ta_gcmd_bestellen                   392  ta_gcmd.c4           */
#line 392
extern ta_command_t ta_gcmd_desc_bestellen;
#line 521 "ta_gcmd.c4"
/*   28      ta_gcmd_anlegen                     521  ta_gcmd.c4           */
#line 521
extern ta_command_t ta_gcmd_desc_anlegen;
#line 583 "ta_gcmd.c4"
/*   30      ta_gcmd_loeschen                    583  ta_gcmd.c4           */
#line 583
extern ta_command_t ta_gcmd_desc_loeschen;
#line 639 "ta_gcmd.c4"
/*    6      ta_gcmd_ren                         639  ta_gcmd.c4           */
#line 639
extern ta_command_t ta_gcmd_desc_ren;
#line 739 "ta_gcmd.c4"
/* 1002      ta_gcmd_chef                        739  ta_gcmd.c4           */
#line 739
extern ta_command_t ta_gcmd_desc_chef;
#line 822 "ta_gcmd.c4"
/*   33      ta_gcmd_status                      822  ta_gcmd.c4           */
#line 822
extern ta_command_t ta_gcmd_desc_status;
#line 917 "ta_gcmd.c4"
/*   32      ta_gcmd_rename                      917  ta_gcmd.c4           */
#line 917
extern ta_command_t ta_gcmd_desc_rename;
#line 1016 "ta_gcmd.c4"
/*   35      ta_gcmd_followup                   1016  ta_gcmd.c4           */
#line 1016
extern ta_command_t ta_gcmd_desc_followup;
#line 1126 "ta_gcmd.c4"
/*   37      ta_gcmd_sprache                    1126  ta_gcmd.c4           */
#line 1126
extern ta_command_t ta_gcmd_desc_sprache;
#line 1229 "ta_gcmd.c4"
/*   38      ta_gcmd_herkunft                   1229  ta_gcmd.c4           */
#line 1229
extern ta_command_t ta_gcmd_desc_herkunft;
#line 1322 "ta_gcmd.c4"
/*   29      ta_gcmd_beschreibung               1322  ta_gcmd.c4           */
#line 1322
extern ta_command_t ta_gcmd_desc_beschreibung;
#line 1508 "ta_gcmd.c4"
/*   34      ta_gcmd_zugriff                    1508  ta_gcmd.c4           */
#line 1508
extern ta_command_t ta_gcmd_desc_zugriff;
#line 1695 "ta_gcmd.c4"
/* 1004      ta_gcmd_alias                      1695  ta_gcmd.c4           */
#line 1695
extern ta_command_t ta_gcmd_desc_alias;
#line 89 "tauschdefs.m4"
/*   Nr.     Funktion                          Zeile  Datei */
#line 96 "ta_mcmd.c4"
/*    8      ta_mcmd_maxlen                       96  ta_mcmd.c4           */
#line 96
extern ta_command_t ta_mcmd_desc_maxlen;
#line 147 "ta_mcmd.c4"
/* 1200      ta_mcmd_simpel                      147  ta_mcmd.c4           */
#line 147
extern ta_command_t ta_mcmd_desc_oeff_crosspostings;
#line 177 "ta_mcmd.c4"
/*    5      ta_mcmd_simpel                      177  ta_mcmd.c4           */
#line 177
extern ta_command_t ta_mcmd_desc_oe;
#line 205 "ta_mcmd.c4"
/*    4      ta_mcmd_simpel                      205  ta_mcmd.c4           */
#line 205
extern ta_command_t ta_mcmd_desc_on;
#line 238 "ta_mcmd.c4"
/*    1      ta_mcmd_simpel                      238  ta_mcmd.c4           */
#line 238
extern ta_command_t ta_mcmd_desc_pn;
#line 267 "ta_mcmd.c4"
/*    2      ta_mcmd_simpel                      267  ta_mcmd.c4           */
#line 267
extern ta_command_t ta_mcmd_desc_pe;
#line 299 "ta_mcmd.c4"
/*    3      ta_mcmd_simpel                      299  ta_mcmd.c4           */
#line 299
extern ta_command_t ta_mcmd_desc_ps;
#line 329 "ta_mcmd.c4"
/*    7      ta_mcmd_simpel                      329  ta_mcmd.c4           */
#line 329
extern ta_command_t ta_mcmd_desc_ts ;
#line 392 "ta_mcmd.c4"
/* 1202      ta_mcmd_dupe                        392  ta_mcmd.c4           */
#line 392
extern ta_command_t ta_mcmd_desc_dupe;
#line 452 "ta_mcmd.c4"
/* 1203      ta_mcmd_tauschdatum                 452  ta_mcmd.c4           */
#line 452
extern ta_command_t ta_mcmd_desc_tauschdatum;
#line 526 "ta_mcmd.c4"
/* 1204      ta_mcmd_transferzeit                526  ta_mcmd.c4           */
#line 526
extern ta_command_t ta_mcmd_desc_transferzeit;
#line 579 "ta_mcmd.c4"
/* 1205      ta_mcmd_tausch_brett                579  ta_mcmd.c4           */
#line 579
extern ta_command_t ta_mcmd_desc_tausch_brett;
#line 89 "tauschdefs.m4"
/*   Nr.     Funktion                          Zeile  Datei */
#line 103 "ta_ucmd.c4"
/* 1105      ta_ucmd_anlegen                     103  ta_ucmd.c4           */
#line 103
extern ta_command_t ta_ucmd_desc_anlegen;
#line 220 "ta_ucmd.c4"
/*   10      ta_ucmd_passwort                    220  ta_ucmd.c4           */
#line 220
extern ta_command_t ta_ucmd_desc_passwort;
#line 326 "ta_ucmd.c4"
/* 1106      ta_ucmd_level                       326  ta_ucmd.c4           */
#line 326
extern ta_command_t ta_ucmd_desc_level;
#line 353 "ta_ucmd.c4"
/* 1107      ta_ucmd_level                       353  ta_ucmd.c4           */
#line 353
extern ta_command_t ta_ucmd_desc_level_abfragen;
#line 473 "ta_ucmd.c4"
/*   14      ta_ucmd_vertreter                   473  ta_ucmd.c4           */
#line 473
extern ta_command_t ta_ucmd_desc_vertreter;
#line 596 "ta_ucmd.c4"
/* 1104      ta_ucmd_restzeit                    596  ta_ucmd.c4           */
#line 596
extern ta_command_t ta_ucmd_desc_restzeit;
#line 688 "ta_ucmd.c4"
/*   19      ta_ucmd_konto                       688  ta_ucmd.c4           */
#line 688
extern ta_command_t ta_ucmd_desc_konto_geben;
#line 720 "ta_ucmd.c4"
/*   20      ta_ucmd_konto                       720  ta_ucmd.c4           */
#line 720
extern ta_command_t ta_ucmd_desc_konto_aendern;
#line 747 "ta_ucmd.c4"
/*   22      ta_ucmd_konto                       747  ta_ucmd.c4           */
#line 747
extern ta_command_t ta_ucmd_desc_konto_frage;
#line 907 "ta_ucmd.c4"
/*   18      ta_ucmd_zahl                        907  ta_ucmd.c4           */
#line 907
extern ta_command_t ta_ucmd_desc_zeilenlaenge;
#line 940 "ta_ucmd.c4"
/*   16      ta_ucmd_zahl                        940  ta_ucmd.c4           */
#line 940
extern ta_command_t ta_ucmd_desc_bildschirmlaenge;
#line 985 "ta_ucmd.c4"
/*   40      ta_ucmd_zahl                        985  ta_ucmd.c4           */
#line 985
extern ta_command_t ta_ucmd_desc_umlaut;
#line 1024 "ta_ucmd.c4"
/*   42      ta_ucmd_zahl                       1024  ta_ucmd.c4           */
#line 1024
extern ta_command_t ta_ucmd_desc_terminaltyp;
#line 1251 "ta_ucmd.c4"
/* 1003      ta_ucmd_liste                      1251  ta_ucmd.c4           */
#line 1251
extern ta_command_t ta_ucmd_desc_liste;
#line 1498 "ta_ucmd.c4"
/* 1103      ta_ucmd_string                     1498  ta_ucmd.c4           */
#line 1498
extern ta_command_t ta_ucmd_desc_telefon;
#line 1528 "ta_ucmd.c4"
/* 1102      ta_ucmd_string                     1528  ta_ucmd.c4           */
#line 1528
extern ta_command_t ta_ucmd_desc_plz;
#line 1557 "ta_ucmd.c4"
/* 1101      ta_ucmd_string                     1557  ta_ucmd.c4           */
#line 1557
extern ta_command_t ta_ucmd_desc_ort;
#line 1586 "ta_ucmd.c4"
/* 1100      ta_ucmd_string                     1586  ta_ucmd.c4           */
#line 1586
extern ta_command_t ta_ucmd_desc_strasse;
#line 1617 "ta_ucmd.c4"
/*   12      ta_ucmd_string                     1617  ta_ucmd.c4           */
#line 1617
extern ta_command_t ta_ucmd_desc_ansage;
#endif
