#line 1 "ta_icmd.c4"
/* ta_icmd.c4 : info/jedesmalinfofile-pseudo "Kommandos" -*- C -*- */
/*
    Copyright (C) 1994 1995 1996 1997 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@ohse.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
 * Tausch: Pseudokommandos fr Infofiles.
 */
#line 32 "ta_icmd.c4"


#include <portab.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>

#include "tomsysdep.h"
#include "prototyp.h"
#include "aktdata.h"

#include "tausch.h"
#include "ta_int.h"
#include "ta_ext.h"
#include "ta_cmd.h"

static void ta_icmd_info (char *cmd, const char *dummy, LONG dummy2);

static FILE *info_f;

void
ta_icmd_end(void)
{
	if (info_f)
		fclose (info_f);
	info_f = NULL;
}

/*
 * in den beiden folgenden Beschreibungen ist absichtlich level 10 
 * eingetragen. Damit wird verhindert, da sie jemals als Kommando
 * in die ITK ausgegeben werden, aber gleichzeitig werden sie als
 * Kommando erkannt (aus #CMD), was fr die Verarbeitung wichtig ist.
 */
#line 84

#line 84
ta_command_t ta_icmd_desc_info = {
#line 84
	/* Magic 1       */ "I",
#line 84
	/* Magic 2       */ "J",
#line 84
	/* Funktionsname */ ta_icmd_info,
#line 84
	/* Min. Level    */ 10,
#line 84
	/* Textpara      */ NULL,
#line 84
	/* Num. Parameter*/ 0,
#line 84

#line 84
	/* ITK-ID-Nummer */ 0,
#line 84
	/* Gruppierung   */ "",
#line 84
	/* ITK-Version   */ 0,
#line 84
	/* ITK-Typ       */ NULL, 
#line 84
	/* ITK-Name      */ NULL, 
#line 84
	/* ITK-Beschrei. */ 
#line 84
	NULL
#line 84
	, 
#line 84

#line 84
	/* ITK-Syntaxdefinition*/
#line 84
	NULL
#line 84
	,
#line 84

#line 84
	/* Verkettungsptr*/ NULL
#line 84
};
#line 84


/*
 * [IJ][A-Z]* : Infofilebestellungen in die Queue schreiben
 * Sie werden erst spter behandelt, damit die Outfilemaximalgre
 * beachtet werden kann und alle Kommandoresultate schon einfliessen.
 */
static void
ta_icmd_info (char *cmd, const char *dummy TOM_ATTRIB_UNUSED, 
	LONG dummy2 TOM_ATTRIB_UNUSED)
{
	if (!info_f)
		info_f = xfopen (tprintf ("%s_later.cmd", tom_tmp_dir), BINAPPEND);
	fprintf (info_f, "%s\n", cmd);
}

