/* ta_info_iti.c : generate ITI */
/*
    Copyright (C) 1994 1995 1996 Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
*/

#include "tomsysdep.h"

#include <portab.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>
#include <syslog.h>
#include <ctype.h>
#include <errno.h>

#include "prototyp.h"
#include "user.h"
#include "brett.h"
#include "mmread.h"
#include "modem.h"
#include "terminal.h"

#include "tausch.h"
#include "ta_int.h"
#include "ta_ext.h"
#include "ta_info.h"

ULONG
ta_info_iti (const char *fname, const char *dummy1, long dummy2)
{
	ULONG crc = 0;
	FILE *f;
	infofile_t *akt;

	/* get rid of warnings */
	(void) dummy1;
	(void) dummy2;

	f = xfopen (fname, BINWRITE);

	akt = ta_get_info_anker();
	while (akt)
	{
		if (level() >= akt->level)
		{
			char c;
			switch(akt->ident)
			{
			case TA_INFO_NETIDENT: c='N'; break;
			case TA_INFO_LOKALIDENT: c='L'; break;
			case TA_INFO_USERIDENT: c='U'; break;
			default: c='U'; break; 
			}
			/* Der User darf das Infofile sehen */
			fprintf (f, ":#%s\r\n", akt->name);
			fprintf (f, "::%s\r\n", akt->text);
			fprintf (f, ":FC%cI%c\r\n", (akt->mit_crc) ? '+' : '-', c);
			crc += line_checksum (akt->name) + line_checksum (akt->text);
		}
		akt = akt->next;
	}
	fclose (f);
	return (ULONG) (crc & 0xffff);
}
