/* tomattribs.h : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#ifndef TOMATTRIBS_H
#define TOMATTRIBS_H

#ifdef __GNUC__

#if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ > 5)
# if !defined(PROFILING) && !defined(DEBUGGING) && defined(HAVE_ATTRIBUTE_SECTION)
#   define TOM_ATTRIB_SECTION(x) __attribute__((section(#x)))
# endif
#endif

/* die beiden folgenden werden nur definiert, wenn die Funktionalitt
 * verfgbar ist. "#define XXX" macht hier keinen Sinn, weil 
 * der entsprechende Code nie ausgefhrt wrde. 
 * Also: Mit Vorsicht benutzen.
 */
#if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ > 4)
#  define TOM_ATTRIB_CONSTRUCTOR  __attribute__((__constructor__))
#  define TOM_ATTRIB_DESTRUCTOR  __attribute__((__destructor__))
#endif

#if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ > 4)
#  define TOM_ATTRIB_CONST  __attribute__((__const__))
#endif
	/* gcc.info sagt, noreturn wre ab 2.5 verfgbar. HPUX-gcc 2.5.8
	 * kann es noch nicht - what's this?
	 */
#if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ > 5)
# define TOM_ATTRIB_NORET  __attribute__((__noreturn__))
#endif
	/* 
	 * checked Formatstring (Argument Nr. "formatnr"). Der erste 
	 * Parameter des Formatstrings ist Argument Nr. "firstargnr".
	 * fr vprintf und co, wo das nicht mglich ist, ist firstargnr
	 * auf 0 zu setzen -> nur Formatstring wird geprft.
	 */
#if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ > 5)
# define TOM_ATTRIB_PRINTF(formatnr,firstargnr)  \
	__attribute__((__format__ (printf,formatnr,firstargnr)))
#endif

#define TOM_ATTRIB_INLINE __inline__

#if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ > 6)
#define TOM_ATTRIB_UNUSED __attribute__((__unused__))
#endif

#endif /* GNU-C */

#ifndef TOM_ATTRIB_CONST
#define TOM_ATTRIB_CONST
#endif
#ifndef TOM_ATTRIB_SECTION
#define TOM_ATTRIB_SECTION(x)
#endif
#ifndef TOM_ATTRIB_CONST
#define TOM_ATTRIB_CONST
#endif
#ifndef TOM_ATTRIB_NORET
#define TOM_ATTRIB_NORET
#endif
#ifndef TOM_ATTRIB_PRINTF
#define TOM_ATTRIB_PRINTF(x,y)
#endif
#ifndef TOM_ATTRIB_INLINE
#define TOM_ATTRIB_INLINE
#endif
#ifndef TOM_ATTRIB_UNUSED
#define TOM_ATTRIB_UNUSED
#endif

#endif
