/* tomtcl.h.in : still no description */
/* careful: tomtcl.h is generated automatically from tomtcl.h.in and
   several .c files.
*/
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#ifdef HAVE_LIBTCL
#ifndef TOM_TCL_H
#define TOM_TCL_H

#ifdef HAVE_TCL_H
#include <tcl.h>
#else
#include <tcl/tcl.h>
#endif

extern Tcl_Interp *ttcl_interp;

#define TTCL_PROTO(x) int x (ClientData dummy, Tcl_Interp *interp, int, char *[])

	/* Ausfhren eines Scriptes */
BOOLEAN ttcl_script(char *, char **result_string);
/* -1: Fehler aufgetreten
 *  0: Funktion lieferte `ok'.
 *  1: Funktion lieferte etwas anderes. 
 * wenn result_string != NULL wird bei Returncodes 0 und 1 *result_string
 * gesetzt (achtung: der Speicherbereich wird bei nchstem TCL-Aufruf 
 * berschrieben).
 */
int ttcl_call_func(const char *filename, const char *func, const char *para,
	char **result_string);

#define TTCL_EXITCHECK() \
do { \
	if (logout_modus) \
	{ \
		Tcl_SetResult(interp,"logoff_modus set",TCL_STATIC); \
		return TCL_ERROR; \
	} \
} while (0)

	/* Hook hat Funktion komplett selbst bernommen */
#define TTCL_HRES_DONE     0
	/* Hook hat bergebenen Parameter modifiziert */
#define TTCL_HRES_MODIFIED  1
	/* Hook hat nichts getan */
#define TTCL_HRES_NOTDONE   2
	/* Bei der Ausfhrung ist ein Fehler aufgetreten */
#define TTCL_HRES_ERROR    3

int ttcl_hook(const char *cmd, const char *para, char **newpara);



#define TTCL_HOOK(cmd,para,newpara,errorcode,donecode) \
	{ int hookres; hookres=ttcl_hook(cmd,para,&newpara); \
		if (hookres==TTCL_HRES_ERROR) { errorcode; } \
		if (hookres==TTCL_HRES_DONE) { donecode; } \
		if (hookres==TTCL_HRES_MODIFIED) {para=newpara; } \
	}
#define TTCL_HOOK_CLEANUP(newpara) if (newpara) free(newpara)

#endif
#endif
