/* Perl Schnittstelle fr TOM -- hi emacs, dies ist -*- C -*- */

#include <EXTERN.h>               /* from the Perl distribution     */
#include <perl.h>                 /* from the Perl distribution     */
#include "tomsysdep.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <syslog.h>
#include <unistd.h>
#include <ctype.h>


#undef do_readline /* perl pollutes namespace */
#include "prototyp.h"
#include "aktdata.h"
#include "befehle.h"
#include "brett.h"
#include "user.h"
#include "io.h"
#include "modem.h"
#include "terminal.h"
#include "tompaths.h"
#include "tomtcl.h"
#include "box_conf.h"
#include "routing.h"

extern int logout_modus;

static BOOLEAN init_done;

PerlInterpreter *tperl_interp;  /***    The Perl interpreter    ***/
static PerlInterpreter *tperl_hook_interp;  /***    The Perl interpreter    ***/
static PerlInterpreter * tperl_init_interpreter(void);

#ifdef __cplusplus
#  define EXTERN_C extern "C"
#else
#  define EXTERN_C extern
#endif

EXTERN_C void boot_DynaLoader _((CV* cv));
EXTERN_C void boot_tom _((CV* cv));

static void boot_tom2(CV *cv)
{
	const char *file = __FILE__;
	/* DynaLoader is a special case */
	newXS("DynaLoader::boot_DynaLoader", boot_DynaLoader, file);
	boot_tom(cv);
	_wrap_perl5_tom_var_init(cv); /* ### Hack. */
}

#if 0
int 
ttcl_perl_hook(const char *fn, const char *para, char **newpara)
{
	static BOOLEAN in_hook=FALSE;
	char *buf;
	char *buf2;
	int errorflag;
	static BOOLEAN hook_init_done=FALSE;
	char datei[PATH_MAX];
	char *fn_lower;

	/* Endlosrekursionen vermeiden ... */
	if (in_hook)
		return TTCL_HRES_NOTDONE;

	fn_lower=entumlauten1(fn);
	XNULLCHECK(fn_lower);
	strlwr(fn_lower);

	sprintf(datei,"%shook_%s.tcl",box_conf.tcl_dir,fn_lower);
	if (!fileexist(datei))
	{
		free(fn_lower);
		return TTCL_HRES_NOTDONE;
	}

	if (!hook_init_done)
	{
		hook_init_done=TRUE;
		ttcl_hook_interp=ttcl_init_interpreter();
		if (!ttcl_hook_interp)
		{
			free(fn_lower);
			syslog(LOG_ERR,"Kann TCL Interpreter nicht anlegen");
			return TTCL_HRES_NOTDONE;
		}
	}
	if (!ttcl_hook_interp)
	{
		free(fn_lower);
		return TTCL_HRES_NOTDONE;
	}

	buf=XMALLOC(PATH_MAX
		+ ( fn ? strlen(fn) : 0) 
		+ ( para ? strlen(para) : 0)
		+ 128);
	buf2=XMALLOC(fn ? strlen(fn) : 1);
	if (fn)
	{
		strcpy(buf2,fn);
		strupr(buf2);
	}
	else
		*buf2=0;
	
	sprintf(buf,"source %s\nreturn [hook_%s {%s} {%s}]\n",
		datei, fn_lower, buf2, para ? para : "");
	free(fn_lower);
	free(buf2);

	in_hook=TRUE;
	errorflag=Tcl_Eval(ttcl_hook_interp, buf);
	in_hook=FALSE;

	free(buf);
	if (errorflag!=TCL_RETURN && errorflag!=TCL_OK)
	{
		char *trace;
		mbprintf("%s: %s\r\n",buf,ttcl_hook_interp->result);
		trace=Tcl_GetVar(ttcl_hook_interp,"errorInfo",TCL_GLOBAL_ONLY);
		if (trace && !logout_modus)
		{
			mbprintf("*** TCL TRACE ***\r\n");
			do {
				char *p=strchr(trace,'\n');
				if (p)
					*p='\0';
				mbprintf("%s\r\n",trace);
				if (p)
					trace=p+1;
				else
					trace=NULL;
			} while (trace!=NULL);
		}
		return TTCL_HRES_ERROR;
	}
	*newpara=NULL;
	if (0==strcmp(ttcl_hook_interp->result,"done"))
		return TTCL_HRES_DONE;
	if (0==strncmp(ttcl_hook_interp->result,"modified",8))
	{
		char *p=strpbrk(ttcl_hook_interp->result,"\t ");
		if (p)
		{
			while (isspace(*p))
				p++;
			*newpara=XSTRDUP(p);
		}
		else
			*newpara=XSTRDUP("");

		return TTCL_HRES_MODIFIED;
	}
	else
		return TTCL_HRES_NOTDONE;
}
#endif

int 
tperl_call_func(const char *filename, const char *func, const char *para,
	char **result_string)
{
	const char *embedding[] = { "", filename,NULL };
	int exitstatus;

	if (!tperl_interp) {
		tperl_interp=tperl_init_interpreter();
	}
	if (!tperl_interp) {
		mbprintf("Kein Perl Interpreter vorhanden!\r\n");
		return FALSE;
	}

	if (!fileexist(filename))
		return -1;

	exitstatus=perl_parse(tperl_interp, boot_tom2, 2, embedding, NULL);
	if (exitstatus) {
		if(SvTRUE(GvSV(errgv)))
			fprintf(stderr, "parse error: %s\n", SvPV(GvSV(errgv),na));
		return -1;
	} else {
#if 0
		const char *args[5]={NULL};
		if (para) {
			args[0]=para;
			args[1]=NULL;
		} else {
			args[0]=NULL;
		}
		perl_call_argv(func, G_DISCARD | G_EVAL, args);
#endif
		dSP;                            /* initialize stack pointer      */
		ENTER;                          /* everything created after here */
		SAVETMPS;                       /* ...is a temporary variable.   */
		PUSHMARK(sp);                   /* remember the stack pointer    */
		XPUSHs(sv_2mortal(newSVpv((para ? para : ""),0))); /* push the base onto the stack  */
		PUTBACK;                      /* make local stack pointer global */
		perl_call_pv(func, G_EVAL|G_SCALAR); /* call the function             */
		SPAGAIN;                        /* refresh stack pointer         */
								   /* pop the return value from stack */
		if (SvTRUE(GvSV(errgv)))     /* check $@ */
		{
			syslog (LOG_ERR,"Perl function %s in %s died: %s",
				func,filename, SvPV(GvSV(errgv), na)) ;
			(void) POPs ;
			exitstatus=-1;
		} else if (result_string) {
			*result_string=XSTRDUP(POPp);
			exitstatus=0;
		} else {
			(void) POPs;
			exitstatus=0;
		}
		PUTBACK;
		FREETMPS;                       /* free that return value        */
		LEAVE;                       /* ...and the XPUSHed "mortal" args.*/
	}
	return exitstatus;
}


BOOLEAN 
ttcl_perl_script(char *name, char **result_string)
{
	const char *embedding[] = { "", name,NULL };
	int exitstatus;
	if (!tperl_interp) {
		tperl_interp=tperl_init_interpreter();
	}
	if (!tperl_interp) {
		mbprintf("Kein Perl Interpreter vorhanden!\r\n");
		return FALSE;
	}
	exitstatus=perl_parse(tperl_interp, boot_tom2, 2, embedding, NULL);
	if (exitstatus) {
		if(SvTRUE(GvSV(errgv)))
			fprintf(stderr, "parse error: %s\n", SvPV(GvSV(errgv),na));
	}
	exitstatus=perl_run(tperl_interp);
#if 0
	if (!result_string && *ttcl_interp->result)
		mbprintf("%s\r\n",ttcl_interp->result);
	if (result_string) 
		*result_string=ttcl_interp->result;
#endif
	return TRUE;
}

static PerlInterpreter *
tperl_init_interpreter(void)
{
	PerlInterpreter *interp;
	interp = perl_alloc();
	if (!interp) {
		syslog(LOG_ERR,"Kann Perl Interpreter nicht anlegen");
		return NULL;
	}
	perl_construct(interp);
	return interp;
}

