/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#include "tomsysdep.h"

#include <portab.h>
#include <stdio.h>
#include <limits.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "tompaths.h"
#include "prototyp.h"
#include "brett.h"
#include "modem.h"
#include "terminal.h"

static BOOLEAN zeige_datei_sub(const char *name, BOOLEAN interpret);
extern int logout_modus;

/*
	Datei anzeigen

	06.12.1992 Frank, neu
*/
BOOLEAN zeige_datei(const char *name)
{
	return zeige_datei_sub(name,FALSE);
} /* zeige_datei */

/*
 * Datei anzeigen, mit Textinterpretation
 * Uwe, 16.2.1995
 */
BOOLEAN zeige_interpret_datei(const char *name)
{
	return zeige_datei_sub(name,TRUE);
} /* zeige_interpret_datei */

/*
 * Datei anzeigen, zentrale Routine.
 * Uwe, 24.9.1995
 */
static BOOLEAN zeige_datei_sub(const char *name, BOOLEAN interpret)
{
	int ret;
	size_t l;

	l=strlen(name);
	if (l>3 && !strcmp(name+l-3,".gz"))
	{
		char *cmd;
		cmd=concat("gunzip <",name,NULL);
		if (!cmd)
			return FALSE;
		ret=call_piped(cmd,interpret);
		free(cmd);
	}
	else
	{
		FILE *f;
		f = fopen(name,BINREAD);

		if (!f)
			return FALSE;

		ret = output_file(f,interpret);
		fclose(f);
	}
	return ret;

} /* zeige_datei_sub */

